About This File

Genesys Agent Scripting 7.2 Help

Copyright © 2004-2011 Genesys Telecommunications Laboratories, Inc. All rights reserved.
as_help_04-2011_v7.2.004.00

The information contained herein is proprietary and confidential and cannot be disclosed or duplicated without the prior written consent of Genesys Telecommunications Laboratories, Inc.

About Genesys

Alcatel-Lucent’s Genesys solutions feature leading software that manages customer interactions over phone, Web, and mobile devices. The Genesys software suite handles customer conversations across multiple channels and resources - self-service, assisted-service, and proactive outreach - fulfilling customer requests and optimizing customer care goals while efficiently using resources. Genesys software directs more than 100 million customer interactions every day for 4,000 companies and government agencies in 80 countries. These companies and agencies leverage their entire organization, from the contact center to the back office, while dynamically engaging their customers. For more information, go to www.genesyslab.com.

Each product has its own documentation for online viewing at the Genesys Technical Support website or on the Documentation Library DVD, which is available from Genesys upon request. For more information, contact your sales representative.

Notice

Although reasonable effort is made to ensure that the information in this document is complete and accurate at the time of release, Genesys Telecommunications Laboratories, Inc., cannot assume responsibility for any existing errors. Changes and/or corrections to the information contained in this document may be incorporated in future versions.

Your Responsibility for Your System’s Security

You are responsible for the security of your system. Product administration to prevent unauthorized use is your responsibility. Your system administrator should read all documents provided with this product to fully understand the features available that reduce your risk of incurring charges for unlicensed use of Genesys products.

Trademarks

Genesys and the Genesys logo are registered trademarks of Genesys Telecommunications Laboratories, Inc., in the USA and/or other countries. All other trademarks and trade names referred to in this document are the property of other companies.

Technical Support from VARs

If you have purchased this software from a value-added reseller (VAR), please contact the VAR for technical support.

Technical Support from Genesys

If you have purchased support directly from Genesys, please contact Genesys Technical Support at the following regional numbers:

North and Latin America | +888-369-5555 or +506-674-6767 | support@genesyslab.com
Europe, Middle East, and Africa | +44-(0)-1276-45-7002 | support@genesyslab.co.uk
Asia Pacific | +61-7-3368-6868 | support@genesyslab.com.au
Malaysia | 1-800-814-472 or +61-7-3368-6868 (International) | support@genesyslab.com.au
India | 000-800-100-7136 or +61-7-3368-6868 (International) | support@genesyslab.com.au
Japan | +81-3-6361-8950 | support@genesyslab.co.jp

Before contacting technical support, please refer to the Genesys Technical Support Guide for complete contact information and procedures.

Ordering Information

For complete information on ordering Genesys products, please see Licensing Genesys Products (for 6.5 and earlier products) or Genesys Licensing Guide (for 7.0 and later products).

Released by

Genesys Telecommunications Laboratories, Inc.
www.genesyslab.com


Overview

Genesys Agent Scripting is a development tool that enables you to create and maintain browser-based web applications called ”r;agent scripts." An agent script guides agents through an effective customer interaction flow and helps them complete a structured business process. Genesys Agent Scripting also assists in constructing the interfaces to other back office systems.

This Help file provides an overview of Genesys Agent Scripting. The intent of this guide is to provide an end user of the Genesys Agent Scripting editor with instructions for each menu option and window in the system. For purposes of explanation, an imaginary Home and Business Security Systems company was created and a set of processes were defined using Genesys Agent Scripting to illustrate the use of the system.

The figure below identifies the key areas of the Graphical User Interface (GUI) for the Genesys Agent Scripting Editor. Click any section of the image for more information about that section.

The Project Tree and Page Tree areas on the left contain a list of projects, process flows, streams, pages, and branching conditions contained within the current project book.

A project consists of one or more process flows. A process flow consists of one or more streams. A stream consists of one or more pages. A page contains fields and actions.

The Genesys Agent Scripting Page Editor in the middle of the window contains the actual script page and the Process Flow and Stream diagrams provide a visual link to following the call flows.

The right side of the window contains two sections. The Field List provides a list of all of the fields defined in the current project book. The Action List contains a list of all of the buttons defined in the current project book.

Each of the menus at the top of the window and their menu options will be explained throughout this guide. Many of the options available from menus are also available through pop-up menus. Simply right mouse click an item to display its pop-up menu.

Process flow diagrams and Stream flow diagrams are available if you have installed Microsoft Visio 2003 Professional.

A Project Book is another name for the Genesys Agent Scripting repository that comprises objects such as projects, process flows, streams, pages, and fields; all of which are explained in this guide.

Objects may be copied between the next highest level in the tree. Select an object and drag it to the next highest level object. A new instance of the object will be generated in the new location. Changes made to the original object apply to the new object and vice versa.

To make changes to the Genesys Agent Scripting page, simply position the cursor at the point desired to make a change. You can add text by simply typing. Actions, fields, and other controls can be added by using the menu options described in this guide.

Genesys Agent Scripting allows many project books to be maintained.

This online reference guide is organized to correspond to the menus in the Genesys Agent Scripting Editor. There is a book in the Table of Contents for each menu in the Genesys Agent Scripting Editor:

  • File

  • Edit

  • Project

  • Process Flow

  • Stream

  • Page (or Page Layout)

  • Format

  • Define

  • Compile

  • Window


Printing This Help File

You can print a single topic (page) or all the topics (pages) within a single book. You cannot, however, print the entire Help file at once.

On the Table of Contents, select a topic or book and then do the following:

  1. Select the Print button.

  2. In the Print Topics dialog box, select either:

    • Print the selected topic

    • Print the selected heading and all subtopics

  3. Select OK.


File

File Menu Overview

Use the File menu to access features related to settings and overall system functions. File is the first pull down menu on the task bar. There are ten options in the file menu:

  • Settings

  • Convert to Collaborate Mode (or Collaborate)

  • Lock Exclusive (only appears when Project Book is in collaborate mode)

  • Unlock Exclusive (only appears when Project Book is in collaborate mode)

  • Open Project Book

  • New Project Book

  • Import

  • Page Layouts

  • User Defined Functions

  • Exit


Settings - File Menu

File

Settings

Use the Settings window to set overall system settings. Each of the options for this window is described below. The system settings will typically be the inputs when the system is set up. No other changes should be necessary.

General Tab

When you select Settings from the File menu, the General settings tab is the active tab.

Image Directory

The Image Directory is the subdirectory where images are stored and accessed under the location where the generated web application is deployed. When you select an image, it is automatically copied to this location.

Style Sheet Directory

A style sheet is an external document that contains a list of properties and rules that tell the browser how to display HTML tags. The Style Sheet Directory is the subdirectory where style sheets are stored and accessed under the location where the generated web application is deployed. When you select a style sheet, it is automatically copied to this location.

Default Page Layout

The Default Page Layout allows you to set a background for pages. The default layout is used when there is no specific page layout selected for a page in the page editor.

Default Process Flow

This field sets the default process flow to run when one is not specified when launching the Agent Scripting generated web application.

Automatically Create Actions for New Interfaces

When checked, this option causes the system to automatically create an action that will execute the corresponding interface that was created. If this option is not checked, you will need to manually create an action to execute the interface.

Advanced Tab

The following controls appear on the Advanced settings tab:

Integrate with Genesys Agent Interaction

This option allows you to have scripts integrate with the Genesys Agent Interaction Layer. It is enabled for those Project Books created with the base toolkit ”Genesys Agent Interaction Toolkit”. If a script is integrated with the Genesys Agent Interaction Layer then the URL must contain the input parameters for the agent’s Place and ID. If a script is launched for a Genesys Interaction then the URL must contain the input parameter for the T-Server Interaction ID. If a script is launched for a Genesys Outbound request then the URL must contain the input parameter for the Outbound Record Handle ID.

When the script is launched it automatically queries the Genesys Agent Interaction Layer for the information associated with the Agent, Interaction and Outbound IDs. The pre-defined fields supplied by the toolkit are then populated with the information. The ID for either the T-Server Interaction or the Outbound Record Handle is also used to identify the script data and the page stack information that are automatically saved in memory. If the script is re-launched with the same T-Server Interaction ID or Outbound Record Handle ID, then the script data previously saved in memory is reloaded on the pages along with the page stack.

Note: With this option set, you can only compile for the JSP environment.

Script Reporting

This dropdown list enables you to choose the type of reporting you want to have:

  • Disabled: No reporting is provided.

  • Enabled: Reporting data will be collected for fields and pages marked for reporting. Data will be stored in a database defined by configuration parameters G_System_DB_Connection_String and G_System_DB_Provider.

  • Genesys Reporting: (available only when the Integrate with Genesys Agent Interaction checkbox is selected). Reporting data will be collected for fields and pages marked for reporting. Data will be attached as Interaction Data on the Genesys Interaction.

Default XML URL

Genesys Agent Scripting comes with several prepackaged XML servers for you to use in the scripts. These servers allow you to, among other things, generate PDF files, send e-mails, and store and retrieve XML documents. This setting lets you choose a configuration field that contains the location of these XML servers.

Save Page Navigation when Saving Session

This option allows you to have the script state information transferred along with collected data. This option is useful if you want to transfer the navigation from one session to another along with collected information.

Use POST Method with Forms

Beginning with release 7.2.0, Agent Scripting uses only the POST method. The checkbox Use POST Method with Forms has been removed.

Previously, you had to specify the POST method to prevent Agent Scripting from using the GET method for submitting forms.

Maximum references to display

When the Visio diagrams are built they show references to other objects outside the default flow. Complex diagrams can take a significant amount of time to draw.

This number is used to tell Genesys Agent Scripting the maximum number of references to display. When you exceed this number, the title of the diagram is changed to show that it has been exceeded.

Collaborate Tab

This tab is only active if you have converted the project book to collaborate mode.

Server Location

This field contains the directory in which the collaboration server code is located.

Server URL

The Server URL is the address of the Genesys Agent Scripting Collaboration server.

Automatically Lock Pages

This setting only becomes active in collaborate mode. Use it to turn off the automatic locking of pages in collaborate mode for a Project Book. You can then view a page without checking it out.


File > Convert to Collaborate Mode (or Collaborate)

Convert to Collaborate Mode (or Collaborate) Overview

Collaborate mode allows you to convert Project Books to multi-user format, check in and check out files, lock and unlock Project Books, and access the Administrate function to manage users and servers (for system administrators only).

The following options are available:

  • Convert to Collaborate Mode

  • Collaborate

If the Project Book you are working with has not been converted to collaborate mode, the File menu option reads Convert to Collaborate.

If the Project Book has been converted to collaboration mode, the File menu option reads Collaborate, and contains a submenu with several additional options.


File > Convert to Collaborate Mode (or Collaborate)

Convert to Collaborate Mode

To gain access to the administrator functions in Genesys Agent Scripting, you must first convert a Project Book to Collaborate mode.

The Convert to Collaborate option opens a wizard for converting a Genesys Agent Scripting Project Book to a multi-user Project Book.

  1. Make a backup copy of the Project Book you wish to convert it to collaborate mode.

Once converted to collaborate mode, a Project Book cannot be restored to single user mode.

  2. Select File > Convert to Collaborate Mode.

  3. In the Convert to Collaborate dialog box, click Next to continue.

  4. If the Server Language, Server Location, and Server URL are known, then enter the information in their respective fields.

The Server Language field specifies whether you will be using ASP or JSP collaboration mode.

The Server Location field should contain the directory in which the Genesys Agent Scripting Collaboration Server resides.

The Server URL field is the location of the Genesys Agent Scripting Collaboration Server.

  5. If a server does not exist, click Find Server.

This will bring up the standard windows dialog box. Select the directory in which the server should reside.

For IIS, it is recommended that the server directory be a subdirectory under C:\Inetpub\wwwroot. For JSP web servers, the folder should be a subdirectory of that web server.

In order to use the JSP version of the collaboration server, there are a few additional steps that need to occur.

  6. This version requires a mySQL database to be created.

  7. Then, the file SQL_WWC_NEW-6-0-0.sql in C:\Program Files\GCTI\Genesys Agent Scripting\Collaborate jsp Web Folder\ must be run against the database created in Step 1.

  8. Once the server directory has been set up, the file WWCConfig.inc.jsp in the server directory must be modified to contain the proper database connection information to connect to the database created in Step 1.

An example of the database connection information:

<%

String config_jdbc_class = "com.mysql.jdbc.Driver";

String config_jdbc_connect_str =

"jdbc:mysql://localhost:3306/wwc?user=root";

%>

If a new server is being created, Genesys Agent Scripting will generate a UserID and Password.

  9. To continue, the user must be able to connect to the administrative server. Click Test to communicate with the server.

If unsuccessful, the message Unable to connect to server will appear. Click OK, check the Server Location and Server URL, make sure that the file com.mysql.jdbc.Driver appears in the <TOMCAT>\shared\lib directory, and click Test again.

Note: If com.mysql.jdbc.Driver is not present, you must install this driver and then restart Tomcat before proceeding.

If successful, the Next button will be enabled.

  10. Click Next to continue.

The UserID is a Genesys Agent Scripting UserID. It is assigned through the Genesys Agent Scripting Administration Module.

The Password is a Genesys Agent Scripting Password. It is assigned through the Genesys Agent Scripting Administration Module.

  11. To continue, the user must have a valid UserID and Password. Once the values have been input, click Login to connect to the server.

If the login attempt is unsuccessful, the message Unsuccessful Login will appear. Click OK, check the UserID and Password, and click Login again.

If successful, click Next to continue at the next dialog box. This dialog box is used to create the initial starting point for the multi-user Project Book.

  12. Click Check In to create the multi-user Project Book.

  13. Click Finish to return to Genesys Agent Scripting. The Project Book now supports multiple users.

Once the Project Book has been converted to multi-user, the Convert to Collaborate Mode menu option will disappear from the File menu.


File > Convert to Collaborate Mode (or Collaborate) > Collaborate

Collaborate Menu Overview

The Collaborate menu is only enabled in a multi-user (collaborate) Project Book. These options allow you to manage a Project Book in concert with other users. Options under this menu are:

  • Check In

  • Check Out

  • Apply Updates

  • Build Project Book

  • Scan For Errors

  • Administrate


File > Convert to Collaborate Mode (or Collaborate) > Collaborate

Check In

The Check In option checks in changes that have been made to objects, updating the admin database and making the objects available for other users to modify. When you select this option, a Check In dialog box will be displayed.

Object List

This list will display all objects in the Project Book that are currently checked out. You can see the name of each object that has been checked out, along with its description and the date it was checked out. To mark an object for check in, check the box to the left of the object in the list.

Comment

Prior to checking in changes to the admin database, you must provide a comment describing the changes that have been made.

Select All

This button selects all of the items that are not checked in.

Clear All

This button clears all items that are currently selected for check in.

Check In

Use this option to check in changes to the admin database. Clicking Check In will check in the selected objects in the window. Once checked in, other users will be able to view the changes.


File > Convert to Collaborate Mode (or Collaborate) > Collaborate

Check Out

The Check Out option allows you to lock script objects so they can be safely updated without affecting other users. When you select this option, a Check Out dialog box will be displayed.

Show Objects of Type

Use this drop-down list to filter the object list to only show objects of a certain type. Valid types are: Projects, Process Flows, Streams, Pages, Fields, Actions, XML Interfaces, Functions, and API Interfaces.

Object List

This list will display all objects in the Project Book that are currently not checked out and their descriptions. To select an object to be checked out, click the check box.

Note: Objects are automatically checked out when you edit them from any Genesys Agent Scripting dialog.

Progress

This bar show the progress made as each object is checked out.

Select All

This button selects all of the items that are not checked out.

Clear All

This button clears all items that are currently selected for check out.

Check Out

Use this option to check out objects from the admin database. Clicking Check Out will check out each object that has a check mark next to it. Until each object is checked in, other users will not be able to modify or delete it.

Close

This button will close the window without performing any actions.


File > Convert to Collaborate Mode (or Collaborate) > Collaborate

Apply Updates

Apply updates will take all changes checked in by other users and apply them to the local copy of the Project Book.

Note: Prior to checking out an object, Genesys Agent Scripting will first automatically apply updates to the local copy.


File > Convert to Collaborate Mode (or Collaborate) > Collaborate

Build Project Book

Use the Build Project Book option to build a new copy of a Genesys Agent Scripting Project Book. New copies should be built for each user that wishes to edit the Genesys Agent Scripting Project Book.

At the end of a build, the user who selected the Build Project Book option is automatically placed in the new Project Book.

Note: To continue editing, you should open the original Project Book. It is suggested that an administrative user be assigned who is not a script editor. This administrative user would be responsible for maintaining users and building Project Books.


File > Convert to Collaborate Mode (or Collaborate) > Collaborate

Scan for Errors

Genesys Agent Scripting Project Books can run in two modes: optimistic and pessimistic.

In pessimistic mode, the Project Book assumes that users are going to do things that conflict with each other, so the Project Book prevents this from happening. For example, this mode will prevent a user from adding a new reference to an object that a different user is currently attempting to delete.

In optimistic mode, it is assumed that these situations are very rare and not worth the cycle time.

Scan for Errors scans the Project Book for any errors that may occur when the Project Book is running in optimistic mode.

Scan

This button causes the system to scan the Project Book for errors. If any errors are found, they are listed in the table shown above. If the system does not find any errors, a No Errors Found dialog box will appear.


File > Convert to Collaborate Mode (or Collaborate) > Collaborate > Administrate

Administrate Overview

The Administrate option launches the Genesys Agent Scripting Administration module. This module has four main sections.

  • Login Screen

  • Main Menu

  • Update Users

  • Update Servers


File > Convert to Collaborate Mode (or Collaborate) > Collaborate > Administrate

Login Screen

Login is the first window that appears. Enter a UserID and Password to login.

UserID

This is a 1-100 character string created in the setup or by an administrative user. To log into the system, you must be assigned administrative access (the user created in the setup process is automatically assigned administrative access).

Password

This a 1-1000 character string assigned to the UserID. The field is a password field so any text you type will be hidden.

Login

Clicking the Login button will log you into the application if your UserID and Password are correct. If the UserID and/or Password are not valid, an Invalid UserID or Password message will appear.

Clicking OK will bring you back to the login window. If you enter the correct information, you are logged into the system and see the main menu display.


File > Convert to Collaborate Mode (or Collaborate) > Collaborate > Administrate

Main Menu

Currently the Genesys Agent Scripting Collaboration Administration application has two main functions

  • User maintenance

  • Server maintenance

Both functions are only applicable to collaboration Project Books within Genesys Agent Scripting.

To navigate between the two menu items, click the radio button to the left of the choice.


File > Convert to Collaborate Mode (or Collaborate) > Collaborate > Administrate

Update Users

The user maintenance section of the application allows you to add new users and modify and deactivate existing ones.

Clicking the Update Users link in the catalog opens the Update Users window.

Insert User

The Insert User button allows an administrative user to add new users to the admin database. Clicking the Insert User button opens the Insert User window to appear.

UserID

This is the UserID that will be used to log into Genesys Agent Scripting in collaboration mode or into the Genesys Agent Scripting Collaboration Administration application. The field can be between 1-100 characters and must be unique.

First Name

This is the first name of the user. The field can be between 1-100 characters.

Last Name

This is the last name of the user. The field can be between 1-100 characters.

Password

This is the password that will be used to log into Genesys Agent Scripting in collaboration mode or into the Genesys Agent Scripting Collaboration Administration application. The field can be between 1-100 characters. It is a password field so any text you enter will be hidden.

Admin User

When this box is checked, it gives the UserID access to the Genesys Agent Scripting Collaboration Administration application. If it is not checked, the UserID can only be used to log into a collaboration version of Genesys Agent Scripting.

Insert User

The Insert User button will add a new user to the Genesys Agent Scripting Administration database.

Cancel

Clicking cancel will bring the administrative user back to the User Maintenance window.

User Table

The User Table field displays a list of all user accounts. The radio button next to each user allows an administrator to select a specific user account for updating, deleting, or activating.

The following fields are read only.

UserID

This field displays the UserID for the account.

First Name

This field displays the First Name for the account.

Last Name

This field displays the Last Name for the account.

Admin User

This field tells the administrator if the account is an administrator account. If the box is checked, you can access the Genesys Agent Scripting Collaboration Administration application as well as multi-user databases within Genesys Agent Scripting. If the box is not checked, you can only log into Genesys Agent Scripting.

Active?

This field tells the administrator if the user account is currently active or inactive. If an account is inactive, that user may not log in to the system.

Show All Users

Clicking the Show All Users button displays any deactivated accounts in the User Table.

Update User

Use the fields below to update existing user accounts. When an administrator selects a user account from the User Table, the following fields are populated with information from that account.

UserID

This is the UserID that will be used to log into Genesys Agent Scripting in collaboration mode or into the Genesys Agent Scripting Collaboration Administration application. The field can be between 1-100 characters and must be unique.

First Name

This is the first name of the user whose ID is being created. The field can be between 1-100 characters.

Last Name

This is the last name of the user whose ID is being created. The field can be between 1-100 characters.

Password

This is the password that will be used to log into Genesys Agent Scripting in collaboration mode or into the Genesys Agent Scripting Collaboration Administration application. The field can be between 1-100 characters. It is a password field so any text you enter will be hidden.

Admin User

The field allows the administrator to grant access to the Genesys Agent Scripting Collaboration Administration application. If it is checked for a particular user account, the user is also an administrator. If not, the user cannot log in to the admin application.

Active User

This field is read only. It indicates if the account can currently be used to access the system.

Update User

After the administrator has finished making changes to the user account, the Update User button will save the changes to the database. If a user account has not been selected and the administrator clicks Update User, a Please Select a User message will appear.

Clicking OK will bring the administrator back to the User Maintenance window.

Delete User

Deleting (deactivating) a selected user does not remove that user account from the admin database. It just prevents the user from using the account to gain access to Genesys Agent Scripting or the Genesys Agent Scripting Collaboration Administration application. Clicking Delete User without selecting a user account from the User Table will cause a message to appear.

Activate User

Activating a selected user account allows the user to use that account to log into the system once more. Clicking Activate User without selecting a user account from the User Table will cause a message to appear.


File > Convert to Collaborate Mode (or Collaborate) > Collaborate > Administrate

Update Servers

Administrative users can currently change the lock mode and unlock databases from this section of the Genesys Agent Scripting Collaboration Administration application.

Clicking the Update Servers link in the catalog opens the Update Servers window.

Server Table

The server table contains a list of project books that have been converted to collaboration mode.

Database Name

Displays the name of a Genesys Agent Scripting Collaboration project book.

Locked Mode

The database can be locked in one of two ways:

  • Pessimistic Mode

In this mode, the database assumes that users are going to do things that conflict with each other, so the database prevents this from happening. For example, this mode will prevent a user from adding a new reference to an object that a different user is currently attempting to delete.

  • Optimistic Mode

In optimistic mode, it is assumed that these situations are very rare and not worth the cycle time.

Locked?

This specifies whether the database currently has a database-wide lock placed on it.

Locked Exclusive?

This specifies whether the database has been locked for a user’s exclusive use. In this mode, individual records will not need to be checked out in order to make changes. However, all changes will need to be checked in prior to releasing the exclusive lock.

User Name

Displays the name of the user who currently has a lock on the database.

Change Lock Mode

The Change Lock Mode button allows you to change the lock mode of the currently selected database. In order to change the lock mode, all items must be checked in and the database must not be locked.

Unlock Database

The Unlock Database button will clear a database-wide lock on the currently selected database as long as it is not an exclusive lock. Exclusive lock maintenance is handled from within the Genesys Agent Scripting client application.

Why Unlock a Database?

When Genesys Agent Scripting is in the process of checking in or checking out Genesys Agent Scripting components, it places a database lock on the entire database so that no one else makes changes to the central database during its operation. Under normal conditions, this database lock is acquired and released automatically. However, if a user’s machine crashes or the network goes down during the course of a check in or check out, this global database lock might not be released. The administrative application provides a facility where this database lock can be manually cleared.

You should only clear a database lock manually if it is clear that the last check in or check out failed and is no longer processing.

Note: here only database-level locks are displayed. Finer granular locks, such as locks on individual scripts, pages, fields, and so on, are administrated through the Genesys Agent Scripting client application.


File

Lock Exclusive

Lock Exclusive only appears in the menu in multi-user (collaborate) mode. This feature will allow you to lock the Project Book for your exclusive use. In this mode, individual records will not need to be checked out in order to make changes. However, all changes will need to be checked in prior to releasing the exclusive lock. If a Project Book is locked exclusively, another user may not modify any objects in the Project Book until the exclusive lock is released.


File

Unlock Exclusive

If a Project Book is exclusively locked, the Unlock Exclusive option replaces the lock exclusive menu option. This releases the exclusive lock that the user has on the Project Book. Before releasing the lock, all objects must be checked in through the Collaborate menu.


File

Open Project Book

The Open Project Book option presents you with a standard windows dialog to open an existing Genesys Agent Scripting Project Book. It includes the following features:

Open

Click Open to open a selected Project Book.

Browse

Click to browse for a pre-existing Project Book.

New

Click to create a new Project Book.

Collaborate

Click to create a local copy of a Project Book that has already been converted to collaborate mode.

Auto-open on startup

Select a Project Book, then select this box if you want the selected Project Book to open automatically upon startup of the Genesys Agent Scripting application.

Properties

Select a Project Book, then select the Properties button to open the properties for the selected Project Book.

History

Select a Project Book, then select the History button to display the history of a project.

Branch

Select a Project Book, then select the Branch button to display the branches related to the project.

Remove

Select a Project Book, then select the Remove button to remove the selected Project Book.

Cancel

Cancel closes the Open Project Book window without opening the selected Project Book.


File

New Project Book

The New Project Book option presents you with a standard windows dialog box to set up a new project book.

Save in

This drop-down list provides you with the directory path in which the Genesys Agent Scripting Project Book will be created.

File name

This is the name you give to the Genesys Agent Scripting Project Book to be created.

Save as type

This field cannot be changed. All Genesys Agent Scripting Project Books are of the type Genesys Agent Scripting Database.

Save

Click Save to create the new Genesys Agent Scripting Project Book.

Cancel

Cancel closes the new Genesys Agent Scripting Project Book window without creating a new project book.

Project Book Properties

After you click Save in the previous screen, the project book properties for the new Project Book will appear.

File Name

The name of the Project Book file.

Path

The full path of the Project Book.

Project Book

The name of the Project Book. It is user defined and does not have to be unique.

Base Toolkit

The name of the toolkit that the Project Book is initialized with. The following lists the values you can choose:

  • None &endash; Project Book is not initialized with any toolkits.

  • Agent Scripting Toolkit &endash; Project Book is initialized with the functions to create scripts with reporting features and to suspend and resume scripts.

  • Genesys Agent Interaction Toolkit &endash; Project Book is initialized with the same functions as the Agent Scripting Toolkit along with the additional Telephony functions. It also provides access to Genesys Agent Interaction Layer data and operations.

Description

The description allows you to include a brief explanation of the Project Book.

Version

This is a user defined numbering scheme that lets the you track the project book versions.

OK

Click OK to open the Project Book Setup Wizard.

Cancel

Click Cancel to cancel the creation of the new Project Book.

You can either go through all the steps listed in the New Project Check List or click Just do it! which will create everything in the checklist.

If you decide to go through the steps manually, select the first step then click Create to create a project.

This opens the Project Properties dialog box, which is described under Define Project.


File

Import

The Import option presents you with the option to import objects from other Genesys Agent Scripting Project Books into the Project Book currently in use. The Import from Project Book dialog box appears when you select this menu option.

Select Project Book

The Select Project Book button opens the Select Genesys Agent Scripting Project Book dialog box which allows you to choose the Genesys Agent Scripting Project Book from which you wish to import.

Look in

This drop-down list provides you with the directory path in which the Genesys Agent Scripting Project Book from which objects will be imported exists.

File name

This is the name of the Genesys Agent Scripting Project Book from which the objects will be imported.

File of Type

This field cannot be changed. All Genesys Agent Scripting Project Books are of the type Genesys Agent Scripting Project Book (.mdb).

Open

Click Open to open the selected Project Book and close the dialog box.

Cancel

Cancel closes the dialog box without opening the selected Project Book.

Include Duplicates

If this box is checked, the Object Table will display all objects in the selected Project Book whether or not they are already included in the currently open Project Book. If it is not checked, only objects that aren’t in the currently open Project Book will appear.

Object Table

This table contains a list of objects that you may select to be imported. Check the box next to each object to select it.

When an object is selected all child objects that are required by the parent object will also be selected. For example, if a Stream is selected then all Pages included by that Stream will be selected automatically. A child object can be unselected if there are no parent objects selected.

Progress

Once the Import button is clicked, this bar shows the progress of the import process.

Select All

Clicking Select All will select all of the objects in the Object Table by placing a check in the check box next to each object.

Clear All

This button will clear any objects in the Object Table that have been selected.

Import

Clicking Import will cause the selected objects to be imported into the currently open Genesys Agent Scripting Project Book.

Close

The Close button closes the Import dialog box.


Page Layout

File

Page Layouts

Use the Page Layouts option to create new or display existing page layouts.

To display existing page layouts, select the layout to be viewed from the list. The page layout will be displayed in the Genesys Agent Scripting editor.

To create a new page layout, select File > Page Layouts > Insert New Page Layout. The Page Layout Properties dialog box will appear.

To use the default page layout, select File > Page Layouts > Default


File

User Defined Functions

You can add custom functions to a new file WWGUDFunctions.xxx (where xxx specifies the target language). Then you must add the function to Genesys Agent Scripting.

Select File > User Defined Functions to open the User Defined Function List dialog box.

Add

Clicking Add opens the User Defined Function Properties dialog box.

Name

Enter the name of the User Defined Function here.

Description

This field contains a description of the function.

Return Type

This field describes the format of the data returned by the function. The user may select String, Number, Boolean, or DateTime.

Template

The template is generated based on the name and parameters assigned to the function.

Parameters

Parameters refer to the information passed into the function. In order to create the parameters, you must click the parameters button. This opens the User Defined Function Parameter List dialog box.

Add

Clicking Add opens the Parameter dialog box.

Parameter Order

This number indicates the order in which the parameters will be passed to the function.

Parameter Name

This is the name of the parameter being passed to the function.

Description

This field contains a description of the parameter.

Type

This field describes the format of the data passed to the function. You may select String, Number, Boolean, or DateTime.

Edit

In order to edit existing parameters, you should select the parameter to be edited from the list and click Edit. This will open the Parameter Properties dialog box.

Delete

This option allows you to delete existing parameters.

Delete All

Clicking Delete All will delete all of the parameters that have been defined for the specified User Defined Function.

Edit

In order to edit existing user defined functions, you should select the function to be edited from the list and click Edit. This opens the User Defined Function Properties dialog box.

Copy

This option allows you to make a copy of a parameter. Click Copy and the following dialog box opens.

Delete

This option allows you to delete a user defined function.


File

Exit

Use this option to exit Genesys Agent Scripting.


EDIT

Edit Menu Overview

The Edit menu is used to perform common edit functions on pages. There are nine options in the Edit menu:

  • Undo (Ctrl+Z)

  • Cut (Ctrl+X)

  • Copy (Ctrl+C)

  • Paste (Ctrl+V)

  • Select All (Ctrl+A)

  • Find (F3)

  • Find Next (Ctrl+F3)

  • Replace (Ctrl+H)

  • Reload Page


Undo (Ctrl-Z)

EDIT

Undo (Ctrl+Z)

Use the Undo option to undo the last change made to the script page. You can also select Ctrl+Z to undo the last change. Make multiple changes by repeatedly selecting this option.


Cut (Ctrl-X)

EDIT

Cut (Ctrl+X)

Use the Cut option to remove the selected text or object in the current script page and place it into the clipboard. Ctrl+X will also remove the selected text or object.


Copy (Ctrl-C)

EDIT

Copy (Ctrl+C)

Use the Copy option to copy the selected text or object in the current script page to the clipboard. You can also select Ctrl+C to copy the selected text or object.


Paste (Ctrl-V)

EDIT

Paste (Ctrl+V)

Use the Paste option to paste the contents of the clipboard into the current script page. Ctrl+V will also perform the paste function.


EDIT

Select All (Ctrl+A)

Use the Select All option to select all the contents of the current script page. Ctrl+A will also perform the Select All function.


EDIT

Find (F3)

The Find option allows the user to locate specific text strings within each page. When you select this option the Find dialog box opens. Selecting F3 will also open the Find dialog box.

Each of the fields and buttons on this dialog box are described below.

Find What

Enter the text string to be found in this field.

Search

This option allows you to select the scope of the search.

Find Whole Word Only

This option limits the search to a whole word, and not part of a word.

Match Case

This option makes the search case sensitive.

Find Next

This button is used to activate the find option. Genesys Agent Scripting will start to search from the current cursor position to the end of the current page. If the text string is not found, Genesys Agent Scripting will proceed to the next page in the script tree. If the text string cannot be found on any page in the Script View, a message will be displayed and the search will terminate. If the search string is located, the text will be highlighted and the search window will close. To find the next occurrence of the text string use the Find Next option.

Cancel

Use this button to close the search window without searching.


Find Next (Ctrl-F3)

EDIT

Find Next (Ctrl+F3)

Once a string has been found, the Find Next menu option appears in the menu. Selecting it causes Genesys Agent Scripting to find the next occurrence of the text string. Selecting Ctrl+F3 also finds the next occurrence of the string.


Replace (Ctrl-H)

EDIT

Replace (Ctrl+H)

Replace allows you to search for a text string and replace it with other text. When you select this option, the Replace dialog box opens. You can also select Ctrl+H to replace text.

Each of the fields and buttons on this dialog box are described below.

Find What

Enter the text string to be found in this field.

Replace With

Enter the text string to take the place of the string in the Find What field.

Search

This option allows you to select the scope of the search.

Find Whole Word Only

This option limits the search to a whole word, and not part of a word.

Match Case

This option causes the search to be case sensitive.

Find Next

This button is used to activate the find option. Genesys Agent Scripting will start to search from the current cursor position to the end of the current page. If the text string is not found, Genesys Agent Scripting will proceed to the next page in the script tree. If the text string cannot be found on any page in the Script View, a message will be displayed and the search will terminate. If the search string is located, the text will be highlighted and the search window will close. To find the next occurrence of the text string use the Find Next option.

Cancel

Use this button to close the search window without searching.

Replace

The Replace button will cause the selected text found in the page to be replaced by the text in the Replace With field.

Replace All

The Replace All button will cause all instances of the selected text found in all pages in the project to be replaced by the text in the Replace With field.


EDIT

Reload Page

If you select the Reload Page option from the menu, it will undo all changes made to the page since the page was loaded.


Project

Project Menu Overview

Projects are a collection of flows, which appear as top level objects in the Project Tree. The Project menu is used to create and update projects. It can be accessed from the menu bar or by right-clicking a project in the Project Tree. There are four options in the Project menu:

  • Define Project

  • Edit Project

  • Save As

  • Insert Process Flow


Project

Define Project

The Define Project menu option is the first item in the Project menu. This item allows you to create new projects, edit existing projects, create copies of projects, and delete projects. Selecting the Define Project menu option opens the Project List dialog box.

Add

You may add new projects to a project book by clicking on the Add button. This opens the Project Properties dialog box.

Project

Use this field to specify a name for the project. This name will appear in the Project Tree window.

Description

Use this field to provide a description of the project. This description is for information purposes only and is not used anywhere else in the system. It is not required.

OK

Click OK to create the new project or save changes to the existing project and close the Project Properties dialog box. Projects are added to the Project Tree in alphabetical order.

Cancel

Cancel closes the Project Properties window without creating the new project or saving any changes made to an existing project.

Edit

You may edit existing projects by selecting a project from the list and clicking the Edit button in the Project List window. This opens the Project Properties dialog box.

Copy

You may create a copy of the selected project by clicking the Copy button. Doing so will cause a confirmation message to appear.

  • Click Yes to create a copy.

  • Click No to cancel the copy.

Delete

A user can delete a project by selecting a project in the Project List dialog box and clicking the Delete button. This will cause a confirmation message to appear.

  • Click Yes to delete the selected project.

  • Click No to cancel the delete.


Project

Edit Project

The Edit Project menu option is the second item in the Project menu. This item allows you to edit an existing project. Selecting the Edit Project menu option causes the Project Properties dialog box to appear as in the Define Project section.

If a process flow or stream is selected in the Project Tree and you select the Edit Project menu option, the project under which the process flow or stream falls will be the one edited.


Save As - Project Menu

Project

Save As

The Save As menu option is the third item in the Project menu. This item allows you to save an existing project under a different name or with different details without overwriting the original. Selecting the Save As menu option causes the Project Properties dialog box to appear as in the Define Project section, with one small difference.

Project

Use this field to specify a name for the project. This name will appear in the Project Tree window.

Description

Use this field to provide a description of the project. This description is for information purposes only and is not used anywhere else in the system. It is not required.

Save As

Click Save As to save the new version of the project and close the Project Properties dialog box. The new version will be added to the Project Tree and the original version will still exist as well.

Cancel

Cancel closes the Project Properties dialog box without saving the new version of the project.


Insert Process Flow - Project Menu

Project

Insert Process Flow

The Insert Process Flow menu option is the last item in the Project menu. This item allows you to add process flows to the selected project. Inserting process flows from the Project menu will add the process flow to the end of the list of process flows belonging to the selected project. Selecting the Insert Process Flow menu option opens the Process Flow List dialog box.

See Process Flow for details on the Process Flow List dialog box.


Process Flow

Process Flow Menu Overview

A process flow is a collection of streams in a default order that represents the default path a call will follow. Process flows appear as the second level in the Project Tree, falling under projects. The Process Flow menu is used to create and update process flows. It can be accessed from the menu bar or by right-clicking a process flow in the Project Tree. There are five options in the Process Flow menu:

  • Insert Process Flow

  • Edit Process Flow

  • Save As

  • Remove Process Flow

  • Insert Stream

With Microsoft Visio 2003 Professional, process flow diagrams are available within Genesys Agent Scripting. A process flow diagram shows the collection of streams that comprise that process flow, a default flow, any branches connecting the streams, and any branches connecting to other process flows.

Right-clicking a process flow diagram brings up a menu containing a subset of the process flow menu items. From this menu, you can

  • Layout Shapes

  • Print Diagram

  • Insert Stream

See process flow diagram icons and information on using process flow diagrams.


Insert Process Flow - Process Flow Menu

Process Flow

Insert Process Flow

The Insert Process Flow menu option is the first item in the Process Flow menu. This item allows you to add process flows to a project as well as create new process flows, edit existing process flows, create copies of process flows, and delete process flows. The Insert Process Flow menu option opens the Process Flow List dialog box.

This dialog box lists process flows that have been defined but are not currently part of the selected project. To add a process flow to the project, select the process flow in the list and click OK. Inserting process flows from the Process Flow menu will insert the process flow above the currently selected process flow in a project.

Reference Filter

This filter allows you to display All, Unused, or Used objects in the List.

Add

You may add new process flows to a project book by clicking on the Add button. This opens the Process Flow Properties dialog box.

Label

The process flow label will appear on the corresponding Process Flow diagram and in the Process Flow drop down in the simulation.

Name

Use this field to specify a name for the process flow. This name will appear in the Project Tree window and is used internally. Process flow names cannot contain spaces and must be unique.

Description

Use this field to provide a description of the process flow. This description is for information purposes only and is not used anywhere else in the system. It is not required.

OK

Click OK to create the new process flow or save changes to the existing process flow and close the Process Flow Properties window.

Cancel

Cancel closes the Process Flow Properties window without creating the new process flow or saving any changes made to an existing process flow.

Edit

You may edit existing process flows by selecting a process flow from the list and clicking the Edit button in the Process Flow List dialog box. This opens the Process Flow Properties dialog box.

Copy

You may create a copy of the selected process flow by clicking the Copy button. Doing so will cause a confirmation message to appear.

  • Click Yes to create a copy.

  • Click No to cancel the copy.

Delete

You can delete a process flow by selecting a process flow in the Process Flow List dialog box and clicking the Delete button. This will cause a confirmation message to appear.

  • Click Yes to delete the selected process flow.

  • Click No to cancel the delete.


Process Flow

Edit Process Flow

The Edit Process Flow menu option is the second item in the Process Flow menu. This item allows your to edit an existing process flow. Selecting the Edit Process Flow menu option opens the Process Flow Properties dialog box as described in the Insert Process Flow section.

If a stream is selected in the Project Tree and you select the Edit Process Flow menu option, the process flow under which the stream falls will be the one edited.


Save As - Process Flow Menu

Process Flow

Save As

The Save As menu option is the third item in the Process Flow menu. This item allows you to save an existing process flow under a different name without overwriting the original. Selecting the Save As menu option opens the Process Flow Properties dialog box as described in the Insert Process Flow section, with one small difference.

Label

The process flow label will appear on the corresponding Process Flow diagram and in the Process Flow drop down in the simulation.

Name

Use this field to specify a name for the process flow. This name will appear in the Project Tree window and is used internally. Process flow names cannot contain spaces and must be unique.

Description

Use this field to provide a description of the process flow. This description is for information purposes only and is not used anywhere else in the system. It is not required.

Save As

Click Save As to save the new version of the process flow and close the Process Flow Properties dialog box. The new version will be added to the Project Tree above the original version.

Cancel

Cancel closes the Process Flow Properties dialog box without saving the new version of the process flow.


Process Flow

Remove Process Flow

The Remove Process Flow menu option is the fourth item in the Process Flow menu. This item will remove the selected instance of the process flow from the Project Tree and close the corresponding Process Flow diagram.


Insert Stream - Process Flow Menu

Process Flow

Insert Stream

The Insert Stream menu option is the last item in the Process Flow menu. This item allows the user to add streams to the selected process flow. Inserting a stream from the Process Flow menu will add the stream to the end of the list of streams belonging to the selected process flow. Selecting the Insert Stream menu option opens the Stream List dialog box.

See Stream for details on the Stream List dialog box.


Stream

Stream Menu Overview

A stream is a collection of pages with a logical flow connecting the pages with branching conditions that govern the transition from page to page. Streams appear as the third level in the Project Tree, falling under process flows. The Stream menu is used to create and update streams. It can be accessed from the menu bar or by right-clicking a stream in the Project Tree. There are five options in the Stream menu:

  • Insert Stream

  • Edit Stream

  • Save As

  • Remove Stream

  • Insert Page

With Microsoft Visio 2003 Professional, stream diagrams are available within Genesys Agent Scripting. A stream diagram is a lower level diagram that shows the flow from page to page within a stream including all branching conditions within the stream as well as connections to other streams and process flows.

In addition, any actions that occur during page load or unload are indicated by a star as seen in the icon table below.

Right-clicking on a stream flow diagram brings up a menu containing a subset of the stream menu items. From this menu, the user can

  • Layout shapes

  • Print diagram

  • Insert Page

See stream diagram icons and information on using stream diagrams.


Insert Stream - Stream Menu

Stream

Insert Stream

The Insert Stream menu option is the first item in the Stream menu. This item allows the user to add streams to a process flow as well as create new streams, edit existing streams, create copies of streams, and delete streams. The Insert Stream menu option opens the Stream List dialog box.

This dialog box lists streams that have been defined but are not currently part of the selected process flow. To add a stream to the process flow, select the stream in the list and click OK. Inserting streams from the Stream menu will insert the stream above the currently selected stream in a process flow.

Reference Filter

This filter allows you to display All, Unused, or Used objects in the List.

Add

You may add new streams to a project book by clicking on the Add button. This opens the Stream Properties dialog box.

Stream Label

The stream label appears on the corresponding Stream diagram.

Stream Name

Use this field to specify a name for the stream. This name will appear in the Project Tree window and is used internally. Stream names cannot contain spaces and must be unique.

Description

Use this field to provide a description of the stream. This description is for information purposes only and is not used anywhere else in the system. It is not required.

OK

Click OK to create the new stream or save changes to the existing stream and close the Stream Properties dialog box.

Cancel

Cancel closes the Stream Properties dialog box without creating the new stream or saving any changes made to an existing stream.

Edit

You may edit existing streams by selecting a stream from the list and clicking the Edit button in the Stream List dialog box. This opens the Stream Properties dialog box.

Copy

You may create a copy of the selected stream by clicking the Copy button. Doing so will cause a confirmation message to appear.

  • Click Yes to create a copy.

  • Click No to cancel the copy.

Delete

You can delete a stream by selecting a stream in the Stream List window and clicking the Delete button. This will cause a confirmation message to appear.

  • Click No to cancel the delete.

  • Click Yes to delete the selected stream.

If a stream is referenced by other objects, clicking Yes will not delete it. Instead, a message opens that allows you to view a cross reference of objects that use this stream.

  • Click No to return to the Stream List.

  • Click Yes to open the Object Cross Reference dialog box.

Until all of the references are removed, you cannot delete the stream. Double clicking each reference will take you to the selected object.


Stream

Edit Stream

The Edit Stream menu option is the second item in the Stream menu. This item allows you to edit an existing stream. Selecting the Edit Stream menu option opens the Stream Properties dialog box as in the Insert Stream section.


Save As - Stream Menu

Stream

Save As

The Save As menu option is the third item in the Stream menu. This item allows you to save an existing stream under a different name without overwriting the original. Selecting the Save As menu option opens the Stream Properties dialog box as in the Insert Stream section, with one small difference.

Stream Label

The stream label appears on the corresponding Stream diagram.

Stream Name

Use this field to specify a name for the stream. This name will appear in the Project Tree window and is used internally. Stream names cannot contain spaces and must be unique.

Description

Use this field to provide a description of the stream. This description is for information purposes only and is not used anywhere else in the system. It is not required.

Save As

Click Save As to save the new version of the stream and close the Stream Properties dialog box. The new version will be added to the Project Tree above the original version.

Cancel

Cancel closes the Stream Properties dialog box without saving the new version of the stream.


Stream

Remove Stream

The Remove Stream menu option is the fourth item in the Stream menu. This item will remove the selected instance of the stream from the Project Tree and close the corresponding Stream diagram.


Insert Page - Stream Menu

Stream

Insert Page

The Insert Page menu option is the last item in the Stream menu. This item allows you to add pages to the selected stream. Inserting a page from the Stream menu will add the page to the end of the list of pages belonging to the selected stream in the Page Tree. Selecting the Insert Page menu option opens the Page List dialog box.

See Page for details on the Page List dialog box.


Page (or Page Layout)

Page (or Page Layout) Menu Overview

Use the Page menu to create and update pages. It can be accessed from the menu bar or by right-clicking a page in the Page Tree.

The Page Layout menu appears in place of the Page menu when you select a page layout from the Page Layouts option in the File menu.

  • Page Menu

  • Page Layout Menu


Page (or Page Layout) > Page

Page Menu Overview

A page is the actual web page that appears on the agent desktop with all of the text, fields, action buttons, and interfaces shown in addition to the relevant page load and page unload actions and branching conditions. Pages belonging to a selected Stream appear in the Page Tree. The Page menu is used to create and update pages. It can be accessed from the menu bar or by right-clicking a page in the Page Tree. There are fourteen options in the page menu.

  • Insert Page

  • Edit Page

  • Save As

  • Remove Page

  • Insert Branch

  • Insert Field

  • Insert Action

  • Insert Page Link

  • Insert HTML Table

  • Insert URL Link

  • Insert Navigator

  • Insert Image

  • Insert Break

  • Edit HTML

  • Edit Page View (only if Edit HTML was selected)


Insert Page - Page Menu

Page (or Page Layout) > Page

Insert Page

The Insert Page menu option is the first item in the Page menu. This item allows you to add a page to a stream as well as create new pages, edit existing pages, create copies of existing pages, and delete pages. The Insert Page option opens the Page List dialog box.

The Page List dialog box lists pages that have been defined but are not currently part of the selected stream. To add a page to the stream, select the page in the list and click OK. Inserting pages from the Page menu will insert the page above the currently selected page in a stream.

Reference Filter

This filter allows the user to display All, Unused, or Used objects in the List.

Add

You may add new pages to a project book by clicking the Add button. This opens the Page Properties dialog box.

Page Label

The page label will appear in the corresponding Stream diagram.

Page Name

Use the Page Name field to provide a name for the page. This name will appear in the Page Tree and is used internally. Page names cannot contain spaces and must be unique.

Description

Use this field to provide a description of the page. This description is for informational purposes only and is not used anywhere else in the system. It is not required.

Override Multi-row Tables

Tables are fields defined as a collection of other fields. Tables can either be defined as single row or multi-row tables. If this box is selected then all tables that appear on the script page will be treated as single row tables regardless of their definition.

Capture as HTML Form when Using CAPTURE Action

When checked, this feature allows you to save the page in HTML format rather than to just capture the content of the page when using the capture action. This can be used to capture the layout of a letter or form and not just the contents/data on the form/letter.

Don't Add to Page Stack

When checked, this feature will keep a page from being added to the page stack.

This is useful for pages that the Genesys Agent Scripting user wants to execute but not have the end user return to on a previous page action. For example if the Genesys Agent Scripting user has a blank page that only contains a page load event, that page may be skipped if the end user backs up.

Generate Reporting Data

When this check box is selected, Reporting Data for this page will be generated as part of the Page Unload action. This is known as a "Reporting Data Collection Point".

Note: Reporting Data Collection Points are also displayed on the Visio Stream Diagrams as small yellow database icons on the Page Unload portion of the Page symbol.

Reporting Marker

This is an optional user-defined text field that is used to categorize and/or group Agent Scripting Pages for reporting purposes.

Template

A powerful feature of Genesys Agent Scripting is the use of templates for script page layouts. Using basic HTML structures, a template can be created in a text file, and then loaded into Genesys Agent Scripting. To format a script page based on template, select the name of the template from the template drop down.

CAUTION: If the user selects a template to be applied to an existing script page, the page’s content will be replaced with the template.

Preview

Clicking Preview will open a browser with the template loaded.

Layout

By default, Genesys Agent Scripting will use the page layout selected in the settings dialog box as the layout for a page. However, you can override the default layout by selecting one from the drop-down list.

Load Action

This button allows you to define an action to occur when the page is loaded.

Unload Action

This feature allows you to define an action that will run anytime the current page is about to unload. If for any reason during this action, the Alert command is encountered, the page unload is canceled. This is useful for doing validation of information prior to leaving a page.

OK

Click OK to create the new page or save changes to the existing page and close the Page Properties dialog box.

Cancel

Cancel closes the Page Properties dialog box without creating the new page or saving any changes made to an existing page.

Edit

You may edit existing pages by selecting a page from the list and clicking the Edit button in the Page List dialog box. This opens the Page Properties dialog box.

Copy

You may create a copy of the selected page by clicking the Copy button. Doing so will cause a confirmation message to appear.

  • Click Yes to create a copy.

  • Click No to cancel the copy.

Delete

You can delete a page by selecting a page in the Page List dialog box and clicking the Delete button. This will cause a confirmation message to appear.

  • Click No to cancel the delete.

  • Click Yes to delete the selected page.

If a page is referenced by other objects, clicking Yes will not delete it. Instead, a message opens that allows you to view a cross reference of objects that use this page.

  • Click No to return to the Page List.

  • Click Yes to open the Object Cross Reference dialog box.

Until all of the references are removed, you cannot delete the page. Double-clicking each reference will take the user to the selected object.


Page (or Page Layout) > Page

Edit Page

The Edit Page menu option is the second item in the Page menu. This item allows you to edit an existing page. Selecting the Edit Page menu option opens the Page Properties dialog box as in the Insert Page section.


Save As - Page Menu

Page (or Page Layout) > Page

Save As

The Save As menu option is the third item in the Page menu. This item allows you to save an existing page under a different name without overwriting the original. Selecting the Save As menu option opens the Page Properties dialog box as in the Insert Page section, with one minor difference: The OK button has been replaced with the Save As button. Adjust the properties as necessary and then click Save As to save a copy of the page.


Page (or Page Layout) > Page

Remove Page

The Remove Page menu option is the fourth item in the Page menu. This item will remove the selected instance of the page from the Page Tree. This option does not delete the page; it just removes it from the selected stream.


Insert Branch - Page Menu

Glossary of Key Terms > Branching

Insert Branch

The Insert Branch menu option is the fifth item in the Page menu. It is also available by right-clicking a branching condition in the Page Tree. This item allows you to add branches to the selected page. Selecting the Insert Branch menu option opens the Branch Condition dialog box.

Note: You may also edit a branch and delete a branch by right-clicking a branching condition in the Page Tree.

Branch From

This is the location from which the branch occurs. You must select a process flow, stream, and page. The choice of process flow, stream, and page determine if it is a page branch, stream branch, or process flow branch.

If you select the choice [Current] for the process flow and stream and select a specific page, this creates a page level branch.

If you select the choice [Current] for the process flow and select a specific stream and page, this creates a stream level branch.

If you selects a specific process flow, stream, and page, this creates a process flow level branch.

Branch Type

You have four types of branches to pick from: always branch, conditional branch, return, and stop.

Branch To

This option is used to specify where the script should be directed. You indicate this by selecting a process flow, stream, and page from the drop down lists.

This field is only active if the branch type is always branch or conditional.

Condition

This field is only active if the branch type is conditional. To branch conditionally, select a field in the first drop-down list box, a condition (operator) in the second, static or field (value type) in the third, and provide a value or field in the last. Genesys Agent Scripting will automatically determine the valid operators and range of values based on the type of field selected. For example, if you select a check box type field then only the equal and not equal operators will be selectable, and only true and false for values will be selectable. Similarly, if you select a radio button type field then only the equal and not equal operators will be available. However, the values drop-down will list all possible values for the radio button.

A conditional branch only branches if the selected condition is met.

Use Branch On Return

This check box is only active if the branch type is always branch or conditional. If this box is checked, it indicates that upon hitting a return point, the system should branch to the location specified below.

Branch On Return

This field is only active if the Use Branch On Return box is checked.

This option is used to specify where the script should return to after hitting a return point. You indicate this by selecting a process flow, stream, and page from the drop-down lists.

OK

Click OK to save any changes made to the branch.

Cancel

Click Cancel to close the window without accepting any changes to the branch.

Branch Display in the Page Tree

Page, stream, and process flow branches are grouped separately under their page in the Page Tree.

The page level branches appear above the stream level branches, which are above the process flow level branches. Branches with return may fall in any of the three categories. They are differentiated in the Page Tree by symbol.


Page (or Page Layout) > Page

Insert Field

The Insert Field menu option is the sixth item in the Page menu. This item allows you to place data fields on the selected page. Selecting the Insert Field menu option opens the Field List dialog box.


Page (or Page Layout) > Page

Insert Action

The Insert Action menu option is the seventh item in the Page menu. This item allows you to place action buttons on the selected page. Selecting the Insert Action menu option opens the Action List dialog box.


Insert Page Link - Page Menu

Page (or Page Layout) > Page

Insert Page Link

The Insert Page Link menu option is the eighth item in the Page menu. The Insert Page Link option allows you to add a link to other Genesys Agent Scripting pages on the selected page. Selecting this option opens the Page Link Properties dialog box.

Link Text

This field is used to provide the text value that will be displayed as the link text on the selected page.

Open Page in New Browser Window

If this box is checked, it will cause the page to appear in a new browser window.

Process Flow

Use this drop-down list to select a process flow to which this link will be associated.

Stream

Use this drop-down list to select a stream to which this link will be associated.

Page

Use this drop-down list to select a page to be associated with the link.

Use Link With Return

If this box is checked, upon reaching a return point, the page containing the link will be reloaded.

OK

Clicking the OK button will add the link to the page.

Cancel

Clicking the Cancel button will close the dialog box without adding the link to the page.


Page (or Page Layout) > Page

Insert HTML Table

The Insert HTML Table menu option is the ninth item in the Page menu. Use the Insert HTML Table option to add an HTML table structure to the selected page. Selecting this option opens the Table dialog box.

Each of the options on this dialog box is described below. Once a table has been inserted, you can double-click the table in the script page and make additional changes.

Rows

The row value indicates the number of rows you want to be displayed in the table.

Columns

The column value indicates the number of columns you want to be displayed in the table.

Border

Select this option to have a border for the table.

Include Table Heading

If you select this option a single row will be added to the top of the table that spans all columns. This row is meant to be used for a heading for the table.

Include Column Headings

If you select this option, a row will be added to the table for columns headings.

Include Row Headings

If you select this option, a column will be added to the table for row headings.

Sample

This field provides an example of what the table will look like on the page.

OK

Clicking the OK button will add an HTML table with the selected characteristics to the page.

Cancel

Clicking the Cancel button will close the window without creating the HTML table.


Page (or Page Layout) > Page

Insert URL Link

The Insert URL Link menu option is the tenth item in the Page menu. The Insert URL Link option allows you to add a link to other pages. Selecting this option opens the Link Properties dialog box described below:

Text

The field is used to provide the text value that will be displayed as the link text.

URL

The URL (Universal Resource Locator) points to a Web address. When the page is displayed you will be able to click the link and jump to a page outside of Genesys Agent Scripting. You do not need to include the http:// piece of the URL. If a URL is added that begins with www, Genesys Agent Scripting will prefix the http://, otherwise the link will be treated as a relative link.

HTML

This field allows you to add attributes to the link.

Open New Window

If this box is checked, the page appears in a new browser window.

OK

Clicking the OK button will add the link to the page.

Cancel

Clicking the Cancel button will close the window without adding the link to the page.


Page (or Page Layout) > Page

Insert Navigator

The Insert Navigator menu option is the eleventh item in the Page menu. It displays a drop-down list of the set of process flows to which the user can branch.


Insert Image - Page Menu

Page (or Page Layout) > Page

Insert Image

The Insert Image menu option is the twelfth item in the Page menu. Selecting this option opens the Image dialog box.

Use this option to place an image on the window. Once selected, images are automatically copied to the images directory indicated in the settings dialog.

Image

This field contains the image file name to be added.

Browse

Click the Browse button to display a standard windows dialog box for selecting an image.

Width

This specifies the width of the image in pixels.

Height

This specifies the width of the image in pixels.

OK

Clicking the OK button will add the image to the page.

Cancel

Clicking the Cancel button will close the window without adding the image to the page.


Page (or Page Layout) > Page

Insert Break

The Insert Break menu option is the thirteenth item in the Page menu.

By default, Genesys Agent Scripting places a new paragraph mark in a script page when you select the Enter key. You can use the Insert Break option to move text and objects to a new line without starting a new paragraph.


Edit HTML - Page Menu

Page (or Page Layout) > Page

Edit HTML

The Edit HTML (and Edit Page View) menu options are the final items in the Page menu.

The Edit HTML option allows you to access and modify the HTML code that makes up the page. When you select this option, the Genesys Agent Scripting Editor will display the HTML code in the Genesys Agent Scripting Editor rather than the page content.

See Edit Page View.


Page (or Page Layout) > Page

Edit Page View

The Edit Page View option only appears in the Page menu after Edit HTML has been selected. It takes the place of the Edit HTML menu option. Selecting this option causes Genesys Agent Scripting to display the page content in the Genesys Agent Scripting Editor rather than the HTML code.

See Edit HTML.


Page (or Page Layout) > Page Layout

Page Layout Menu Overview

The Page Layout menu appears in place of the Page menu when you select a page layout from the Page Layout option in the File menu. There are nine options in the Page Layout menu:

  • Delete Page Layout

  • Edit Page Layout Properties

  • Save As

  • Insert Page Link

  • Insert Page Area

  • Insert Catalog Area

  • Insert Image

  • Set Background Image

  • Edit HTML

  • Edit Page View (only if Edit HTML was selected)


Page (or Page Layout) > Page Layout

Delete Page Layout

Use the Delete Page Layout menu option to delete an existing page layout. A confirmation message will appear.

  • Click No to cancel the delete.

  • Click Yes to delete the page layout.

If a page layout is used by any objects in the system, clicking Yes will not delete it. Instead, a message opens that allows you to view a cross reference of objects or pages that use this page layout.

  • Click No to close the message.

  • Click Yes to open the Object Cross Reference dialog box.

Until all of the references are removed, you cannot delete the page layout. Double-clicking on each reference will take you to the selected object or page.


Page (or Page Layout) > Page Layout

Edit Page Layout Properties

Use the Edit Page Layout Properties menu option to modify the selected page layout. Selecting this option opens the Page Layout dialog box for the selected page layout. You can then edit any item on this dialog box.

Layout Name

Use this field to specify a name for the new page layout. This name will appear in the tree on the main Genesys Agent Scripting window in page layout mode.

Description

Use this field to provide a description of the page layout. This description is for information purposes only and is not used anywhere else in the system.

Style Sheet

This field contains a style sheet file name. You may add a style sheet to the page layout.

Browse

Click the Browse button to select a style sheet to add to the page layout. Once selected, style sheets are automatically copied to the style sheets directory indicated in the settings dialog box.

Catalog

This field contains a list of the existing catalogs. Select one to add a catalog to the layout.

Code

The Code button allows you to create an action that will run when any page using this page layout is loaded. Actions associated with a page layout are run before actions on a page.


Save As - Page Layout Menu

Page (or Page Layout) > Page Layout

Save As

This item allows you to save an existing page layout under a different name without overwriting the original. Selecting the Save As menu option causes the Page Layout dialog box to appear as in the Edit Page Layout section, with one minor difference: The OK button has been replaced with the Save As button. Adjust the properties as necessary and then click Save As to save a copy of the page layout.


Insert Page Link - Page Layout Menu

Page (or Page Layout) > Page Layout

Insert Page Link

The Insert Page Link option allows you to add a link to other Genesys Agent Scripting pages on the selected page. Selecting this option opens the Page Link Properties dialog box.

Link Text

This field is used to provide the text value that will be displayed as the link text on the selected page.

Open Page in New Browser Window

If this box is checked, it will cause the page to appear in a new browser window.

Process Flow

Use this drop down to select a process flow to which this link will be associated.

Stream

Use this drop down to select a stream to which this link will be associated.

Page

Use this drop down to select a page to be associated with the link.

Use Link With Return

If this box is checked, upon reaching a return point, the page containing the link will be reloaded.

OK

Clicking the OK button will add the link to the page.

Cancel

Clicking the Cancel button will close the dialog box without adding the link to the page.


Page (or Page Layout) > Page Layout

Insert Page Area

The Page Area is where the contents of the created pages appear in the browser. Selecting this option will add a page area to the page layout.


Page (or Page Layout) > Page Layout

Insert Catalog Area

The Catalog Area is where the page navigation information appears. Selecting this option will add a catalog area to the page layout.


Insert Image - Page Layout Menu

Page (or Page Layout) > Page Layout

Insert Image

The Insert Image option allows you to insert images in the page layout.

Once selected, images are automatically copied to the images directory indicated in the settings dialog.

Image

This field contains the image file name to be added.

Browse

Click the Browse button to display a standard windows dialog for selecting an image.

Width

This specifies the width of the image in pixels.

Height

This specifies the width of the image in pixels.

OK

Clicking the OK button will add the image to the page layout.

Cancel

Clicking the Cancel button will close the window without adding the image to the page layout.


Page (or Page Layout) > Page Layout

Set Background Image

The Set Background Image option allows you to select a background image to appear in all pages using this page layout. Selecting this option opens the Image dialog box.

Once selected, images are automatically copied to the images directory indicated in the settings dialog.

Image

This field contains the image file name to be added.

Browse

Click the Browse button to display a standard windows dialog box for selecting an image.

Width

This specifies the width of the image in pixels.

Height

This specifies the width of the image in pixels.

OK

Clicking the OK button will add the image to the page layout background.

Cancel

Clicking the Cancel button will close the window without adding the image to the page layout background.


Edit HTML - Page Layout Menu

Page (or Page Layout) > Page Layout

Edit HTML

The Edit HTML (and Edit Page Layout View) menu options is the final items in the Page Layout menu.

The Edit HTML option allows you to access and modify the HTML code that makes up the page layout. When you select this option, the Genesys Agent Scripting Editor will display the HTML code in the Genesys Agent Scripting Editor rather than the page layout content.

See Edit Page Layout View.


Page (or Page Layout) > Page Layout

Edit Page Layout View

The Edit Page Layout View option only appears in the Page Layout menu after Edit HTML has been selected. It takes the place of the Edit HTML menu option. Selecting this option causes Genesys Agent Scripting to display the page layout content in the Genesys Agent Scripting Editor rather than the HTML code.

See Edit HTML.


Format

Format Menu Overview

The Format menu is used to format text on the current script page. There are eight options in the format menu:

  • Bold

  • Italic

  • Underline

  • Set Color

  • Set Font

  • Justify

  • HTML Table

  • List


Format

Bold

This option will set the font style of the selected text to bold.


Format

Italic

This option will set the font style of the selected text to italic.


Format

Underline

This option will set the font style of the selected text to underline.


Format

Set Color

Selecting the Set Color option opens the Color dialog box.

This dialog box is the basic Microsoft Windows color selection dialog box. Select any color from the basic colors or define custom colors. When you click OK, the selected text in the script will be changed to the chosen color.


Format

Set Font

The Set Font option allows you to select a font for text items on the page. Selecting this option opens the Select Font dialog box.

Select font options and click OK to change selected text.

Font

This option allows you to select fonts, in order of preference, in which the selected text will appear.

Sample

The Sample field provides you with an example of how the text will appear.

Size

By selecting the font size, you can determine the size of the text on the page.

OK

Click OK to change the selected text in the page to match the chosen font.

Cancel

Click Cancel to close the Select Font dialog box without changing the font of the selected text.


Format

Justify

The Justify option allows you to align text on the page.

Left

This option aligns the selected text with the left margin.

Center

This option causes the text to be centered on the page.

Right

This option aligns the selected text with the right margin.

Justify

Justify equally spaces the words on a line so that the line appears to be aligned with both the left and right margins. The last line of the paragraph will be left justified.


Format

HTML Table

The HTML Table menu option allows you to edit the selected HTML Table.

Add Row

This option allows you to add a new row to a table. The new row appears above the selected cell(s).

Add Column

This option adds a column to the left of the selected cell.

Delete Rows

This option deletes the selected row(s).

Delete Columns

This option deletes the selected column(s).

Merge Columns

This option merges the selected cells into one cell.

Split Columns

This option divides the selected cell(s).

Add Cell

This option adds a cell to the left of the selected cell.

Delete Cell

This option deletes the selected cell(s).

Toggle Border

This option adds or removes the border from the selected HTML Table.


Format

List

The List option allows you to take selected text and convert it to a numeric list.


Define

Define Menu Overview

The Define menu is used to define elements used throughout the Project Book. These elements include fields for data input and retrieval, interfaces for enterprise applications, and functions for managing complex data handling within a script. There are 14 options in the define menu:

  • Projects

  • Process Flows

  • Streams

  • Pages

  • Fields

  • Actions

  • XML Interfaces

  • Databases

  • Database Interfaces

  • API Interfaces

  • Async Interfaces

  • Catalogs

  • Templates

  • Custom Field Type


Define

Projects

The Define Project menu option is the first item in the Define menu. This item allows you to define projects. Selecting the Define Project menu option opens the Project List dialog box.


Define

Process Flows

The Define Process Flow menu option is the second item in the Define menu. This item allows you to define process flows. Selecting the Define Process Flow menu option opens the Process Flow List dialog box.


Define

Streams

The Define Streams menu option is the third item in the Define menu. This item allows you to define streams. Selecting the Define Streams menu option opens the Stream List dialog box.


Define

Pages

The Define Pages menu option is the fourth item in the Define menu. This item allows you to define pages. Selecting the Define Pages menu option opens the Page List dialog box.


Define > Fields

Fields Overview

The Define Fields menu option is the fifth item in the Define menu. This item allows you to define fields. Fields are used for collecting and displaying information. They are also used to control branching. There are many types of fields that can be defined in Genesys Agent Scripting. Selecting the Define Fields menu option opens the Field List dialog box.

The Field List dialog box lists all fields that have been previously defined.

Filter by Type

This filter allows you to display only the fields of the type that you specified in the drop-down list.

Filter by Group

This filter allows you to display only the fields that belong to the specified group.

Sort by Group

When selected, the fields in the list are sorted first by group and then alphabetically. When not selected, the fields are sorted alphabetically regardless of which group they belong to.

Reference Filter

This filter allows you to display All, Unused, or Used objects in the list.

Add

Clicking Add opens the Field Properties dialog box.

Edit

Use the Edit button to edit fields. In order to edit a field, you must select a field from the Field List and click Edit. When this option is selected, the Field List will appear. You can then edit any item on this dialog box.

Copy

This option allows you to make a copy of a field. Clicking Copy opens a confirmation message.

  • Click Yes to add a copy of the selected object to the Field List.

  • Click No to close the dialog box without making a copy of the field.

Delete

Use the Delete button to delete fields. In order to delete a field, you must select a field from the Field List and click Delete. Clicking Delete opens a confirmation message.

  • Click No to cancel the delete.

  • Click Yes to continue.

When you select Yes, Genesys Agent Scripting will first verify that the field to be deleted is not used anywhere in the system. If the field is not being used anywhere else, it will be deleted. However, if any other object references the field, you will not be able to delete it at this time and a message will appear.

  • Click No to return to the Field List.

  • Click Yes to open the Object Cross Reference dialog box.

Until all of the references are removed, you cannot delete the field. Double-clicking on each reference will take you to the selected object.

You may select multiple fields to be deleted by holding the Shift key while selecting the fields.

Predefined Fields for Reporting

Two predefined fields are provided for use with reporting:

G_Reporting_Business_Result

Type = String

User-defined text that will be automatically collected at every Reporting Data Collection Point, and is included as part of the Page Reporting Data.

G_Reporting_Process_Flow_Result

Type = Drop Down List

Predefined states that determine the state of the Process Flow. Collected at every Reporting Data Collection Point, and included as part of the Process Flow Reporting data and the Page Reporting data.

Started: The Process Flow has been started and is in progress.

Suspended: The Process Flow has been suspended.

Resumed: The Process Flow has been resumed (restarted) following a suspend operation.

Abandoned: The Process Flow has been terminated with incomplete results.

Completed: The Process Flow has been successfully ended.

Transferred: The Process Flow has been Transferred to another Agent.


Define > Fields > Field Properties

Field Properties Overview

The Field Properties dialog box contains the following tabs:

  • Definition

  • Type

  • Size

  • Values

  • Table

  • HTML

  • Custom Type

Note: The Function tab was removed for version 7.2.0. Now, when Genesys Agent Scripting opens a pre-7.2.0 Project Book, it automatically converts fields of the type Function to the type Date and Time.


Define > Fields > Field Properties

Definition Tab

The Definition tab is used to set basic field properties.

Field Label

This is the label used at runtime for display and user alerts.

Field Name

The field name is used to identify the field within Genesys Agent Scripting. The name should be descriptive. It is the name you will use when selecting fields for placement on a script page, and in functions and XML interfaces.

Group

You can assign fields to groups. These fields can be filtered based on the group in the Field List, so that only fields belonging to a specific group display.

To assign a field to a group, select the group from the drop-down list. If the group has not yet been created, select [Prompt for a new value] from the drop-down list. In the window that displays enter the new group name.

Select [No Group] if you do not want to assign a field to a group.

To remove a group from the Group List, you must first move all fields belonging to that group to a different group (or to [No Group]). When no fields are assigned to that group, the group name is removed from the list.

The Group also displays in the Field List dialog box in the Filter by Group drop-down list.

Description

The description is for informational purposes only. This field is not used anywhere else is the system.

Pop-up Value

You can specify a pop-up value for a field. When the user moves the mouse over the field at runtime, a pop-up will appear with the pop-up value you specified.

Cross Reference

This button becomes active once the field has been created. Clicking Cross Reference will bring up a list of all of the objects that use the selected field.


Define > Fields > Field Properties

Type Tab

The Type tab includes the following options that allow you to customize field properties.

Field Type

The field type is used to indicate the type of data the field will use to collect and display. There are currently 12 field types are supported by Genesys Agent Scripting. Use the drop-down list box to select one of the following fields:

String

A string field should be used to display alphanumeric data.

Multi-Line Text

A multi-line text field will be displayed with scroll bars and will allow you to input many lines of text. See the Size tab for formatting information.

Numeric

A numeric field is used to store numbers. When the script is run, Genesys Agent Scripting will automatically validate that the you only input numeric information into the field. See the Size tab for formatting information.

Date and Time

A date and time field is used to store date and time values. Genesys Agent Scripting will display the date or time in the selected formatting. See the Size tab for formatting information.

Function

A function field is a display only field. The field’s value will be generated when a script is run based on the settings in the function tab.

Note: Function fields are being deprecated in Genesys Agent Scripting. In version 7.0.2 you may still define and use a Function field. In subsequent versions, you must use the Date and Time field in place of the Function field.

Calendar

A calendar field puts a calendar in the script.

You can select a single date on the calendar by scrolling through the months and years and clicking a date.

A calendar field value includes a date and time. If you set another field equal to the calendar field without clicking on the calendar to activate the calendar control, the date and time will be passed to the new field unchanged. However, if you click on any date, even the date to which the calendar field is currently set, the time will be set to 00:00:00. The intent of the calendar control is to pass the date information and automatically set any time information to 00:00:00. Failure to activate the calendar control could lead to misleading results if you subsequently use the time information.

Check Box

A check box field displays as a check box and can be used to capture and display true or false values.

A check box that is checked is the equivalent of a Boolean value of True, Yes, or 1. An unchecked check box is the equivalent of a Boolean value of False, No, or 0. If you set a string variable equal to a check box, the string will be set to 0 if the box is not checked, and to 1 if the box is checked. Conversely, if you set a check box equal to a string field, the check box will be set to selected if the string field is an integer 1, and unselected if the string field is not an integer.

Radio Buttons

Radio button fields are displayed as a group of options from which you may choose. For static values, the radio button shows the value names, but any logical comparisons are done based on the database value that is stored in the system. So, if you set a string field equal to the radio button, the string value will be whatever the database value is for the selected radio button. In the case of process flows, streams, and pages, the database value is the same as the name. If you set a radio button equal to another field that is not set to one of the database values of the radio button, none of the radio button values will be selected.

Radio buttons always have the first item in the list selected. To clear all items, or to pre-select a different item, use an action statement (for example Set FieldRadioButton = "").

See the Values tab for information regarding how to set the options you will be allowed to choose from.

Drop-Down List

Drop-down list fields are displayed as a drop-down list box that allows you to choose from a pre-selected list.

Drop-down lists always have the first item in the list selected. To clear all items, or to pre-select a different item, use an action statement (for example Set FieldDropdown = "").

See the Values tab for information regarding how to set the options you will be allowed to choose from.

Table

A table field is a collection of other fields. A table field will be displayed on the window as a table with columns made up of other fields. A table field can contain other table fields to support an unlimited level of parent child relationships. See the Table tab for information regarding how to associate fields with a table.

Custom Field Type

A custom field type field is a user defined field. Custom Field Types allow you to customize field types that are specific to their needs.

Listener

A listener field is a field type whose value can be updated asynchronously. Listener fields are display only.

Required

Required indicates that the script user must provide a value for this field. Genesys Agent Scripting will prevent you from leaving the script page if they have not provided a value.

Display Only

A Display Only field is a field that cannot be modified by the user. It will appear in a script as text.

Parameter

A Parameter Field is a field that will be passed to Genesys Agent Scripting at the start of the script via the URL. The values for parameter fields will generally be provided by applications, such as a CTI (Computer Telephony Integration) application.

Parameter and Configuration File Field options are mutually exclusive.

Do Not Transfer

Select this option for any field whose value should not be transferred on a Save Session or Load Session action. This option is useful for data elements that should not be carried forward when a session is transferred.

Password

Select this option to have the field’s value masked as a password field.

Configuration File Field

When this box is checked, the field is read in from the configuration file when the Genesys Agent Scripting application is started.

Parameter and Configuration File Field options are mutually exclusive. See configuration files for more information.

Reporting

The Reporting dropdown list is enabled for all field types except Table. Three options are available:

  • Never: This field is not included in Reporting Data.

  • If Changed: This field is included in Reporting Data if it has changed since the last Reporting Data Collection Point (Marked Page Unload).

  • Always: This field is included in Reporting Data at every Reporting Data Collection Point (Marked Page Unload).

Show this Field If

Fields can be shown or hidden based on the value of a specific field.

You may select a field from the Field drop-down list and Genesys Agent Scripting will automatically determine the valid operators and range of values based on the type of field selected. For example, if you select a check box type field then only the equal and not equal operators will be selectable, and only true and false for values will be selectable. Similarly, if you selects a radio button type field then only the equal and not equal operators will be available, however, the values drop-down list will list all possible values for the radio button. You can then select either a field or static value in the Value Type drop-down list to compare it against.


Define > Fields > Field Properties

Size Tab

The format of the Size tab depends on the type of field being displayed.

Type = String

If the type of the field is String, the tab will be displayed as described below.

Display Size

Display size sets the visual size of the field at runtime. This setting is only used to tell the browser the number of characters to allow on the window. It does not limit the number of characters that may be entered in the field.

Format

Format is used to control input of a field. Any character can be included in a format with the # and @ character as placeholders for user provided data. The # is used to indicate any valid number. Like the #, the @ is used to indicate a valid number but has the special property of being hidden. This is useful for fields that contain sensitive information such as a credit card. Some examples are shown below.

Type | Format | Example Value | Example Display
Telephone | (###) ###-#### ext. #### | 1234567890 123456789123 | (123) 456-7890 (123) 456-7891 ext. 23
Zip Code | #####-#### | 123456789 12345 | 12345-6789 12345
Credit Card Number | @@@@-@@@@-@@@@-#### | 1234567890123456 | ****-****-****-3456

Max Field Size

The field size is used to validate the field. You will not be allowed to enter a value that is longer than the field size at runtime. If 0 is entered, the max field size is not limited.

Min Field Size

You can specify a minimum field size that will be validated at runtime. The value entered in this field must contain at least the specified number of characters. If 0 is entered, the min field size is not limited.

Type = Numeric

If the type of the field is Numeric, the tab will be displayed as described below:

Display Size

Display size sets the visual size of the field at runtime. This setting is only used to tell the browser the number of characters to allow on the window. It does not limit the number of characters that may be entered in the field.

Format

For Numeric Fields, the user may select Integer, Currency, Fixed Decimal Point, Floating Decimal Point, and Percentage.

Max Field Size

The field size is used to validate the field. You will not be allowed to enter a value that is longer than the field size at runtime. If 0 is entered, the max field size is not limited.

Min Field Size

You can specify a minimum field size that will be validated at runtime. The value entered in this field must contain at least the specified number of characters. If 0 is entered, the min field size is not limited.

Type = Date and Time

If the type of the field is Date and Time, the tab will be displayed as described below.

Display Size

Display size sets the visual size of the field at runtime. This setting is only used to tell the browser the number of characters to allow on the window. It does not limit the number of characters that may be entered in the field.

Format

The format of a Date and Time field has two purposes. First, it is used to ensure that the value entered in the field is a valid value. Secondly, it is used to tell the server how to convert the input to the standard format in which it is stored. All date and time values are stored internally in the format yyyy-MM-dd HH:mm:ss, where HH:mm:ss are optional values with the caveat that items to the right can be dropped. That is, the user can specify HH:mm without the seconds value, ss, but the user cannot specify mm without also specifying HH.

For example, if the internal Date/Time string field 1999-12-31 23:59:59 is assigned to strings with the Format shown in the table (M/d/y hh:mm a), that means you will internally receive the data in the columns Display and Value Stored Internally. Parts of the original Date/Time field that are not used by the format are discarded and only the parts used are stored internally.

The table below shows how date and time data is constructed for use in a Date and Time field:

Element | Meaning | Example(s) of Use
M MM MMM MMMM | 1- or 2-digit month 2-digit month abbreviated month name month name | 1 01 Jan January
d dd | 1- or 2-digit date 2-digit date | 2 02
y yy yyyy | 2- or 4-digit year 2-digit year 4-digit year | 04, 2004 04 2004
E EEEE | abbreviated day name day name | Fri Friday
H HH | 1- or 2-digit hour (0-23) 2-digit hour (0-23) | 8 9 10 11 12 13... 08 09 10 11 12 13...
h hh | 1- or 2-digit hour (1-12) 2-digit hour (1-12) | ...8 9 10 11 12 ...08 09 10 11 12
m mm | 1- or 2-digit minute 2-digit minute | ...9 10 11 12 13 14...59 ...09 10 11 12 13 14...59
s ss | 1- or 2-digit second 2-digit second | ...9 10 11 12 13 14...59 ...09 10 11 12 13 14,,,59
a | AM (or PM) | AM

The table below shows examples of valid entries for the Format field when setting up Date and Time fields, as well as what is displayed to the script user and how the data is stored internally:

Format | Display | Value Stored Internally
M/d/y | 1/2/04 | 2004-01-02 00:00:00
MM/dd/yy | 01/02/04 | 2004-01-02 00:00:00
MM/dd/yy | 01/02/99 | 2099-01-02 00:00:00
MMM/d/yyyy | Dec/3/2004 | 2004-12-03 00:00:00
E MMMM/d/yyyy | Fri December/31/1999 | 1999-12-31 00:00:00
M/d/y EEEE H | 1/2/04 Friday 23 | 2004-01-02 23:00:00
M/d/y hh:mm a | 12/31/1999 11:59 PM | 1999-12-31 23:59:00
h:m:s a | 11:59:59 PM | 1970-01-01 23:59:59

Note: Dates in the format 19xx should be formatted as yyyy.

Max Field Size

The field size is used to validate the field. You will not be allowed to enter a value that is longer than the field size at runtime. If 0 is entered, the max field size is not limited.

Min Field Size

You can specify a minimum field size that will be validated at runtime. The value entered in this field must contain at least the specified number of characters. If 0 is entered, the min field size is not limited.

Type = Multi-line Text

If the type of field is Multi-Line Text the tab will be displayed as described below.

Display Size

This defines the size of the field on the page. It does not limit the amount of text that can be entered in the field.

Rows

For a Multi-Line Text field, the rows value indicates the number of rows that should be allocated on the web page for the field.

Cols

For a Multi-Line Text field, the cols value indicates the number of columns that should be allocated on the Web page for the field.

Max Field Size

The field size is used to validate the field. You will not be allowed to enter a value that is longer than the field size at runtime. If 0 is entered, the max field size is not limited.

Min Field Size

You can specify a minimum field size that will be validated at runtime. The value entered in this field must contain at least the specified number of characters. If 0 is entered, the min field size is not limited.


Define > Fields > Field Properties

Values Tab

The Values tab can only be accessed for field types Radio Button and Drop down List.

Values

This section allows you to define the field’s values.

Properties

When the user clicks on the Properties button a dialog box will be displayed depending on the value type selected (Static, Process Flows, Streams, Pages).

Static

Use Static to indicate that the values for a drop-down list or radio button are not from a table in a database. Genesys Agent Scripting will store the values for the field inside the application. You input values by clicking the Properties button.

When you click Properties and you have previously selected Static, the Field Value List is displayed.

Add

Selecting the Add button opens the Field Value dialog box.

Value Order

The value order is used to determine the order a value will appear in the radio field or drop-down list. This will shift all other fields with higher value orders down one in the order.

Display Value

The display value is the value the user will see on the script page.

Database Value

The database value is the actual value that will be assigned to the field when you select the current value.

Note: This value defaults to the display value, but may be overridden, and may be empty, or contain the same data as another Field Value entry. When Field Value data is duplicated, this field should not be used as a filter field or a visibility selector for any other Genesys Agent Scripting field.

Filter Value

The filter value is the value assigned to this value for filtering. Filtering can be used to reduce the number of choices the person using the scripts has to look at.

For example, suppose you need to determine how someone heard about a service being offer. First you want to determine if they heard an advertisement on the radio, or saw the ad in the newspaper. The ad is currently run on 15 radio stations and printed in 5 different newspapers. If you did this without filtering, there would be one drop-down list that lists all 15 radio stations and 5 newspapers. With filtering, you could create a drop-down list called media source and give it two values: Radio and Newspaper. You would then create a second drop-down list and add all 20 values to the list (15 radio stations, and 5 newspapers). However, in this case you would set the Filter Field to the Media source field, and on each value in the drop-down list, you would set the filter value to the appropriate value (Radio or Newspaper).

This field only becomes active when a field is set in the Filter Field drop down under the Values tab.

Edit

Use the Edit button to edit the Field Value List. In order to edit a field value, you must select a field value from the Field Value List and click Edit. When this option is selected, the Field Value dialog box will appear. You can then edit any item on this dialog box.

Delete

Use the Delete button to delete field values. In order to delete a field value, you must select a field value from the Field Value List and click Delete. A confirmation message will appear.

  • Click Yes to delete the field value or No to cancel.

Delete All

The Delete All button will delete all preexisting values in the Field Values List.

  • Click Yes to delete all of the values in the list or No to cancel.

Import

The Import button allows you to import values from an external database table into a list of static values. Clicking this button opens the Import Values from Table dialog box.

Each of the options on this dialog box is described below.

Database

Select a database for a source for this data element. Databases are defined in the database section below.

Table

Select the table as the source for values for this field.

Order Column

The order column allows you to select a column from the database table on which to order the items in the table.

Display Column

The values in the display column will be the items displayed in the drop-down list or as options in the Radio button field.

Database Value

The database value indicates the column in the table that should be used to assign a value to the Genesys Agent Scripting field. This can be the same column as the display column above or a different one.

Filter Column

The filter column is the column in the table that should be used for filtering. See the example in the Static Field values section.

    • Click OK to return to the Field Value List.

Process Flows

You can create a list consisting of process flows, streams, and pages.

When you click Properties and if you have previously selected process flows, the Field Test Value List is displayed.

Streams

You can create a list consisting of process flows, streams, and pages.

When you click Properties and if you have previously selected streams, the Field Test Value List is displayed.

Pages

You can create a list consisting of process flows, streams, and pages.

When you click Properties and if you have previously selected pages, the Field Test Value List is displayed.

Branch on Value Change

Select this option to have Genesys Agent Scripting automatically branch each time the value of the field changes.

Filter Field

In this field, you can select a field to act as a filter for this drop-down list or radio button. When you select a field to be a filter, its value will be used to determine the values that will be displayed on the script page. See filter value for more information.

Hide Radio Button Heading

If this box is selected, the heading for the radio button will not appear on the window at runtime. This option is disabled for drop-down lists.

Alternate Format for Radio Button

This option allows radio buttons to be displayed horizontally without a border and without a title. It is disabled for drop-down lists.


Define > Fields > Field Properties

Table Tab

The Table tab can only be accessed if the Table field type is selected. When you select the Table tab, the Field Properties dialog box opens. The Field Properties dialog box provides the following options:

Maximum Number of Rows to Display at One Time

This setting indicates the maximum number of rows that Genesys Agent Scripting should display on the script page in the browser. If the number of rows in the table exceeds this number, Genesys Agent Scripting will automatically add First, Previous x, Next x, and Last buttons to the script page where x is equal to the display rows.

Display Table as Drop-Down List

When this option is selected, the table is displayed as a drop-down list containing the column headings. When the user selects, that column will be displayed on the page.

Allow Multiple Table Rows to be Selected at One Time

You can use this option to indicate that multiple rows in a table can be selected at one time. By default, Genesys Agent Scripting tables are displayed with a radio type button in the first column of each row so a user can select that row. When this option is selected, the radio buttons are replaced with check boxes so the user can select more than one row at a time.

Only If This Field Is True

This field becomes active if the Allow Multiple Table Rows to be Selected at One Time field is selected. This item allows you to set a condition on whether or not multiple rows in a table can be selected. Only check box fields will appear in this list.

Filter Field

Select a Filter field to be used to evaluate each row in the table. If the field’s filter column’s value matches the filter field’s value, the row will be displayed; otherwise the row will be hidden.

Filter Column

Selects the column within the table whose value will be matched against the filter field’s value to determine if the row will be displayed.

Automatically Update Rows

The Automatically Update Rows check box is used to indicate if table values should automatically be updated. A table is a collection of Genesys Agent Scripting fields. If auto update is activated, values in fields are automatically copied to rows in a Genesys Agent Scripting table. If auto update is not activated, you must press a button to have changes copied into a row in a table.

Branch on Row Change

When this option is checked, Genesys Agent Scripting will automatically generate a branch when a row in the table is selected.

Retain Deleted Rows

If this option is selected, when a delete row command is issued, the row will be marked for deletion and hidden from the user. The row will not actually be removed from the table. If this option is not selected, a delete row command will cause the row to be removed from the table.

Hide Table Heading

If this box is selected, the heading for the table will not appear on the window at runtime.

Hide Column Heading

If this box is selected, the heading for all columns in the table will not appear on the screen at runtime.

Associate Fields

Clicking this button opens the Associate Fields dialog box. Use this dialog box to associate previously-defined fields with this table.

This screen displays the table in a tree structure and allows you to maintain the current table as well as any sub-tables. Fields can be dragged and dropped onto the table, and reordered. The available field list is managed to ensure that the same field is not added to the structure twice. Changes to the attributes are automatically saved.

Each of the options on the table is described below.

Table Tree

This window displays the fields that belong to the table. The fields are displayed in a tree structure and can be reordered by dragging and dropping. The columns appear in the table from left to right in the same order that the fields appear in the tree, from top to bottom.

Add Field

Click this button to add the selected field to the table.

Remove Field

Click this button to remove the selected field from the table.

Available Field List

This list contains all of the fields that can be added to the table. Once a field has been added to the table, it will be removed from this list since fields cannot appear twice in the same table.

The Available Field List can be filtered to show all fields or only those that belong to a specific group. In order to filter the fields, select a group from the drop-down list.

Heading

The heading is a text field to be displayed as a column heading in the table.

Hidden

Selecting this check box hides the values of the field so that the user cannot see them when this table is displayed. This option is helpful if you need to include a field in a table but do not wish to display its values on the window.

Child Table Display Column

If the field you have selected to add to the current table (table 1) is another table (table 2), you can select a column from table 2 to display in a column for table 1.


Define > Fields > Field Properties

HTML Tab

The HTML tab is used to change the look and feel of the field.

HTML Attributes

Select Static or Field in the HTML Attributes drop-down list.


Define > Fields > Field Properties

Custom Type Tab

The Custom Type tab allows you to define custom field types to meet their specific needs. This tab only becomes available when a field type of Custom Field Type is selected in the Type tab.

The Custom Type tab includes the following fields:

Custom Field Type

This drop-down list contains all of the Custom Field Types that have been defined. Select one from the list.

Custom Properties

This table shows a list of all properties that have been defined for the custom field type selected in the drop-down list. Click on a value in this table to directly assign a value to the property.

Edit CFT Definition

Click this button to display the Custom Field Type Properties.

OK

Click OK to accept the entered information.

Cancel

Click Cancel to close the Custom Type dialog box and cancel any information entered into the dialog box.


Define > Actions

Actions Overview

The Define Actions menu option is the sixth item in the Define menu. This item allows you to define actions. Selecting the Define Actions menu option opens the Action List dialog box.

Filter by Type

To filter the list based on action type, use the Filter by Type drop down and select one of the displayed actions.

Reference Filter

This filter allows you to display All, Unused, or Used objects in the List.

Add

Add defines a new action. Clicking Add opens the Action Wizard dialog box.

Edit

You may edit existing actions by selecting an action from the list and clicking the Edit button in the Action List dialog box. This opens the Action Properties dialog box.

Copy

You may create a copy of the selected action by clicking the Copy button. Doing so will cause a confirmation message to appear.

  • Click No to cancel the copy.

  • Click Yes to create a copy.

Delete

You can delete an action by selecting an action in the Action List window and clicking the Delete button. This will cause a confirmation message to appear.

  • Click No to cancel the delete.

  • Click Yes to continue.

When you select Yes, Genesys Agent Scripting will first verify that the action to be deleted is not used anywhere in the system. If the action is not being used anywhere else, it will be deleted. However, if any other object references the action, you will not be able to delete it at this time and a message will appear.

  • Click No to return to the Action List dialog box.

  • Click Yes to open the Object Cross Reference dialog box.

Until all of the references are removed, you cannot delete the action. Double-clicking on each reference will take the user to the selected object.

You may select multiple actions to be deleted by holding the Shift key while selecting the actions.


Define > Actions > Action Wizard

Action Wizard Overview

The Action Wizard aids you in the process of defining an action. To go directly to the Action Properties dialog box, click the Skip Wizard button in any Action Wizard dialog box.

Action Name

Always begin by entering an Action Name. This value will be displayed as the text for the button, unless a button image is provided.

Action Type

The Action Type indicates how the action is used. The following are valid action types:

  • Add Row

  • API Interface

  • Branch

  • Database Interface

  • Delete Row

  • Insert Row

  • Load Session

  • Next

  • Previous

  • Save Session

  • Unselect All Rows

  • Update Row

  • XML Interface

The following buttons display at the bottom of the Action Wizard dialog box:

Button Name | Description
Skip Wizard | Click Skip Wizard to open the Action Properties dialog box. This allows you to have more manual control over the creation and definition of any other Action type.
Previous | Click the Previous button to review or make changes for the previous step. As you define the specific details of an Action using the Action wizard.
Next | Click the Next button to go to the next step, if the Action type you are defining requires you to proceed to additional Action wizard screens.
Finish | Click Finish to complete the Action. The Finish button becomes available when the Action wizard has enough information to define the Action type you selected.
Cancel | Click Cancel to cancel the Action.


Define > Actions > Action Wizard

Add Row

The Add Row action will add a row to a table. The new row will be populated with the current values of fields that are contained in the table as described below:

  • Strings are displayed as a string with the current value.

  • Multi-Line Text fields are displayed as a string with the current value.

  • Numeric values are set to the current value and displayed as a string in the appropriate format.

  • Date fields are set to the current value and displayed as a string in the appropriate date format.

  • Calendar fields are displayed as the selected date in M/d/y format.

  • Radio button values are displayed as a string set to the currently selected value.

  • Check boxes are displayed as a check box that is either checked or empty.

  • Drop downs are displayed as a string with the value set to the currently selected drop down value.

To insert a blank row, use the Insert Row action type instead.

Note: If the target table has Automatic Updates enabled, adding a row to the table will result in duplicate values. This is caused by updates automatically being applied to the current row in the table, and the same values being added to the new row.

Next

Click Next to continue creating an Add Row action. This opens the Action Wizard - Add Row dialog box.

Table

This drop-down list allows you to select to which table a row should be added.

Previous

The Previous button will allow you to go back to the previous dialog box to review or change the information.

Finish

The Finish button will create the Add Row action.


Define > Actions > Action Wizard

API Interface

This action will execute an API Interface.

Next

Click Next to continue creating an API Interface action. This opens the Action Wizard - API Interface dialog box.

API Interface

This drop-down list allows you to select which API Interface the action will call.

Previous

The Previous button will allow you to go back to the previous dialog box to review or change the information.

Finish

The Finish button will create the API Interface action.


Define > Actions > Action Wizard

Branch

This action will execute a branch to a specific script and page.

Next

Click Next to continue creating a Branch action. This opens the Action Wizard - Branch dialog box.

Process Flow

This drop-down list allows the user to select from which process flow the user will select the stream.

Stream

This drop-down list allows the user to select from which stream the user will select the page. The list of streams is determined by the process flow selected above.

Page

This drop-down list allows the user to select to which page the window will branch. The list of pages is determined by the stream selected above.

Previous

The Previous button will allow the user to go back to the previous dialog box to review or change the information.

Finish

The Finish button will create the Branch action.


Define > Actions > Action Wizard

Database Interface

This action will execute a Database Interface.

Next

Click Next to continue creating a Database Interface action. This opens the Action Wizard - Database Interface dialog box.

Database Interface

This drop-down list allows you to select which Database Interface the action will call.

Previous

The Previous button will allow you to go back to the previous dialog box to review or change the information.

Finish

The Finish button will create the Database Interface action.


Define > Actions > Action Wizard

Delete Row

This action will delete the current row from a table.

Next

Click Next to continue creating a Delete Row action. This opens the Action Wizard - Delete Row dialog box.

Table

This drop-down list allows you to select from which table a row should be deleted.

Previous

The Previous button will allow you to go back to the previous dialog box to review or change the information.

Finish

The Finish button will create the Delete Row action.


Define > Actions > Action Wizard

Insert Row

This action will insert a new row into a table. The new row will be blank and any values entered in the fields that make up the table but are not yet saved into the table will be cleared as described below.

Insert Row causes the following behavior in the component fields of a Table Field:

  • Strings are cleared and displayed as ”” .

  • Multi-Line Text fields are cleared and displayed as ”” .

  • Numeric values are set to 0 and displayed in the appropriate format.

  • Date fields are cleared and displayed as ”” .

  • Calendar fields are set to ”” .

  • All radio button values are deselected and displayed as ”” .

  • Check boxes are unchecked and displayed as ”” .

  • Drop downs are displayed as ”” .

The corresponding component field values are reset as follows:

  • Strings are cleared and displayed as ”” .

  • Multi-Line Text fields are cleared and displayed as ”” .

  • Numeric values are set to 0 and displayed in the appropriate format.

  • Date fields are cleared and displayed as ”” .

  • Calendar fields are set to ”” .

  • All radio button values are deselected.

  • Check boxes are unchecked.

  • Drop downs are set to ”” .

If the you want to insert a row with the current values of fields that are contained in the tables, use the Add Row action type instead.

Next

Click Next to continue creating an Insert Row action. This opens the Action Wizard - Insert Row dialog box.

Table

This drop-down list allows you to select to which table a row should be inserted.

Previous

The Previous button will allow you to go back to the previous dialog box to review or change the information.

Finish

The Finish button will create the Insert Row action.


Define > Actions > Action Wizard

Load Session

This action will load a complete session. The action uses the value within a field to uniquely identify the session.

Next

Click Next to continue creating a Load Session action. This opens the Action Wizard - Load Session dialog box.

Field

This drop-down list allows the user to select which field’s value should be used to uniquely identify the session to be loaded.

Previous

The Previous button will allow the user to go back to the previous dialog box to review or change the information.

Finish

The Finish button will create the Load Session action.


Define > Actions > Action Wizard

Next

This action will branch to the next logical page.

Next

Click Next to continue creating a Next action. This opens the Action Wizard - Next dialog box. With the Action Type of Next selected, no further settings are required.

Previous

The Previous button will allow the user to go back to the previous dialog box to review or change the information.

Finish

The Finish button will create the Next action.


Define > Actions > Action Wizard

Previous

This action will branch to the previously displayed page.

Next

Click Next to continue creating a Previous action. This opens the Action Wizard - Previous dialog box. With the Action Type of Previous selected, no further settings are required.

Previous

The Previous button will allow the user to go back to the previous dialog box to review or change the information.

Finish

The Finish button will create the Previous action.


Define > Actions > Action Wizard

Save Session

This action will save a complete session. The action uses the value within a field to uniquely identify the session.

Next

Click Next to continue creating a Save Session action. This opens the Action Wizard - Save Session dialog box.

Field

This drop-down list allows the user to select which field’s value should be used to uniquely identify the session to be saved.

Previous

The Previous button will allow the user to go back to the previous dialog box to review or change the information.

Finish

The Finish button will create the Save Session action.


Clear All Rows

Define > Actions > Action Wizard

Unselect All Rows

This action will clear all rows from a table.

Unselect All Rows causes the same behavior as Insert Row for the component fields that make up a table, as well as deselecting all of the rows in the table. The corresponding component field values are reset as follows:

  • Strings are cleared and displayed as ”” .

  • Multi-Line Text fields are cleared and displayed as ”” .

  • Numeric values are set to 0 and displayed in the appropriate format.

  • Date fields are cleared and displayed as ”” .

  • Calendar fields are set to ”” .

  • All radio button values are deselected.

  • Check boxes are unchecked.

  • Drop downs are set to ”” .

Note: This command will also clear all rows from all tables that are contained within the target table.

Next

Click Next to continue creating an Unselect All Rows action. This opens the Action Wizard - Unselect All Rows dialog box.

Table

This drop-down list allows the user to select from which table the rows should be unselected.

Previous

The Previous button will allow the user to go back to the previous dialog box to review or change the information.

Finish

The Finish button will create the Unselect All Rows action.


Define > Actions > Action Wizard

Update Row

This action will update the current row in a table with values from fields contained in the table.

Update Row causes the same behavior as Add Row except that it operates on the currently selected row.

  • Strings are displayed as a string with the current value.

  • Multi-Line Text fields are displayed as a string with the current value.

  • Numeric values are set to the current value and displayed as a string in the appropriate format.

  • Date fields are set to the current value and displayed as a string in the appropriate date format.

  • Calendar fields are displayed as the selected date in M/d/y format.

  • Radio button values are displayed as a string set to the currently selected value.

  • Check boxes are displayed as a check box that is either checked or empty.

  • Drop-down lists are displayed as a string with the value set to the currently selected drop-down value.

Next

Click Next to continue creating an Update Row action. This opens the Action Wizard - Update Row dialog box.

Table

This drop-down list allows the user to select in which table the row should be updated.

Previous

The Previous button will allow the user to go back to the previous dialog box to review or change the information.

Finish

The Finish button will create the Update Row action.


Define > Actions > Action Wizard

XML Interface

This action will execute an XML Interface.

Next

Click Next to continue creating an XML Interface action. This opens the Action Wizard - XML Interface dialog box.

XML Interface

This drop-down list allows the user to select which XML Interface the action will call.

Previous

The Previous button will allow the user to go back to the previous dialog box to review or change the information.

Finish

The Finish button will create the XML Interface action.


Define > Actions

Action Properties

The Action Properties window has two tabs, the General tab and the Advanced tab. The buttons associated with each tab are described below. Clicking the Skip Wizard button in any Action Wizard dialog box will open the Action Properties dialog box.

If you provide an Action Name or Action Type, then click Skip Wizard, the name or type is transferred to the action editor. If an Action Type is not selected, by default Function is selected.

General Tab

The General tab allows you to view and/or edit basic action properties.

Button Text

This value will be displayed as the text for the button, unless a button image is provided.

Name

Use this field to specify a name for the action. This name will appear in the Action List window and is used internally. Action names cannot contain spaces and must be unique.

Description

This field contains a description of the action. It is optional and only used for informational purposes. If the action is created through the wizard, it is automatically created.

Pop-up Value

You can specify a pop-up value for actions. When you move the mouse over this button at runtime a pop-up will appear with this value.

Action Type

The Action Type indicates how the action is used. Valid action types are described in the Action Wizard Overview.

Additionally, any custom action created using the Skip Wizard button on the Action Wizard dialog box will have an action type of Function. This indicates a completely custom action.

Action types are also used to organize and filter actions in the Actions List.

Image

Actions can be displayed as images rather than standard buttons by providing the name of an image file.

Browse

Click the Browse button to navigate to a desired image file.

Image Width and Image Height

If the action is being displayed as an image, the image height and width fields are used to set the size of the action image.

Advanced Tab

The Advanced tab allows users to view and/or edit more advanced action properties.

Confirm Action

This allows you to specify that at runtime a user must confirm the action. If this box is selected, the text field becomes active and allows you to specify what message appears in the runtime confirmation dialog. The default message is:

Are you sure?

and the user must click Yes to proceed.

Automatically Branch to Next Logical Page when Action is Clicked

Selecting this check box causes Genesys Agent Scripting to generate a branch condition when the action button is clicked. It will either branch to the next script page or a page referenced in a branching condition on the current page. The branch occurs after any code defined for this action has been executed.

Skip Validation

Select this box if you want Genesys Agent Scripting to skip over all validation at runtime. This allows you to leave a page that has required fields without providing values for these fields (for example, when working with cancel buttons).

Note: If this option is checked and the action is called in a page unload action, the validation will not be skipped.

Show this Button If

Actions can be shown or hidden based on the value of a specific field. You may select a field from the first drop-down list and Genesys Agent Scripting will automatically determine the valid operators and range of values based on the type of field selected.

For example, if you select a check box type field, then only the equal and not equal operators will be selectable, and only the true and false values will be selectable. Similarly, if you select a radio button type field, then only the equal and not equal operators will be available, however, the Values drop-down list will list all possible values for the radio button. You can then select either a field or static value to compare it against.

Both the General and the Advanced tab include the following buttons:

Code

Clicking the Code button opens the Code for Action <action> dialog box, where <action> represents the Action Name previously selected.

Cross Reference

Clicking Cross Reference will bring up a list of all of the objects that use the field.

OK

Click OK to apply the changes you made.

Cancel

Click Cancel to cancel the operation.


Define > Actions

Code Button

Clicking the Code button on the Action Properties window opens the Code for Action <action> dialog box, where <action> represents the Action Name previously selected. The following options allow you to create additional code statements for a specified Action.

Insert After

Insert a new code line after the currently selected line.

Insert Before

Insert a new code line before the currently selected line.

Clear

This command clears the current line.

Command

The Command window contains a tree structure of the various commands the user can select. Below is a brief description of each command.

ALERT

Display a message to the user in an alert box.

You can cause an alert box to display a Genesys Agent Scripting field or free form text.

CAPTURE

Capture the content of a page.

You can capture the content of a page to a field or free form text. It can then be used to create an e-mail, PDF, and so on. Capturing a page also captures any style sheets or images.

COMMAND

Execute static text, such as a Javascript statement, as a command in the target language, that is, ASP, ASPX, or JSP.

This field allows you to insert additional code in the target language.

COMMENT

This command allows the user to insert comments into the code.

DIM

This allows you to manually declare a variable. Variables do not normally need to be declared explicitly. However, declaring a variable manually can specify its type when it is ambiguous.

You can define a variable as a String, Boolean, DateTime, or Number.

EXECUTE

This command allows you to execute any predefined Genesys Agent Scripting functions.

The area to the right of the command list contains a table with the existing Genesys Agent Scripting actions.

IF

Execute the following code if the conditions indicated are true. Conditions can be the comparison of one field, variable, or static value to another field, variable or static value.

In an IF command, you can compare an Genesys Agent Scripting field or free form text to another Genesys Agent Scripting field, free form text, or a list of static values from a drop-down list or radio buttons using the operators listed in the screen above. Based on the results, the code entered in the lines after may or may not be executed.

ELSE

This command executes the following code if the proceeding IF condition is not true.

ELSEIF

This command allows you to have multiple conditional statements. If the preceding IF or ELSEIF statements were not true, then check to see if this condition is true and execute the following code if it is true.

ENDIF

This command is used to terminate an IF condition.

You need to place an ENDIF at the end of the IF statement.

RECALC

This command will recalculate the value for the specified Genesys Agent Scripting Function Field selected from the drop-down list.

RESPONSE

This field allows you to write a field, variable, or static text to the browser window.

SET

The command allows you to set a field or variable equal to a field, variable, or static value.

Selecting set allows you to set an Genesys Agent Scripting field or free form text equal to another Genesys Agent Scripting field, free form text, or static value from a drop-down list or radio buttons.

If you are working within a table, using the FOR EACH ROW command, additional options in the drop-down list are also available. You may also set the value for that row’s column or status equal to a field, variable, column, status, or static value where appropriate.

WHILE

This command allows you to execute following code while the conditions indicated are true. Conditions can be the comparison of one field or variable to another field, variable, or static value.

ENDWHILE

This command is used to terminate a WHILE condition.

You need to place an ENDWHILE at the end of the WHILE statement.

Async Commands

The Async Commands are described below.

GET ASYNC CLIENT ID

The async client id tells outside servers how to contact the session. This command allows you capture the async client id and save it to a field.

The async client id can either be saved to a field or as free form text entered when creating the action.

PULL VALUE

The PULL VALUE command takes the value of the Listener field and puts it in a regular Genesys Agent Scripting field. This is similar to having a field on the right side of the set command.

The value taken from the Listener field can either be saved to a Genesys Agent Scripting field or as free form text entered when creating the action.

PUSH VALUE

The PUSH Value command pushes the data into the Listener field on the server. This is similar to having a field on the left side of the set command.

SUBSCRIBE TO MESSAGE

Asynchronous interfaces allow you to send messages to everyone who is subscribed to a specific client id or subject. The SUBSCRIBE TO MESSAGE action command subscribes the user to the subject specified.

The subject can either be the contents of a particular field or free form text entered when creating the action.

UNSUBSCRIBE FROM MESSAGE

The UNSUBSCRIBE FROM MESSAGE action command unsubscribes the user from the subject specified. Once a user has been unsubscribed from a subject, he won’t receive any messages sent to that subject.

The subject can either be the contents of a particular field or free form text entered when creating the action.

Branch Commands

BRANCH

This command allows the user to transfer control to another script page.

Once the BRANCH command has been selected, you can then select the process flow, stream, and page to which to branch.

You can also branch to a field if the field is set to contain a process flow, stream, or page list. The value that the field gets set to will determine the page to which the system is directed.

GET CONTEXT

This command saves the current context to a field.

GET CURRENT PAGE

This command saves the current page value to a field.

GET CURRENT PROCESS FLOW

This command saves the current process flow value to a field.

GET CURRENT STREAM

This command saves the current stream value to a field.

NEXT PAGE

This command causes Genesys Agent Scripting to branch to the next script page. The next script page will either be the next page in the script, or a page referenced in a branching condition on the current page.

PREVIOUS PAGE

This command causes Genesys Agent Scripting to branch to the previous script page that was displayed.

RESTART

This command allows you to start a new session from the selected page.

Interface Commands

API INTERFACE

This command is used to execute custom code within Genesys Agent Scripting. When this command is selected the screen will be changed to provide a list of existing API Interfaces.

DATABASE INTERFACE

This command is used to run a database interface script. When this command is selected, the screen will be changed to provide a list of existing Database Interfaces.

XML INTERFACE

This command is used to run an XML Interface script. When this command is selected the screen will be changed to provide a list of existing XML Interfaces.

Session Commands

LOAD SESSION

This command will load a saved session based on the value of the field selected or text entered below.

This command is used in conjunction with the Save command and requires the same field to be selected or text entered in order to load the corresponding session.

SAVE SESSION

This command allows you to save a session. Saving a session will store all information (for example, call history, data entered, script navigation) in a temporary location. The information can be retrieved with the load command.

You should use the field list to associate a field value with the save option. This field value will be used to determine how the information is stored and retrieved with the load function. The value of this field needs to be able to uniquely identify the saved session. You can also use free form text to assign an identifier to uniquely identify the session to be saved.

CLOSE SESSION

This command will close the current browser window and remove the session.

Table Commands

ADD ROW

This command will cause a new row to be added to the selected table. Values for the new row will come from the current values in the fields associated with the columns in the table.

The Field drop own allows the user to select a table to which to add the row.

DELETE ROW

This command will cause the currently selected row in a table to be deleted.

FOR EACH ROW

This command allows the user to step through each row in a table. FOR EACH ROW can be nested for nested tables.

The user selects the table from a drop down list of Genesys Agent Scripting tables.

If the user iterates through the rows of a Genesys Agent Scripting table within an action, the user can access columns in the table using column or field references.

Field references should be used when iterating through a table and then executing another action from within that action.

Column references should be used if you subsequently have a Database Interface that updates based on the Genesys Agent Scripting table's flags, as the table flags are set based on column references and not field references.

EXIT FOR

This command allows the user to exit the FOR EACH ROW command before reaching the last row in the table.

NEXT ROW

This command allows the user to advance to the next row in a table.

The user needs to place a NEXT ROW at the end of the FOR EACH ROW statement.

GET TABLE ROW

This command will return the current table row.

GET TABLE SIZE

This command will return the number of rows in the table.

INSERT ROW

This command will cause a new row to be added to its table. Values for the row will be set to blanks for string fields and zero for numeric fields. Any values entered in the fields that make up the table but are not yet saved into the table will be cleared.

If the user wishes to insert a row with the current values of fields that are contained in the tables, use Add Row instead.

REMOVE ALL ROWS

This command allows the user to remove all rows from the specified table including any rows from child tables.

SET TABLE ROW

This command will set the current row in the specified table based on the value of the selected field.

UNSELECT ALL ROWS

This action will clear all rows from a table. This command will also clear all rows from any table that is contained within the target table.

UPDATE ROW

This command will cause the currently selected row in a table to be updated with the values in the fields associated with the columns in the table.

Previous Action

This button opens up the Previous Action definition for editing, prior to an Edit Action being issued.

Edit Action

This is used when an Execute command has been selected. It opens the definition of the Action for editing, which is the target of the Execute statement.

Functions

Whenever the right hand side drop down is set to Free Form, the Function button appears. This allows the user to insert a function into an action.

Clicking the Function button opens the User Defined Function Wizard dialog box.

Function

Select a function from the list. The items in the lists are taken from the functions created in the User Defined Functions option.

Template

This shows the user how the function looks and what information needs to be passed to it.

Next

Clicking Next opens a dialog box requesting a name for the variable.

Previous

This button will return the user to the previous dialog box.

Finish

This button will insert the function into the action.

Cancel

Clicking Cancel will close the dialog box without adding the user defined function to the action.

Cross Reference

The Cross Reference button allows the user to see where an action is being used.

Clicking the Cross Reference button opens the Object Cross Reference dialog box.


Define > XML Interfaces

XML Interfaces Overview

The XML Interfaces menu option is the seventh item in the Define menu. This item allows you to define an XML interface for posting and receiving information from other systems. When the user defines an XML interface, the corresponding Genesys Agent Scripting action(s) will automatically be generated.

Note: You need to create an action to invoke the XML Interface.

Selecting the XML Interfaces menu option opens the XML Interface List dialog box. This dialog box lists all XML interfaces that have been defined.

Reference Filter

This filter allows the user to display All, Unused, or Used objects in the List.

Add

Add creates a new interface. Clicking Add opens the XML Wizard dialog box.

Edit

Use the Edit button to edit XML Interfaces. In order to edit an XML Interface, you must select an interface from the XML Interface List and click Edit. When this option is selected, the XML Interface Properties will appear. The user can then edit any item on this dialog box.

Copy

This option allows the user to make a copy of an interface. Click Copy and a confirmation message will appear.

  • Click Yes to add a copy of the selected object to the XML Interface List.

  • Click No to close the dialog box without making a copy of the XML Interface.

Delete

Use the Delete button to delete interfaces. In order to delete an interface, you must select an interface from the XML Interface List and click Delete. The following confirmation message will appear:

  • Click No to cancel the delete.

  • Click Yes to continue.

When the user selects Yes, Genesys Agent Scripting will first verify that the interface to be deleted is not used anywhere in the system. If it is not being used anywhere else, it will be deleted. However, if any other object references the interface, the user will not be able to delete it at this time and a message will appear.

  • Click No to return to the XML Interface List dialog box.

  • Click Yes to open the Object Cross Reference dialog box.

Until all of the references are removed, you cannot delete the interface. Double-clicking on each reference will take the user to the selected object.

You may select multiple interfaces to be deleted by holding the Shift key while selecting the interfaces.


Define > XML Interfaces > XML Wizard

XML Wizard Overview

You have the option to create the following XML Interfaces described below:

  • File Save and Load

  • E-Mail

  • PDF

  • WSDL

  • Other (XML Interface Properties)

For ASP.NET there is security check that validates whether any request data contains any dangerous script code. Data containing html tags that is being sent via http is considered, by default, to be dangerous script code.

For example. If the contents of an e-mail contains html tags, then the browser will display a Server Error panel with an exception of System.Web.HttpRequestValidationException when the e-mail contents is sent to the Email XML Interface. This is also true for the PDF XML Interface where you can input html tag data. To prevent such data from being requested, the web administrator can disable the request validation in machine.config.


Define > XML Interfaces > XML Wizard

File Save and Load

The File Save and Load XML Interface option creates XML Interfaces to save fields and their contents to a flat file and load those fields and their contents from the same flat file into Genesys Agent Scripting. This option opens the XML File Interface Wizard dialog box.

Save Interface

Use the Save Interface field to provide a name for the interface that will save the contents of a field(s) to a file. This name will be shown on the Genesys Agent Scripting button associated with this XML interface.

Load Interface

Use the Load Interface field to provide a name for the interface that will load the contents of a flat file into Genesys Agent Scripting. This name will be shown on the Genesys Agent Scripting button associated with this XML interface.

File Name Value

You can choose between static and field values. If you select Static, then a file name must be provided. If you select Field, then a field must be provided. The file name will be determined by the contents of the field selected.

Note: If you select Static for the File Name value, then multiple users of the runtime generated pages would be writing to the same static file. This can lead to problems.

File Name

This field appears if you select Static in the File Name Value field. You should provide the name of the file where the data is to be stored.

Field

This field appears if you select Field in the File Name Value field. You should provide the field whose contents contain the name of the file where the data is to be stored.

Cancel

Click Cancel to stop the interface creation and close the dialog box.

Next

Click the Next button to continue creating the XML Interfaces. The next page of the XML File Interface Wizard opens.

Available Fields

This list contains all of the fields that have been created in Genesys Agent Scripting and are not already included in the Included Fields list.

Included Fields

This list contains the fields that you want included in the saved file.

Add All

Clicking this button will add all of the existing fields to the Included Files list.

Add

This button will add the selected field in the Available Fields list to the Included Fields list. Once a field is added to the Included Fields list, it is removed from the Available Fields list.

Remove

This button will remove the selected field from the Included Fields list and return it to the Available Fields list.

Remove All

This button will remove all of the fields from the Included Fields list and return them to the Available Fields list.

Previous

The Previous button will allow you to go back to the previous page to review or change the information.

Finish

The Finish button will create the File Save and Load XML Interfaces and display a confirmation message indicating that the XML Interfaces have been created.

Cancel

Click Cancel to stop the interface creation and close the dialog box.


Define > XML Interfaces > XML Wizard

E-Mail

The E-mail XML Interface option creates an XML Interface to provide the ability to send an e-mail from Genesys Agent Scripting. This option opens the XML E-mail Wizard dialog box.

If you add a table—for example, to serve as the body of an email—then following the table you must add an XML tag for every column in that table, so that the email will be received with the correct table format. The following tags provide examples of table formatting:

  • XML tag &endash; ”td”

  • type &endash; ”Column”

  • value &endash; ”Field from table”

E-Mail Interface Name

Use the E-mail Interface Name field to provide a name for the interface that will provide the ability to send an e-mail. This name will be shown on the Genesys Agent Scripting button associated with this XML interface.

Cancel

Click Cancel to stop the interface creation and close the dialog box.

Next

Click the Next button to continue creating the XML Interface. The next page of the XML E-mail Wizard opens.

SMTP Server Type

This field allows the user to choose the type of SMTP server from a drop-down list. The drop-down list has two choices: Port or Pickup Directory. If Port is selected, you must provide the SMTP Server name and Port. If Pickup Directory is selected, you must instead provide the Pickup Directory.

SMTP Server

You may either select static or field. If Static is selected, you need to provide the name of the SMTP Server. If Field is selected, you need to select the field that is set to contain the name of the SMTP Server.

SMTP Port

You may either select static or field. If Static is selected, you need to provide the port number for the SMTP Port. If Field is selected, you need to select the field that is set to contain the SMTP Port.

SMTP Directory

You may either select static or field. If Static is selected, you need to provide the Pickup Directory. If Field is selected, you need to select the field that is set to contain the SMTP Directory.

Previous

The Previous button will allow the user to go back to the previous page to review or change the information.

Cancel

Click Cancel to stop the interface creation and close the dialog box.

Next

Click the Next button to continue creating the XML Interface. The next page of the XML E-mail Wizard opens.

To

You may either select static or field. If Static is selected, you need to provide the e-mail addresses of the person(s) to whom the e-mail will be sent. If Field is selected, you need to select the field that is set to contain the e-mail addresses of the person(s) to whom the e-mail will be sent.

Cc

You may either select static or field. If static is selected, you need to provide the e-mail addresses of the person(s) to whom a copy of the e-mail will be sent. If Field is selected, you need to select the field that is set to contain the e-mail addresses of the person(s) to whom a copy of the e-mail will be sent. This field is optional.

Bcc

You may either select static or field. If static is selected, you need to provide the e-mail addresses of the person(s) to whom a copy of the e-mail will be sent. If Field is selected, you need to select the field that is set to contain the e-mail addresses of the person(s) to whom a copy of the e-mail will be sent. The e-mail addresses provided will not be visible to other recipients of the message. This field is optional.

From

You may either select static or field. If Static is selected, you need to provide the e-mail address from which the e-mail will be sent. If Field is selected, you need to select the field that is set to contain the e-mail address from which the e-mail will be sent.

Subject

You may either select static or field. If Static is selected, you need to provide the information to appear in the subject of the e-mail. If Field is selected, you need to select the field that is set to contain the information to appear in the subject of the e-mail.

Body

You may either select static or field. If Static is selected, you need to provide the information to appear in the body of the e-mail. If Field is selected, you need to select the field that is set to contain the information to appear in the body of the e-mail.

Attachment

You may either select static or field. If static is selected, you need to provide the file name of the attachment to be sent with the email. If Field is selected, you need to select the field that is set to contain the file name of the attachment to be sent with the e-mail. The file name specified must exist on the application server side. This field is optional.

Previous

The Previous button will allow the user to go back to the previous page to review or change the information.

Finish

The Finish button will create the E-mail Interface and will display a confirmation message indicating that the XML Interface has been created.

Cancel

Click Cancel to stop the interface creation and close the dialog box.


Define > XML Interfaces > XML Wizard

PDF

The PDF XML Interface option creates an XML Interface to enable creation of a PDF file. The conversion from HTML to PDF is done by HTMLDOC, a separate product covered by a separate license (the GPL) which is included because it may be useful to the users of Genesys Agent Scripting. Both binary and source code distributions of HTMLDOC are available.

This option opens the XML PDF Wizard dialog box.

PDF Interface Name

Use the PDF Interface Name field to provide a name for the interface that can be used to create a PDF file. This name will be shown on the Genesys Agent Scripting button associated with this XML interface.

PDF Source

You may either select static or field. If Static is selected, you need to provide the file to be converted to PDF. If Field is selected, you need to select the field that points to the file to be converted to PDF.

URL

You must select a field from the drop-down list. The field will contain the URL that points to the generated PDF file.

Runtime Location

You can enter the runtime location (or navigate to it using the Browse button), of the HTMLDOC PDF generation tool. This is the location as executed by the Web Server.

Finish

The Finish button will create the PDF Interface and will display a confirmation message indicating that the XML Interface has been created.

Cancel

Click Cancel to stop the interface creation and close the dialog box.


Define > XML Interfaces > XML Wizard

WSDL

The WSDL XML Interface option creates XML Interfaces to allow automatic importing from a URL of a web service definition into an XML interface. Genesys Agent Scripting will use the correct way to connect to the web service automatically. Currently SOAP is supported. This option opens the WSDL Import Wizard dialog box.

WSDL Import Wizard dialog box (WSDL Wizard page 1)

Field or Button | Definition
URL | Enter the location of the WSDL file to be imported. Note: This is the design-time URL; it can be different from the run-time URL.
Cancel | Click Cancel to stop the interface creation and close the dialog box.
Next | Click Next to continue creating the XML Interface. The next page of the WSDL Import Wizard opens.

WSDL Import Wizard page 2

Field or Button | Definition
Service | Select one of the services defined in the WSDL file.
Previous | Click Previous button to go back to the previous page to review or change the information.
Cancel | Click Cancel to stop the interface creation and close the dialog box.
Next | Click Next to continue creating the XML Interface. The next page of the WSDL Import Wizard opens.

WSDL Import Wizard page 3

Field or Button | Definition
Port | Select one of the ports defined in the WSDL file.
Previous | Click Previous to go back to the previous page to review or change the information.
Cancel | Click Cancel to stop the interface creation and close the dialog box.
Next | Click Next to continue creating the XML Interface. The next page of the WSDL Import Wizard opens.

WSDL Import Wizard page 4

Field or Button | Definition
Operation | Select an operation supported by the service/port combination chosen earlier.
Previous | Click Previous to go back to the previous page to review or change the information.
Cancel | Click Cancel to stop the interface creation and close the dialog box.
Next | Click Next to continue creating the XML Interface. The next page of the WSDL Import Wizard opens.

WSDL Import Wizard page 5

Field or Button | Definition
Name | Provide a name that Genesys Agent Scripting will use to refer to the XML Interface throughout the system.
Previous | Click Previous to go back to the previous page to review or change the information.
Finish | Click Finish to create the WSDL Interface and display a confirmation message indicating that the XML Interface has been created.
Cancel | Click Cancel to stop the interface creation and close the dialog box.


Define > XML Interfaces > XML Wizard > Other (XML Interface Properties)

XML Interface Properties Overview

Selecting Other allows you to create an XML Interface to communicate with other systems through XML. This option opens the XML Interface Properties dialog box.

Each of the objects on this dialog box is described below.

Interface

Use the Interface field to provide a name. This name will be shown on the Genesys Agent Scripting button associated with this XML interface.

Send and Receive Tabs

The Send and Receive tabs are used to display the XML tags that are defined for the post of the XML interface data.

Add

Use the Add button to add a new tag. The new tag will be added as a child to the tag currently selected.

Clicking the Add button opens the XML Tag dialog box. This dialog box has four tabs:

  • Tag Setup

  • Options

  • Table

  • Substring

Edit

Use the Edit button to modify existing XML tags. In order to edit an XML tag, you must select a tag in the Send or Receive tabs and click Edit. Selecting this option opens the XML Tag dialog box. You can then edit any item on this dialog box.

Delete

Use the Delete button to delete an XML tag from the list. Use caution when using the Delete button. When you delete a tag, all of its child tags are also deleted.

In order to delete an XML interface, you must select an XML tag and click Delete. A confirmation message will appear:

  • Click Yes to delete the tag or No to cancel.

WSDL

Click to trigger the XML Import Wizard for WSDL. This button is present only if the interface you are editing is of the type WSDL.

Import

Use the Import button to import a DTD or XSD (XML Schema) file. This function allows you to save a tremendous amount of time in defining an XML interface, and also helps prevent errors.

A DTD file is a file that defines the XML tags for the interface. An XSD file specifies how to formally describe the elements in an XML document. This description can be used to verify that each item of content in a document adheres to the description of the element in which the content is to be placed.

When you click on import a Windows Open File dialog box appears. Navigate to the DTD or XSD file for this XML interface and open it. The tags and many of their options that are defined in the DTD or XSD file will automatically be set up in Genesys Agent Scripting.

Look in

This drop-down list provides the user with the directory path in which the DTD or XSD to be imported into Genesys Agent Scripting exists.

File Name

This is the name of the DTD to be imported into Genesys Agent Scripting.

Files of Type

Select either DTD or XSD from the drop down list.

Cancel

Cancel closes the Import dialog box without importing the selected DTD or XSD.

Open

  • Click Open to import the selected DTD or XSD. A confirmation message will appear.

  • Click No to close the dialog box without importing the DTD or XSD.

  • Click Yes to begin the import process by allowing the user to select which element will be imported from the DTD or XSD. An import confirmation message will appear.

  • Click Yes to import the element into Genesys Agent Scripting and close the dialog box. You will not have the option to import any more elements from the DTD or XSD into the same interface without overwriting the tags that have already been imported.

  • Click No to not import the specified element into Genesys Agent Scripting. The system will then move on to the next element within the DTD and a similar window will appear. This process will continue until either the user clicks Yes for a specific element or the end of the DTD is reached.

  • Click Cancel to close the Import Element dialog box without importing the selected Element from the DTD.

Swap Send <-->Receive

Clicking this button will cause the contents of the Send tab to switch places with the contents of the Receive tab.

Settings

Click Settings to open the XML Settings dialog box.

Server URL

The Server URL is the address of the XML server that will handle this XML post. It is the beginning part of the URL.

Note: This is the design-time URL; it can be different from the run-time URL.

The drop-down list is populated with Genesys Agent Scripting configuration file fields. Select the field that contains the Server URL. It is not mandatory, but if left blank, the Server Name must contain the fully qualified URL for the XML Server.

Server Name

The Server Name is the name of the XML Server that will handle this XML post. It should be either the file name of the server or the fully qualified URL. This field is mandatory.

http://localhost/website/WWGEMail.asp is an example of a fully qualified URL.

DTD URL

The DTD URL is the location of the definition filed to be used for the XML post if one is required.

The drop-down list is populated with Genesys Agent Scripting configuration file fields. Select the field that contains the DTD URL. It is not mandatory, but if left blank, the DTD Name must contain the fully qualified URL for the DTD.

DTD Name

The DTD Name is the name of the definition file to be used for the XML post if a DTD is required.

XML Prefix

This is the XML declaration that appears at the top of an XML file. If the file has a prefix, it must contain ?xml, the XML version, the type of encoding, and whether or not the document needs an outside DTD.

Do Not Perform Any XML Preprocessing

If this box is selected, Genesys Agent Scripting will not perform any XML Preprocessing for this interface. This refers to the global preprocessing that occurs from the file WWGXMLPost.inc.

Enclose All Tag Values with CDATA Indicators

If this option is selected, all tag values will be enclosed with CDATA Indicators. This means that everything between the CDATA indicators is treated as raw data rather than XML (for example, < do not start tags).

Cross Reference

The Cross Reference button allows the user to see where an XML Interface is being used. Clicking the Cross Reference button opens the Object Cross Reference dialog box.


Define > XML Interfaces > XML Wizard > Other (XML Interface Properties)

Tag Setup Tab

The Tag Setup tab is used to set up the tag. Each of the values on this tab is described below.

XML Tag

The XML Tag is the tag name for the XML request or response. The tag name is case sensitive.

Type

The tag type is used to indicate the type of XML tag. Each of the types is described below.

  • Tag—This option is used to supply an XML tag with no value.

  • Filter—In order for this option to appear, you must define an attribute (by checking the attribute check box in the options tab) under the XML Receive tab, and assign it a static value. Genesys Agent Scripting will filter the return values looking for that attribute. Then, you can set up the response to load different fields based on the attribute’s value.

  • Static—This option is used to supply an XML tag with a static value. It only appears for the Send tab.

  • Field—This option is used to supply an XML tag with a Genesys Agent Scripting Field Value that is not a table. The field’s value will be sent as the value of a tag for a send, and the field’s value will be set in the case of a receive.

  • Table—This option is used when the tag’s value is from a Genesys Agent Scripting Table.

  • Column—This option appears when the tag is a child of a tag of type Table. You can then assign the value to one of the columns in the parent table.

Value

This field only appears when Static, Field, or Table is selected as the Type. For a Static Type, you can enter the value in the field. For a Field Type, you select a Field from the drop-down list of Genesys Agent Scripting Fields (excluding Tables). For a Table Type, select from a drop-down list of Genesys Agent Scripting Tables.


Define > XML Interfaces > XML Wizard > Other (XML Interface Properties)

Options TAB

The Options tab is used to set options for the tag.

Attribute

Check this box if this tag is an attribute for its parent tag instead of a child tag.

Optional

An optional tag will only be sent if it has a value.

Optional if Any Child Missing

This option allows an entire parent tag to be ignored if one of its children is missing its value.

Enclose value with CDATA indicator

If this option is selected, this tag’s value will be enclosed with CDATA Indicators. This means that everything between the CDATA indicators is treated as raw data rather than XML (for example, < don’t start tags).


Table Tab - XML Tag

Define > XML Interfaces > XML Wizard > Other (XML Interface Properties)

Table TAB

The Table tab is used to set row and column values for the tag.

Row

The row setting only applies to repeating groups and a tag in the send box. The possible values are defined below:

  • All Rows—If all rows are selected then all rows in a table will be sent.

  • Current Row—If current row is selected then only the current row or last row the user selected, will be sent.

  • Selected Rows—If selected row is selected then all selected rows in a multi-row table will be sent.

Select First Row on Returned Values

If selected, the first row in the table will be selected by default when the table is loaded.

Assign Value to Column

This option is important if the field for this tag points to a table. It is used in combination with the Column option below. This option indicates that there are no children tags to this tag. Then set the Column option to point at a column in this field’s table to determine the value for this tag.

Column

This option is important if the field for this tag points to a table. It is used in combination with the Use value from column option above. See the description of the Use value from column option for information regarding how to use this option.


Define > XML Interfaces > XML Wizard > Other (XML Interface Properties)

Substring Tab

The Substring tab is used to create substrings for fields.

Children Can Substring Value of This Field

If this option is checked, then children tags to this tag can be substrings.

Substring this Field

Substrings can be used to output partial values of a parent tag. For example, suppose the parent tag of this tag points to a telephone number. The substring start and length properties can be used to output parts of the telephone number field.

Start

The start value points to the position in the string you want the substring to start.

Length

The length value tells Genesys Agent Scripting the number of characters to place in this value. If you leaves the length value blank, Genesys Agent Scripting will output the value starting from the start value until the end of the string.


Define > Databases

Databases Overview

The Databases menu option is the eighth item in the Define menu. This option allows you to define a database for use by drop-down list and radio button field values and for database interfaces. Selecting the Database menu option opens the Database List dialog box

From this dialog you can edit or delete an existing database definition or add a new one.

Reference Filter

This filter allows the user to display All, Unused, or Used objects in the List.

Add

Clicking Add opens the Database Properties dialog box.

Edit

Use the Edit button to modify existing databases. In order to edit a database, you must select one from the database list and click Edit. When this option is selected, the Database Properties dialog box will appear. You can then edit any item on this window.

Copy

This option allows you to make a copy of a database. Click Copy and a confirmation message will appear.

  • Click Yes to add a copy of the selected object to the database list.

  • Click No to close the dialog box without making a copy of the database.

Delete

Use delete to remove a Genesys Agent Scripting Database from the list.

In order to delete a Database, you must select a database from the database list and click Delete. A confirmation message will appear:

  • Click No to cancel the delete.

  • Click Yes to continue.

When you select Yes, Genesys Agent Scripting will first verify that the database to be deleted is not used anywhere in the system. If the database is not being used anywhere else, it will be deleted. However, if any other object references the database, you will not be able to delete it at this time and a message will appear.

  • Click No to return to the Database List dialog box.

  • Click Yes to open the Object Cross Reference dialog box.

You may select multiple databases to be deleted by holding the Shift key while selecting the databases.

Until all of the references are removed, you cannot delete the database. Double-clicking on each reference will take you to the selected object.


Define > Databases

Database Properties

Each of the fields on in the Database Properties dialog box is described below.

Database Name

Enter a name for Genesys Agent Scripting to use when referring to this database when offering it as a choice in drop down lists or in radio button fields.

Database Type

Select the type of database from this drop-down list. The choices are: mySQL, Oracle, SQLServer, DB2, Other.

Development Connection

In this field, enter a connection string to be used by the Genesys Agent Scripting development environment to connect to the target database. This connection allows Genesys Agent Scripting to retrieve metadata (such as tables and columns) that describe the target database.

Provider

These two fields offer runtime settings which define where the provider should be taken from and the required provider specifics. The first field offers a drop-down list of two choices:

Static: This choice transforms the second field into a drop-down list that contains a single provider string—which corresponds to your choice in the Database Type field and should appear as a default. If necessary, you can also enter a string into this field; see the documentation provided with your database or ask the database administrator for its provider name.

Field: This choice transforms the data field below it into a drop-down list of fields, which allows you to specify different database access parameters for different target environments by changing the contents of the field. For example, you can set for different values for the ASPX target environment and for the JSP target environment simply by changing the contents of the field.

Runtime Connection

These two fields offer runtime settings which define the type of runtime connection and the required provider specifics. The first field offers a drop-down list of two choices:

Static: This choice transforms the second field into a text box where you must specify a connection string to be used by the generated Genesys Agent Scripting application at runtime. If you are unsure of the values to use in the runtime and development connection fields, speak with your database administrator.

Field: This choice transforms the second field into a drop-down list of database fields, which allows you to specify different database access parameters for different target environments by changing the contents of the field.

OK

Click This button is used to accept any changes and close the dialog box.

Cancel

Click This button is used to close the dialog box without accepting any changes.


Define > Database Interfaces

Database Interfaces Overview

The Database Interfaces menu option is the ninth item in the Define menu. The database interface allows you to set up connections to databases for Selecting, Updating, and Deleting rows of data. Selecting this option opens the Database Interface List dialog box.

From this dialog box you can edit and delete existing interfaces, as well as add new ones.

Reference Filter

This filter allows the user to display All, Unused, or Used objects in the List.

Add

Clicking Add opens the Database Interface Properties dialog box.

Edit

Use the Edit button to modify existing database interfaces. To edit a database interface, you must select one from the database interface list and click Edit. When this option is selected, the Database Interface Properties dialog box will appear. You can then edit any item on this window.

Copy

This option allows you to make a copy of a database interface. Click Copy and a confirmation message will appear.

  • Click Yes to add a copy of the selected object to the database interface list.

  • Click No to close the dialog box without making a copy of the database interface.

Delete

Use delete to remove a Genesys Agent Scripting Database Interface from the list.

To delete a Database Interface, the user must select a database interface from the database interface list and click Delete. A confirmation message will appear.

  • Click No to cancel the delete.

  • Click Yes to continue.

When you select Yes, Genesys Agent Scripting will first verify that the database interface to be deleted is not used anywhere in the system. If the database interface is not being used anywhere else, it will be deleted. However, if any other object references the database interface, you will not be able to delete it at this time and a message will appear.

  • Click No to return to the Database Interface List.

  • Click Yes to open the Object Cross Reference dialog box.

Until all of the references are removed, you cannot delete the database interface. Double-clicking on each reference will take you to the selected object.

You may select multiple database interfaces to be deleted by holding the Shift key while selecting the database interfaces.


Define > Database Interfaces > Database Interface Properties

Database Interface Properties Overview

The Database Interface Properties dialog box contains several items:

  • Interface

  • Database

  • Query Type

  • Query Tab

  • Add Query

  • Add Parameter

  • Add Table

  • Map

  • Add Column

  • Add Where

  • Edit

  • Delete

  • Result Tab

  • Settings

  • Cross Reference


Interface Name - Database Interface Properties

Define > Database Interfaces > Database Interface Properties

Interface

The Interface field contains the name for the Database Interface.


Define > Database Interfaces > Database Interface Properties

Database

This drop-down list is used for selecting the database for this query.


Define > Database Interfaces > Database Interface Properties

Query Type

There are three query types. Each is defined below.

Select

A select query is used to return rows from a table or group of tables in the selected database.

Update

An update query is used to add, update, or delete rows from a table or group of tables in the selected database.

Stored Procedure

A stored procedure query is used to pass values as input parameters to a stored procedure and to save any output or return parameter values to defined fields.


Define > Database Interfaces > Database Interface Properties

Query Tab

The Query Tab provides you with tasks that allow you to build custom queries in Genesys Agent Scripting.

The Query Tab includes the following tasks:

  • Add Query

  • Add Table

  • Add Column

  • Add Where

  • Add Parameter

  • Map

  • Edit

  • Delete


Define > Database Interfaces > Database Interface Properties

Add Query

The Add Query task is different depending on the selected Query Type.

Add Query for Select or Stored Procedure

Clicking Add Query when a Select or Stored Procedure query type is selected opens the Query Properties dialog box.

Query Name

In Genesys Agent Scripting, queries can be nested. In other words, you can create a single query that returns rows from one table. For each row, you can have a nested query that returns rows from another table and so on. To join a nested query, you may need to reference values from a higher-level query. In that case, the query name will be used to identify the query. Query names cannot contain spaces.

If a stored procedure query type is selected, then the Query Name must be the name of the stored procedure.

Record Limit

This option allows you to limit the number of records that the query returns. If the limit is 0, all records will be displayed. It is available for select and stored procedure queries.

Add Query for Update

Clicking Add Query when an Update query type is selected opens the Query Properties dialog box.

Query Name

In Genesys Agent Scripting, queries can be nested. In other words, you can create a single query that returns rows from one table. For each row, you can have a nested query that returns rows from another table and so on. To join a nested query, you may need to reference values from a higher-level query. In that case, the query name will be used to identify the query. Query names cannot contain spaces.

If a stored procedure query type is selected, then the Query Name property must be the name of the stored procedure defined in the database.

Update from Table

This option indicates that values for the query will come from a table. When this option is selected a Field drop-down list becomes active.

Use the Field drop-down list to indicate the table that will be used for this update. Each row in a table has a built in indicator managed by Genesys Agent Scripting that will structure the query for Inserts, Updates, and Deletes based on the actions of the users.

Update Type

If the Update from Table box is not checked, you must select an update type for this query. The valid choices are Update, Insert, or Delete.


Define > Database Interfaces > Database Interface Properties

Add Parameter

The Add Parameter task allows you to define input, output, and return parameters values for a Stored Procedure. It is only enabled if you set the Query Type as Stored Procedure (it replaces the Add Where task).

Clicking the Add Parameter task opens the Parameter Property panel. This panel includes the following functionality:

Direction

A drop-down list containing the direction of the parameter. The direction must match the direction of the corresponding parameter in the stored procedure. You can select one of the following values from the drop-down list:

Input—Defines the parameter as an input.

Output—Defines the parameter as an output.

Input/Output—Defines the parameter as both input and output.

Return Value—Defines the parameter as a return value. A Stored Procedure that returns a value must define the first parameter with the Direction set to Return Value. There can be only one Return parameter.

SQL Type

A drop-down list containing the SQL type of the parameter. It must match the type of the corresponding parameter in the Stored Procedure. You can select one of the following values from the drop-down list:

INTEGER—Parameter is an integer value

FLOAT—Parameter is a float value

VARCHAR—Parameter is a variable or fixed-length character set value

CURSOR—Parameter is a cursor that represents multiple table rows, for example, from a SQL query

DATE—Parameter is a Date value

TIMESTAMP—Parameter is a Date and Time value

BIGINT—Parameter is a big integer value (see the note below)

SMALLINT—Parameter is a small integer value

DOUBLE—Parameter is a double value

REAL—Parameter is a real value

DECIMAL—Parameter is a decimal value

TIME—Parameter is a Time value

Note: Genesys Agent Scripting partially supports mapping the DB2 BIGINT data type in the Database Interface. It is supported with the following exceptions.

  • Cannot create a Database Interface with a Where clause referencing a BIGINT column.

  • Cannot create a Database Interface that performs an Insert or Update specifying a value for a BIGINT column.

Parameter Name

This is the name of the parameter specified in the Stored Procedure.

Value Type

A drop-down list containing the type of the value. If the direction is an input then this field defines whether the input value of the parameter is either a specific value or is the contents of a specific field. If the direction is an output or return value, then the Value Type must be Field in order to define which field is to contain the output/return parameter value. This field is disabled for a parameter whose SQL Type is set to CURSOR. An output CURSOR parameter can be saved to a Table field by adding a Database Table and its associate columns to the Database Interface, matching results from the cursor, and mapping it to a Genesys Agent Scripting Field of type Table.

Field

This field displays when you select Field as the Value Type. Select the field whose content is to be passed as an input parameter or the field that is to contain the value of an output/return parameter.

Value

This field appears if one selects Value as the Value Type. In this field you can set a hard-coded value for an input parameter.

Although generally, Genesys Agent Scripting supports calls to Stored Procedures, the following restrictions apply:

  • Input cursor parameters are not supported.

  • Only one output cursor parameter can be defined.

  • For Database provider System.Data.SqlClient and System.Data.OracleClient, all input and output parameters must be defined with parameter names.

  • For Database provider System.Data.OracleClient, a returned cursor parameter is not supported.

  • For OLEDB access to Oracle prior to version 9.2.0.4.0, timestamp parameters are not supported.

  • The cursor output/returned parameter is only supported for the Oracle database.


Define > Database Interfaces > Database Interface Properties

Add Table

Selecting Add Table opens the Query Properties dialog box for tables.

Table

The Table drop-down list will contain a list of the tables contained in the selected database. Table names cannot contain spaces. Table names with spaces will not appear in the drop-down list.

Key Column

For Update type queries, you must tell Genesys Agent Scripting which column in the table can be used to uniquely identify rows to update by selecting a column from this drop down. Column names cannot contain spaces. Column names with spaces will not appear in the drop-down list.

A table may be added multiple times to gain more control over the sort order of results.


Define > Database Interfaces > Database Interface Properties

Map

Clicking the Map task opens the Database Table/Column Map dialog box. From this dialog box, you can map between the results/columns of a query and Genesys Agent Scripting fields.

The left-side of the screen shows a tree with the tables and columns for a query as well as the Genesys Agent Scripting fields to which each column is mapped. If the query is selected, the following options become active on the right-side of the screen.

Query Mapping (select info)—Select Queries

This option allows you to map the values returned by the SQL query to a Genesys Agent Scripting table. In order to do so, select the table field to which to map the results from the drop-down list.

This option is useful if the query is returning more than one record from the database.

Query Mapping (update from)—Update Queries

This option allows you to map where the values in the database are being updated from. Available choices are Insert, Update, and Delete, as well as any predefined Genesys Agent Scripting table fields.

Result Mapping

Result Mapping is used on update queries for returned values. An update query might return multiple values if you are inserting data from a Genesys Agent Scripting table. Each insertion of data generates a key. You can set the result mapping to a table. This results in the key mapping in the table section to just show columns within that table.

Result Code

This option allows you to map the numeric result code returned by the SQL query to a Genesys Agent Scripting field. In order to do so, select the Field to which to map the result code from the drop-down list.

Result Description

This option allows you to map the result description returned by the SQL query to a Genesys Agent Scripting field. In order to do so, select the field to which to map the result description from the drop-down list.

SQL Command

This option allows you to map the SQL query that was executed to a Genesys Agent Scripting field. In order to do so, select the field to which to map the SQL command from the drop-down list.

Add Table

This option allows you to add a table to the query as described above. Clicking this button opens the Table Properties dialog box.

Edit Field List

Clicking this button opens the Field List dialog box. From this window, fields can be added, edited, or deleted.

If a table is selected in the tree, the following options are available on the right-side of the screen.

Edit Table

This option allows you to edit the selected table. Clicking the buttons opens the Table Properties dialog box.

Key Mapping

This field is only active for update queries. Each insertion of data into the database generates a key. This field lets users map the contents of a Genesys Agent Scripting field as the key. The drop-down list allows you to select which fields should generate the key. If the update query is inserted from a Genesys Agent Scripting table, the key mapping field will only allow you to select from columns within that table.

Add All Columns

This option allows you to add all columns from the selected table to the query as described above. Clicking the Add All Column opens the Column Properties dialog box. If a column has already been added to the table query, it will not add it a second time.

Add A Column

This option allows you to add a column to the selected table in the query as described above. Clicking Add A Column opens the Column Properties dialog box.

Remove Unmapped Columns

This option to remove any unmapped columns from the query. Results will no longer be returned for those columns.

Edit Field List

This option opens the Field List dialog box. From this dialog box, fields can be added, edited, or deleted.

Map Type

This option tells you the type of mapping that occurs. Database columns can be mapped to Columns or Fields. If multiple rows are being returned and the results written to a Genesys Agent Scripting table field, the database columns should be mapped to columns in the Genesys Agent Scripting field. If a single result is returned, database columns should be mapped to fields.

Field Group

This option filters the field list based on the group. Select the field group from the drop-down list and the Field list will only display those fields that belong to the selected group.

Field

This option lists all of the possible Genesys Agent Scripting fields to which the selected column may be mapped. Select a field from the list and the column will be mapped to it.

To unmap a column, select [Not Mapped] from the list.

Edit Column

This option allows you to edit the selected column. Clicking this option opens the Column Properties window.


Define > Database Interfaces > Database Interface Properties

Add Column

The Add Column task is different depending on the selected Query Type.

Add Column for Select or Stored Procedure

To select this option, the user must first add a table to the query. Select a table in the tree view from the Database Interface Properties dialog box and then click Add Column. Clicking Add Column when a Select or Stored Procedure query type is selected opens the Column Properties dialog box.

Table

This field refers to the currently selected table in the Database Interface Properties dialog box.

Column

This field contains a drop-down list of the columns contained in the selected table. You must select a column before continuing. Column names cannot contain spaces. Column names with spaces will not appear in the drop-down list.

Alias

This field allows you to assign an alias for the data in the selected column.

Grouping

This option allows you to group items in a SQL query in order to perform counts or sums.

Add Column for Update

To select this option, you must first add a table to the query. Select a table in the tree view from the Database Interface Properties dialog box and then click Add Column. Clicking Add Column when an Update query type is selected opens the Column Properties dialog box.

Table

This field refers to the currently selected table in the Database Interface Properties dialog box.

Column

The field contains a drop-down list of the columns contained in the selected table. You must select a column before continuing. Column names can not contain spaces. Column names with spaces will not appear in the drop-down list.

Value Type

For this field, valid value types are field or value. If you select Field from the drop-down list, the value for this column is from a field. If Value is selected, the value is a static value.

Field

Depending on value type, this will either be a drop down list of existing Genesys Agent Scripting fields or a static value that you can enter.

Show All Fields

This button only appears for Update from table queries. For queries of this type, you select a Genesys Agent Scripting table to map to back to the database to be updated. When you then add a column to the query, the list of columns only contains those choices that are in the Genesys Agent Scripting table. The show all fields button will change the drop-down list so that it contains all Genesys Agent Scripting fields rather than just those contained in the selected table.


Define > Database Interfaces > Database Interface Properties

Add Where

This option is used to place conditions on the query. You can have from zero to many where clauses for a query. Selecting this option opens the Where Properties dialog box.

Join Type

Join type indicates how the rows in the query will be joined together. Each of the values is described below.

Static Value

You will provide a static value used to select rows from the indicated table.

Field

The value from a Genesys Agent Scripting field will be used to select rows from the indicated table.

Join

The values from another table and column in the selected database will be used to select rows from the table.

Parent Join

This option is only valid in a nested query. This option allows the user to join rows in this table with a column value from a higher level query.

Table

This field contains a drop-down list of the tables in the selected database. You then select a Table from this list to be joined in this query.

Column

This field contains a drop-down list of columns within the selected table.

Operator

This field allows you to select the type of join. It contains a drop-down list of operators such as =, >, <, and Like.

If using the Like command to search for partial strings, the percent sign (%) indicates a wild card character when entered in a field.

Join to Table

This value is only valid if the join type is set to Join. In this case, you select another table from the drop-down list of tables in the database that is part of this query.

Join to Column

You select a column within the Join to Table or parent column in a nested join from the drop-down list.

Value

This field can contain either a static value or a Genesys Agent Scripting field.

Use as OR Condition

Database queries can have OR conditions. This is done by checking a box in the WHERE dialog box. Conditions will be grouped together based on the order in the tree.

For example, if you have the following conditions:

WHERE A = B

WHERE C = D <-- (Use as OR condition is checked)

WHERE E = F

The result will be:

WHERE (A = B OR C = D) AND E = F

When checked, the Use as OR condition applies to the WHERE condition that has been checked and the one immediately preceding it.

Optional

If this box is checked and the Join Type is set to Field, the Where clause will be dropped if the value of the field is an empty string. This allows for a query to be setup with multiple optional queries for searches. The actual query will be resolved at runtime.


Define > Database Interfaces > Database Interface Properties

Edit

From the Query Tab

Use the Edit option to edit any of the database interface queries. The appropriate dialog box will be displayed when you click Edit.

From the Result Tab

Use the Edit option to edit any of the result properties except for parameters. The appropriate dialog box will be displayed when you click Edit.


Delete - Database Interface Properties

Define > Database Interfaces > Database Interface Properties

Delete

Use the Delete option to delete an element in the Query tab and all of it sub elements. Clicking Delete opens a confirmation message.

  • Click No to cancel the delete.

  • Click Yes to delete the tag and its children.


Define > Database Interfaces > Database Interface Properties

Result Tab

The Result tab includes the following tasks:

  • Edit

Results from a database query are defined based on the Query tab. Results are returned to Genesys Agent Scripting in an XML format. The Result tab works identically to the XML Interface Send and Receive tabs defined under the XML Interface dialog box with only one difference. The user cannot add or delete tags. Tags are created based on the query definition.


Settings - Database Interface Properties

Define > Database Interfaces > Database Interface Properties

Settings

Clicking the Settings task opens the XML Settings dialog box.

Server URL

The Server URL is the address of the XML server that will handle this XML post.

Note: This is the run-time URL; it can be different from the design-time URL.

Server Name

The Server Name is the name of the XML Server that will handle this XML post.

DTD URL

The DTD URL is the location of the definition filed to be used for the XML post if one is required.

DTD Name

The DTD Name is the name of the definition file to be used for the XML post if a DTD is required.

XML Prefix

This is the XML declaration that appears at the top of an XML file. If the file has a prefix, it must contain ?xml, the XML version, the type of encoding, and whether or not the document needs an outside DTD.

Do Not Perform Any XML Preprocessing

If this box is selected, Genesys Agent Scripting will not perform any XML Preprocessing for this interface.

Enclose All Tag Values with CDATA Indicators

If this option is selected, all tag values will be enclosed with CDATA Indicators. This means that everything between the CDATA indicators is treated as raw data rather than XML (for example, < don’t start tags).


Define > Database Interfaces > Database Interface Properties

Cross Reference

The Cross Reference button allows the user to see where a Database Interface is being used. Clicking the Cross Reference button opens the Object Cross Reference dialog box.


Define > API Interfaces

API Interfaces Overview

The API Interface menu option is the tenth item in the Define menu. Selecting this option opens the API Interface List dialog box.

From this dialog box, you can edit, copy, and delete existing API interfaces, or add new ones.

Reference Filter

This filter allows the user to display All, Unused, or Used objects in the List.

Add

Clicking Add opens the Edit Interface dialog box.

Edit

Use the Edit button to modify existing API interfaces. To edit an API interface, you must select one from the API interface list and click Edit. Selecting this option opens the API Interface Properties dialog box. You can then edit any item on this dialog box.

Copy

This option allows you to make a copy of an API interface.

Delete

Use delete to remove a Genesys Agent Scripting API Interface from the list.

To delete an API Interface, you must select an API interface from the API Interface List and click Delete. A confirmation message will appear.

  • Click No to cancel the delete.

  • Click Yes to continue.

When you select Yes, Genesys Agent Scripting will first verify that the API interface to be deleted is not used anywhere in the system. If the API interface is not being used anywhere else, it will be deleted. However, if any other object references the API interface, you will not be able to delete it at this time and a message will appear.

  • Click No to return to the API Interface List dialog box.

  • Click Yes to open the Object Cross Reference dialog box.

Until all of the references are removed, you cannot delete the API interface. Double-clicking on each reference will take the user to the selected object.

You may select multiple API Interfaces to be deleted by holding the Shift key while selecting the API Interfaces.


Define > API Interfaces > Edit Interface

Edit Interface Overview

The Edit Interface dialog box contains several items:

  • Interface Name

  • Include File Base Name

  • Field

  • Variable

  • Add

  • Update

  • Delete

  • Send Tab

  • Receive Tab

  • ASP Source Code Tab

  • ASPX Source Code Tab

  • JSP Source Code Tab


Interface Name - Edit Interface

Define > API Interfaces > Edit Interface

Interface Name

The Interface Name field contains the name for the API Interface.


Define > API Interfaces > Edit Interface

Include File Base Name

This field allows you to add an Include file to a call code outside of Genesys Agent Scripting. Include files are files required to support the API function.


Field - Edit Interface

Define > API Interfaces > Edit Interface

Field

Select a Genesys Agent Scripting field to associate it to a variable. This field is only active if the Send tab or Receive tab is selected.


Define > API Interfaces > Edit Interface

Variable

Enter a variable name associated with the selected field. The Variable field only appears if the Send tab or Receive tab is selected.


Add - Edit Interface

Define > API Interfaces > Edit Interface

Add

Clicking Add will enter the Interface Name, Field, and Variable information into the appropriate tab (Send or Receive).


Update - Edit Interface

Define > API Interfaces > Edit Interface

Update

Clicking Update will update changes made to the Interface Name, Field, and Variable information into the appropriate tab (Send or Receive).


Delete - Edit Interface

Define > API Interfaces > Edit Interface

Delete

Clicking Delete allows you to delete selected rows from the Send or Receive tab.

A confirmation message appears.

  • Click Yes to delete the selected row or No to cancel.


Define > API Interfaces > Edit Interface

Send Tab

The Send tab is used to define variables that will receive values from Genesys Agent Scripting fields prior to the API function being executed. These variables must be defined in the called function.


Define > API Interfaces > Edit Interface

Receive Tab

The Receive tab is used to define variables that will send data to Genesys Agent Scripting fields after the execution of the API function.


Define > API Interfaces > Edit Interface

ASP Source Code Tab

The ASP Source Code tab is used to define the code that the API Interface will execute for ASP target environments. Write this code using Visual Basic.


Define > API Interfaces > Edit Interface

ASPX Source Code Tab

This tab is used to define the code that the API Interface will execute for ASPX target environments. The code should be written in C#.


Define > API Interfaces > Edit Interface

JSP Source Code Tab

This tab is used to define the code that the API Interface will execute for asp target environments. The code should be written in Java.


Define

Async Interfaces

Async Interfaces allow users to listen for events and update the contents of a page without refreshing the page.

From the Async Interface List screen, you can edit, copy, and delete existing Async Interfaces, or add new ones.

Reference Filter

This filter allows the user to display All, Unused, or Used objects in the List.

Add

Click Add and the Async Interface Properties dialog box displays. It includes the following fields:

Interface

This is the async interface name.

Setup

Clicking the setup button will cause an outline of an async interface to be created. You then must assign the appropriate listener and data fields to the interface.

When you select either the listener or data tag, an Add button displays at the bottom of the screen. This allows the user to assign fields to the tags.

Clicking Add allows you to specify listener or data fields.

Adding a listener field to the interface will cause the Async Listener Field dialog box to appear. The drop-down list contains fields of these types: listener, string, multiline text, numeric, date and time.

If the Automatically Assign Listener Name check box is selected, the selection that you make in the Field drop-down list appears automatically in the Name field. You can edit this result if you wish.

Name

This is the tag name as it appears in the Async Interface.

Field

This is the name of the listener field to be added.

Adding data fields causes the XML Tag window to appear. For more details about the XML Tag window, see XML Interface section.

Once the listener and data fields have been added to the interface, you have the ability to add new ones, as well as edit or delete ones that have already been added.

Edit

The edit button allows you to edit listener or data fields that are already a part of the interface.

Delete

The delete button allows you to remove listener or data fields from the interface.

Note: Be careful when using the same fields on pages and in Async Interfaces. Forms are processed after the async values are received. Because of this, the values updated by the Async Interface will be overwritten by the field’s value in the form.

Edit

Use the Edit button to modify existing Async Interfaces. To edit an Async Interface, you must select one from the Async Interface List and click Edit. When this option is selected, the Async Interface Properties window will appear. You can then edit any item on this screen.

Copy

This option allows you to make a copy of an Async interface.

Delete

Use delete to remove a Genesys Agent Scripting Interface from the list.

To delete an Async Interface, you must select an Async Interface from the Async Interface List and click Delete.

  • Click No to cancel the delete.

  • Click Yes to continue.

You may select multiple Async Interfaces to be deleted by holding the Shift key while selecting the Async Interfaces.

Async Code Commands

Asnyc commands are available in the Code for Action screen.


Define > Catalogs

Catalogs Overview

A Catalog is where the page navigation information is stored. Selecting this option opens the Catalog List dialog box.

Add

Clicking Add opens the Catalog Properties dialog box.

Edit

You may edit existing catalogs by selecting a catalog from the list and clicking the Edit button in the Catalog List dialog box. This opens the Catalog Properties dialog box.

Copy

You may create a copy of the selected catalog by clicking the Copy button. Doing so will cause a confirmation message to appear.

  • Click No to cancel the copy.

  • Click Yes to create a copy.

Delete

You can delete a catalog by selecting a catalog in the Catalog List dialog box and clicking the Delete button. This will cause a confirmation message to appear.

  • Click Yes to delete the selected catalog.

  • Click No to cancel the delete.


Define > Catalogs

Catalog Properties

Each of the fields on the Catalog Properties dialog box is defined below.

Catalog

The catalog name is used to identify the catalog within Genesys Agent Scripting.

Description

The description is for informational purposes only. This field is not used anywhere else is the system.

Include Current Process Flow\Stream Pages in a Link Section

The catalog has a link section at the top that contains all pages in the current script. Turning off this setting will suppress this section of the catalog. If this setting is turned off, only selected pages will appear in the catalog.

Link Section Title

If the Include Current Process Flow\Stream Pages in a Link Section is checked, then this field becomes active. It allows the user to provide a section title that will appear in the catalog.

Include Other Links Section

This allows you to create a section in the catalog for other links.

Other Links Section Title

If the Include Other Links Section is checked, then this field becomes active. It allows you to provide a section title that will appear in the catalog.

Dynamically Add and Remove Pages from a Catalog

Select this checkbox to enable the catalog to duplicate changes that the user makes in the editor (add, delete, and move pages).

Process Flows

You can select which process flows shall appear in the catalog. Once an item is selected, you can drag and drop it into the Catalog field.

Streams

You can select which streams shall appear in the catalog. Once an item is selected, you can drag and drop it into the Catalog field.

Pages

You can select which pages shall appear in the catalog. Once an item is selected, you can drag and drop it into the Catalog field.

Catalog

This shows the items that will appear in the main section of the catalog.

Other Links (Process Flows)

This shows the links that will appear in the Other Links section. Only Process Flows may be added to the Other Links section.

Expandable Tree Format

This is selected by default. When selected, the links in the catalog section of the browser appear in a tree format. If this option is not selected, all of the links appear in a list.

Include Current Page Indicator

This option only becomes active when the Expandable Tree Format option is not selected. This option causes a pointer to appear next to a link in the catalog, indicating which page the user is currently viewing.

Add All Pages

This button will add all Pages in the Project Book to the catalog. This is useful when initializing a catalog (for example, setting up a default that contains all Pages).

Remove from Catalog

This button will remove the highlighted (selected) item from the Catalog.

Remove from Other Links

This button will remove the highlighted (selected) Process Flow from the Other Links section.

Note: The delete key can no longer be used to remove items from the Catalog or Other Links section.

OK

Click OK to create the new catalog or save changes to the existing catalog and close the Catalog Properties dialog box.

Cancel

Cancel closes the Catalog Properties dialog box without creating the new catalog or saving any changes made to an existing catalog.


Define > Templates

Templates Overview

Use the Templates option to import script page templates. Templates are useful to set a common look and feel for all script pages. A Template is an html file that is imported into Genesys Agent Scripting. The HTML file can be set up to have the basic formatting the user wants to have on each page. Selecting this option opens the Template List dialog box.

Preview Template

Use the Preview Template button to view the template.

Add

Use the button to add new templates. Clicking Add will open the Template dialog box.

Edit

Use the Edit button to modify existing templates. To edit a template, you must select one from the template list and click Edit. When this option is selected, the Template dialog box will appear. You can then edit any item on this window.

Delete

Use the delete button to delete an existing template. A confirmation message appears.

  • Click Yes to delete the template or No to cancel.

Deleting a template does not affect script pages that used this template. It only prevents its use in the future.

You may select multiple templates to be deleted by holding the Shift key while selecting the templates.


Define > Templates

Template

Each of the fields on the Template dialog box is defined below.

Name

The Name field is used to identify the template. This name will appear in the template drop down in the Page Properties dialog box.

Edit Html

The Edit HTML button allows you to access all HTML that makes up the page. Selecting this option opens the Edit HTML dialog box.

View HTML

This button will allow you to directly access and edit the HTML code. Clicking View HTML opens an Edit HTML dialog box for updates.

From this dialog box, the user can directly edit the HTML code.

Update HTML

Clicking this button will save any changes you have made to the HTML code. The HTML Layout will reappear so that the user can see the impact of any changes that were made.

Cancel

Clicking Cancel will return the user to the previous dialog box without saving any changes made to the HTML.

Import

Clicking Import will take you to a Select Template dialog box. Navigate to the template file and select it. It will automatically be imported.

Look in

This drop-down list provides you with the directory path in which the template to be imported exists.

File Name

This is the name of the template to be imported.

Files of Type

This field cannot be changed. All templates are of the type Page Template(*.html).

Open

Click Open to import the selected template.

Cancel

Cancel closes the Select Template dialog box without importing the selected template.


Custom Fields Types

Define > Custom Field Type

Custom Field Type Overview

Custom Field Type allow you to define field types that are specific to their needs. For each custom field type, you can determine which of the target languages (ASP, ASPX, JSP) are supported, as well as how the field will be displayed and how it will process form data for the supported languages.

The Custom Field Type List dialog box provides the following features:

Field Name or Button Name | Description
Reference Filter drop-down list | Use to select an existing Reference Filter.
Add | Use this button to define new custom field types. Clicking this button opens the Custom Field Type Properties dialog box.
Edit | Use to display the Custom Field Type Properties dialog box for a selected Property.
Copy | Use to copy an existing Reference Filter.
Delete | Use the Delete button to delete an existing custom field type.
Close | Use to close the Custom Field Type List.

When the Add or Edit buttons are selected, the Custom Field Type Properties dialog box displays. It includes the following tabs:

  • Definition

  • Properties

  • ASP Rendering

  • ASPX Rendering

  • JSP Rendering

  • ASP Form

  • ASPX Form

  • JSP Form


Define > Custom Field Type > Custom Field Type Properties

Custom Field Type Properties Overview

Custom Field Type properties provide the user with a variety of ways to define custom field types.

The Custom Field Type Properties dialog box provides the following tabs:

  • Definition

  • Properties

  • ASP Rendering

  • ASPX Rendering

  • JSP Rendering

  • ASP Form

  • ASPX Form

  • JSP Form


Definition

Define > Custom Field Type > Custom Field Type Properties

Definition Tab

The Definition tab is the default view of the Custom Field Type Properties dialog box. This tab allows you to define the custom field type with respect to its Genesys Agent Scripting behaviors. It includes the following features:

CFT Name: This field is used to identify the Custom Field Type within Genesys Agent Scripting. It will appear in the CFT List window as well as the Custom Type to in the Field Properties window. A CFT Name must be unique and cannot contain any spaces.

Data Type: This field describes how the data is stored internally within the session. Select one of the following Data Types from the drop-down list: String, Numeric, Date and Time, or Boolean.

Dev. HTML: The Development (Dev.) HTML field allows you to define how the custom field type looks within the editor. An example of Dev. HTML code is:

<input size=%size% value="test">

The Dev. HTML generally works in the same manner as conventional HTML. The only difference is that properties defined in the Properties tab can be assigned to attributes in a tag. To do this, the property must be enclosed by the % (percent sign), as seen by the size attribute and its assigned property in the example above: <input> tag.

You may only enter one top level node in the Dev. HTML field. The end tag must either correspond to the first tag as in <table> and </table> tags or there is only one tag with no end tag as in the <input> tag example shown above.

Cross Reference: Clicking Cross Reference opens the Object Cross Reference dialog box.

The Object Cross Reference dialog box lists all fields that reference the Custom Field Type. From the object list, double-click on a field to display the field’s properties.


Define > Custom Field Type > Custom Field Type Properties

Properties Tab

After a Custom Field Type has been defined, you must specify the set of properties that exists for that custom field type.

Use the Properties tab to define properties describing the behavior of the Custom Field Type both within Genesys Agent Scripting and in the defined target languages.

When referenced in the Dev. HTML field in the Definition tab, properties are enclosed by the percent sign %. The getProp() function call is used to reference properties in the ASP, ASPX, and JSP rendering and Form tabs.

Add

Click the Add button to display the Custom Field Type Property window to the Definition tab.

Custom Field Type Property Window

The default tab in this view is the Definition tab.

Definition Tab

This tab includes the following features:

Property Name: Use for the Property name. Follow these rules when naming properties:

  • Must be unique within the Custom Field Type

  • Cannot contain spaces

  • Cannot contain special characters

Property Type: Use to describe the property's value, which is set in the Custom Type tab of the Field Properties window for the instance of the Custom Field type.

Property Default: Sets the default value for the property. Select a value from the Property type drop-down list.

Use Default for Invalid Values: If this box is selected, the default value entered in the Property Default field becomes the properties value if an invalid one is entered in the Custom Type tab of the Field Properties.

Property Description: Use to enter a description of a property. This is for the customer's reference only. The description is not found anywhere else in the system.

List Values Tab

The List Values tab becomes active only if the Property Type is set to List.

List Values

Use this field to maintain a set of items to select in the Property Defaults field and in the Custom Type tab of the Field Properties.

To create a list, enter the values in this field and select Return between each item in the list.

Edit

Click Edit to display the Custom Field Type Property window for a selected Property.

Delete

Click Delete to delete a selected Property.


Define > Custom Field Type > Custom Field Type Properties

ASP Rendering Tab

Use this tab to determine how the field will look when it is compiled into ASP code when viewed in a web browser. The ASP Rendering Code is Visual Basic code that takes in as arguments the session variable for the instance of the Custom Field Type, the field identifier, and the display only indicator. The field identifier is a unique value determined by Genesys Agent Scripting to identify a field and is prepended to any form variables. This is an example of code that might be entered in the ASP Rendering tab.

<%

Function CFTRR_My_New_Type(sess_var, field_identifier, disp_only)

Dim html

'This code should be written in VBScript and should return

'the HTML as a string to render the field.

'Make sure if you prepend field_identifier to any form element names.

'Use code similar to getProp(field_identifier, "prop_name") to get CFT properties.

If disp_only = 1 Then

'Display only, so just print session variable:

html = sess_var

Else

'The next lines of code creates a text box and sets its initial value based on the session variable:

html = "<input name='" & field_identifier & "val1'"

html = html & " size=" & getProp(field_identifier, "size")

html = html & " value='" & sess_var & "'>"

End If

CFTRR_My_New_Type = html

End Function

%>

This function creates an <input> tag containing the name, size, and value attributes.

Properties defined in the Properties tab can be assigned to attributes in a tag in the ASP Rendering code. To do this, the property is referenced by the getProp() function call, as seen by the size attribute and its assigned property above in the example code.


Define > Custom Field Type > Custom Field Type Properties

ASPX Rendering Tab

This tab determines how the field will look when compiled into ASPX code when viewed in a web browser.

The ASPX Rendering Code is C# code that takes in as arguments the session variable for the instance of the Custom Field Type, the field identifier, and the display only indicator. This is an example of code that might be entered in the ASPX Rendering tab.

<script language="c#" runat="server">

String CFTRR_My_New_Type(String sess_var, String field_identifier, int disp_only)

{

String html = "<input name='" + field_identifier + "val1'";

html = html + " size=" + getProp(field_identifier, "size");

html = html + " value='" + sess_var + "'>";

if (disp_only == 1)

return sess_var;

else

return html;

}

</script>

This function creates an <input> tag containing the name, size, and value attributes. Properties defined in the Properties tab can be assigned to attributes in a tag in the ASPX Rendering code. To do this, the property is referenced by the getProp() function call, as seen by the size attribute and its assigned property above in the example code.


Define > Custom Field Type > Custom Field Type Properties

JSP Rendering Tab

This tab determines how the field will look when compiled into JSP code when viewed in a web browser.

The JSP Rendering Code is Java code that takes in as arguments the session variable for the instance of the Custom Field Type, the field identifier, the display only indicator, the HttpServletRequest, and the HttpServletResponse. This is an example of code that might be entered in the JSP Rendering tab.

String CFTRR_My_New_Type(String sess_var, String field_identifier, int disp_only, HttpServletRequest request, HttpServletResponse response, int)

{

String html;

if (disp_only == 0)

{

html = "<input name='" + field_identifier + "val1'";

html = html + " size=" + getProp(field_identifier, "size", request, response);

html = html + " value='" + sess_var + "'>";

}

else

html = sess_var;

return html;

}

This function creates an <input> tag containing the name, size, and value attributes.

Properties defined in the Properties tab can be assigned to attributes in a tag in the JSP Rendering code. To do this, the property is referenced by the getProp() function call, as seen by the size attribute and its assigned property above in the example code.


Define > Custom Field Type > Custom Field Type Properties

ASP Form Tab

The ASP Form Process code takes what is submitted by the form and returns the session variable with its new value.

The ASP Form Code is Visual Basic code that takes in the field identifier as an argument and returns a new value for the session variable. Below is an example of code that might be entered in the ASP Form tab.

Function CFTFP_My_New_Type(field_identifier)

CFTFP_My_New_Type = Request.QueryString(field_identifier & "val1") & getProp(field_identifier, "add_to_end")

End Function

This function takes the form value and adds the value of the add_to_end property to the end of the session variable.

Properties defined in the Properties tab can be referenced in the ASP Form Processing code. To do this, the property is referenced by the getProp() function call, as seen by the add_to_end property above in the example code.


Define > Custom Field Type > Custom Field Type Properties

ASPX Form Tab

The ASPX Form Process code takes what is submitted by the form and returns the session variable with its new value.

The ASPX Form Code is C# code that takes in the field identifier as an argument and returns a new value for the session variable. This is an example of code that might be entered in the ASPX Form tab.

<script language="c#" runat="server">

String CFTFP_My_New_Type(String field_identifier)

{

String formField = field_identifier + "val1";

String addToEnd = getProp(field_identifier, "add_to_end");

return Request.Params.Get(formField) + addToEnd;

}

</script>

This function takes the form value and adds the value of the add_to_end property to the end of the session variable.

Properties defined in the Properties tab can be referenced in the ASPX Form Processing code. To do this, the property is referenced by the getProp() function call, as seen by the add_to_end property above in the example code.


Define > Custom Field Type > Custom Field Type Properties

JSP Form Tab

The JSP Form Process code takes what is submitted by the form and returns the session variable with its new value.

The JSP Form Code is Java code that takes in the field identifier, HttpServletRequest, and HttpServletResponse as arguments and returns a new value for the session variable. This is an example of code that might be entered in the JSP Form tab.

String CFTFP_My_New_Type(String field_identifier, HttpServletRequest request, HttpServletResponse response)

{

return request.getParameter(field_identifier + "val1") + getProp(field_identifier, "add_to_end", request, response) ;

}

This function takes the form value and adds the value of the add_to_end property to the end of the session variable.

Properties defined in the Properties tab can be referenced in the JSP Form Processing code. To do this, the property is referenced by the getProp() function call, as seen by the add_to_end property above in the example code.


Compile

Compile Menu Overview

The Compile menu is used to compile and test completed pages. There are four options in the Compile menu:

  • Target Environment

  • Compile

  • Simulate

  • Trace Options

  • Assignment Rules

Deploying Applications

Web pages generated by Genesys Agent Scripting require write access to their target directory. When deploying Genesys Agent Scripting applications, make sure that the Web Server has write authority to the target directory.

Deploying Applications Under IIS

Use IIS if you are working with one of the following combinations:

  • ASP or ASP.Net without Async

  • ASP.Net with Async* (see additional step)

For either combination above, complete these steps:

  1. From the Windows Start Menu, go to the Control Panel and select Administrative Tools.

  2. Select Internet Information Services.

  3. In the Internet Information Service window, navigate to the target directory folder under (computer name) > Web Sites > Default Web Site > (target directory).

  4. Genesys Agent Scripting must be deployed as a separate application. To do this:

    1. Right-click the folder and select Properties.

    2. Click the Create button next to the Application name.

ASP.Net with Async*

If you are using ASP.Net with Async, complete these additional steps:

  1. Right-click the Async sub-directory folder and select Properties.

  2. Click the Create button next to the Application name.


Compile

Target Environment

A Target Environment defines the location to which the scripts will be compiled as well as the target language of the scripts. This feature allows you to create multiple target destinations for the compiled code. When you select Target Environment from the Compile menu, the Target Environment List dialog box displays.

The Environment List dialog box includes the following columns, TargetEnv Name, Description, and Code Target. Double-click on a TargetEnv Name in the list to open the Target Environment Properties dialog box for that Target Environment.

In addition:

  • Use the Add button to create a new Target Environment.

  • Use the Edit button to edit a selected Target Environment.

  • Use the Copy button to copy a selected Target Environment.

  • Use the Delete button to delete a selected Target Environment.

Target Environment Properties dialog

This dialog box includes four tabs, General, Advanced, Configuration File, and Default Parameters, which are described below.

General Tab

Fields | Description
TargetEnv Name | The Target Environment Name identifies the target environment to the user.
Description | This field contains a description of the target environment. It is used for informational purposes and is not used elsewhere in the system.
Target Directory | The Target Directory is used to indicate a folder for Genesys Agent Scripting to place the completed generated scripts. This location can be a folder on the machine on which Genesys Agent Scripting is installed or a folder on a network drive. The only restriction is that you must have write access to this location.
Simulate URL | The Simulate URL is the location from where Genesys Agent Scripting will simulate scripts. Genesys Agent Scripting allows you test compiled scripts in a browser. The Simulate URL tells Genesys Agent Scripting how to find the scripts on the Web Server.
Code Target | The Code Target field allows you to select the platform for the application. Currently, Genesys Agent Scripting can produce pages as JSP (Java Server Pages) for running on Java based web platforms or ASP (Active Server Pages) and ASPX (ASP.NET) for running on a web platform such as IIS.

Advanced Tab

Fields

Description

Post Compile Procedure

A post compile procedure allows you to run a batch file as soon as the Genesys Agent Scripting has finished compiling the scripts. Use the Browse button to locate the Post Compile Procedure or enter the full path of the file to be run. An example of a post compile procedure is a script that uploads the compiled scripts to the production web server.

Do Not Overwrite Configuration File

If this box is checked, the Configuration File tab is disabled. It prevents you from assigning values to configuration file fields in the configuration file tab, which will overwrite existing values in the configuration file.

Compile with JMeter Support

If this box is checked, JMeter will be used to build a test script and simulate 1 to many users running the script at one time. This is useful for testing the throughput of a Genesys Agent Scripting application. If this option is selected, the JMeter code will be generated in the script. If it is not selected, the JMeter code will not be generated.

Use Async Framework

This option is only enabled for code targets of ASPX and JSP. If checked, it enables the use of the asynchronous events feature.

Note: You must use Netscape version 6.0 or later when using a Netscape browser to view web pages generated when this option is enabled.

Advanced Java Options

This option is available when you select JSP as the Code Target.

Create Target as a .WAR File

If this box is checked, a .WAR file will be generated in the target directory that can be used for deployment to Application Servers (Tomcat and WebSphere Application Server). The name of the file will be the Project Book name, for example: ProjectBookName.WAR.

Java SDK Directory

If you selected Create Target as a .WAR File, a utility program from the Java SDK is used to create the .WAR file. The path to the Java SDK must be identified in order for this process to work properly. The path can be identified in the following ways:

a. The Browse button allows you to identify the correct directory, otherwise

b. The environment variable called "JAVA_HOME" will be used, otherwise

c. The Java SDK must be in the host machine's path.

Configuration File Tab

Fields | Description
Field Name | A field that has been marked as a configuration file.
Value | The value of the field.

ASP.NET (.NET Server) Target Environment Fields

GAS 7.2 supports Genesys integration with the ASP.NET platform. New configuration fields were added to the Configuration File tab for ASPX target environments (Compile > Target Environment) and these are used instead of the JSP AIL target environment configuration fields:

Existing JSP target environment fields:

  • G_Config_ApplName

  • G_Config_PrimaryHost

  • G_Config_PrimaryPort

  • G_Config_BackupHost

  • G_Config_BackupPort

ASP.NET target environment fields (new for 7.2):

  • G_NETServer_PrimaryHost

  • G_NETServer_PrimaryPort

  • G_NETServer_BackupHost

  • G_NETServer_BackupPort

Notes:

  • Now you can create an ASPX target environment for a Project Book that is created with the Genesys Agent Interaction Toolkit selected as the Base Toolkit.

  • ASPX scripts created with the Genesys Agent Interaction Toolkit selected as the Base Toolkit require Genesys Integration Server version 7.2 or higher in the Genesys environment.

Default Parameters Tab

Fields | Description
Field Name | A field that has been marked as parameters.
Value | The value of the field.


Compile

Compile

After you have created pages and are ready to test them, you must compile. This option takes the pages that you created and produces the Genesys Agent Scripting ASP, ASPX, or JSP code. The Compile option compiles all objects (for example, pages, fields, actions) in the current project book. If there are a large number of pages, this might take some time. In order to save time, the user can choose to compile incremental changes.

Selecting the Compile option opens the Genesys Agent Scripting Compile dialog box. Also, Selecting F5 displays the Compile dialog box.

Use the Target Environment button to select the Target Environment you want to edit. The corresponding drop-down list allows you to select from all defined target environments.

Note: Beginning with release 7.2.0, all options set in the Compile dialog are specific to the Target Environment. When you change the Target Environment, the editor displays the options that are specific to your new choice.

Only Generate Changed Objects

If this option is checked, Genesys Agent Scripting will only compile objects that have been changed since the last compile. This will cut down on compile time for large project books.

Compile Immediately on Open

Checking this option will cause Genesys Agent Scripting to compile the code automatically whenever launched.

Simulate Automatically when Finished Compiling

If this option is checked, the simulation will automatically be launched in a web browser as soon as Genesys Agent Scripting has finished compiling.

Compiling Scripts

This provides a progress bar to indicate the progress of the compile.

Simulate

The Simulate button will launch the simulation as described under the Simulate menu option.

Compile

This option will convert the pages into ASP, ASPX, or JSP code.


Compile

Simulate

After you have finished editing the scripts and compiled them, they are ready to be tested. If the Target Directory and Simulate URL in the Target Environment refer to the same directory, then the scripts will have been compiled to the same directory from which they will be run and may be tested as is. If not, speak to your system administrator.

When you select this option, a browser opens. Selecting Ctrl-F5 will also display the Find screen. The first page that will appear will be a script launch page. It will display a list of possible scripts that can be run, and parameters that have been defined.

Process Flow

Select a script for Genesys Agent Scripting to run. This drop down contains a list of existing scripts as well as a [Default] entry as the first entry in the list. If the [Default] entry is selected, then Genesys Agent Scripting will automatically use the first script/page that is defined in the tree as the starting page when run.

Parameters

All fields defined as parameters will appear on this page. Any field that is defined as a drop-down list or radio button will appear as a drop down list. All other fields will appear as text fields. The user may assign values to these fields before running the Genesys Agent Scripting application in simulation mode.

Display URL

Clicking the Display URL button will cause the starting URL, an example of which is seen below, to appear in the browser window. Starting URL:

http://localhost/WWGDemo/WWGStart.asp?WWGProcessFlowName=&ANI=555-6000&CallID=123456789

Simulate

After you have supplied values for the parameters and selected a process flow, click Simulate. You will be placed in the first page of the script selected in the previous page.

You can navigate through the pages and test them before setting up the Genesys Agent Scripting Application for general use.


Compile

Trace Options

All trace files are for support use only.

Runtime Trace Options

Trace files will be stored in the WebServer's application directory for the Web App.

Trace Level

There are 5 levels supported (0 - 4), which are described below. Each incremental level also traces the data of the previous level(s).

Priority Order | Description
0 - None | No log events are traced.
1 - Errors | The default. Only error conditions are traced.
2 - Warning | Warning messages are traced.
3 - Basic Trace | The normal tracing level, provides information as to code flow, and so on.
4 - Detailed Trace | Shows all possible traces, including input/output data.

Maximum number of Trace Files

Number of Trace Files and Size of Trace files. Allows the amount of trace data to be collected to be modified.

Maximum Size of Trace Files (in KB)

Maximum size of trace files in Kilobytes.

Base Trace Files Name

Allows trace file names to be customized. Default is WWGRT. Default file names will have the form WWGRTxxxxx.log where xxxxx is a sequence number.

Organize Trace Files By...

Allows you to determine how trace files are to be saved. Each user should have their own set of trace files, and the identity of the user can be different depending on the environment. The choices are IP Address, Cookie ID (Genesys Agent Scripting stores a unique cookie ID on each user's machine), and Host name.

Editor Trace Options

Click the Enable Editor Tracing check box if you want to trace operations through the Genesys Agent Scripting editor. When this option is selected, the files are stored in the Genesys Agent Scripting Application directory. Two files are created, WWGEditor.log, and WWGEditor.log.bak. The file WWGEditor.log contains trace messages indicating what forms have been loaded, and which buttons or menu items the user has selected. This is valid for the current or most recent session. There is no limit on size. The file WWGEditor.log.bak contains the data from the previous Editor session.


Compile

Assignment Rules

When you select this option, the Process Flow Assignment Rules dialog box opens which will allow you to define assignment rule expressions for a given Process Flow. This is available only when the Integrate with Genesys Agent Interaction check box is selected.

Assignment Rules are used in conjunction with Project Books that are integrated with the Genesys Agent Interaction Layer. Data associated with the interaction may be used by the Assigner Servlet to determine the correct Process Flow to launch for the interaction.

Deployment Settings Tab

When you select Assignment Rules from the Compile menu, the Deployment Settings tab is the active tab.

This tab allows you to describe some of the operational characteristics of the integration with your custom launching process or Genesys Agent Desktop. The following controls appear on this tab:

Genesys Agent Scripting Assigner Servlet URL

The Assigner Servlet is a Java component that resides on the server for the Genesys Agent Desktop or custom launching process. The Assigner Servlet determines which Project Book and which Process Flow within that Project Book to launch based on the rules that have been deployed to it and the data associated with the interaction. The Genesys Agent Scripting Deployment Guide contains additional details. Specify the Assigner Servlet's location (as a URL), so that Assignment Rules may be added, updated, or removed.

Agent Scripting Project Book URL

This is the deployed location of the Project Book. This is the URL used by the Assigner to launch the selected Process Flow. If this URL is invoked without a specified Process Flow, the default Process Flow for this Project Book will be launched.

To change the value of this field, select a target environment from the Environment drop-down list. The changed value comes from the Target URL field in the Target Environment Properties dialog.

Environment

Select a target environment from this drop-down list box. Your selection affects the value in the Agent Scripting Project Book URL.

Allow Agent to Choose Script to Resume

Selecting this check box indicates that when a previously suspended script is to be resumed, a custom Process Flow will be launched that allows the Agent to select from a list of all associated suspended scripts. If this check box is not selected, then the previously suspended script will be resumed (or a new one launched if it cannot be found).

Remove Rules

Click Remove Rules if you want to remove all association of this Project Book from the Assigner.

Deploy Rules

Click Deploy Rules if you want to add or update the association of this Project Book with the Assigner. This must be used to make the defined assignment rules active.

You will have the opportunity to make this Project Book the default Project Book. The default Project Book is the one that will be used in the event that an interaction is encountered that does not have enough data associated with it to determine the correct Project Book to use. There will always be one and only one default Project Book known to the Assigner Servlet.

Assignment Rules Tab

You can define a set of assignment rules in priority order. Each rule is a set of conditions which must be met for the rule to be true. The structure of the rule expression is ((Rule1) || (Rule2) || (Rule3)). The structure of a rule is (Condition1 && Condition2 && Condition3). This structure is Conjunctive Normal Form. The structure of a condition is Key Name-Operator-Value. You will be able to enter a free form key name.

The following controls appear on the Assignment Rules tab:

Insert Before / Insert After

Use these buttons to create an assignment rule and to specify the rule's order in the sequence of existing assignment rules. For example, click Insert Before to create a new assignment rule before an existing, selected rule (making the new rule higher priority). Click Insert After to create a new assignment rule after an existing, selected rule (making it lower priority).

Clicking either of these buttons opens the Process Flow Assignment Rule dialog box.

Delete

Select an existing assignment rule and click Delete to remove it from the expression.

Edit

Select an existing assignment rule and click Edit to edit the assignment rule definition in the Process Flow Assignment Rule dialog box.

Outbound Server Tab

The Outbound Server tab is used to link Process Flows in Agent Scripting to script objects in the Configuration Server. Once the Process Flow to Script Object link has been created in Configuration Server, these script objects can be associated with Outbound Campaigns and Outbound Calling Lists. The script objects will be used by the Assigner when selecting a Process Flow to launch. The current tenant's name will be displayed when successfully logged in.

In the upper left-hand corner, the name of the tenant currently being associated with the Outbound Table is displayed. When using a new project the tenant name will be empty until you click Synchronize or Change Tenant.

The following controls appear on the Outbound Server tab:

Change Tenant

Click Change Tenant to read all Script objects from the Configuration Server of type Outbound Campaign for a given tenant which applies to this Project Book. Clicking this button opens the Configuration Login dialog box in which you enter the User Name, Password, Application, Host, and SOAP Port to connect to the Configuration Server. After successful connection to the Configuration Server, a dialog box containing the list of valid tenants will be displayed. You can select a tenant from the list.

Add

Click Add to add a Process Flow and description to the Outbound table.

Update

Click Update to edit or update the description of a Process Flow already in the Outbound table.

Remove

Click Remove to mark the selected Process Flow for removal in the Outbound table.

Synchronize

Click Synchronize to apply all Outbound table changes to the Configuration Server. Clicking this button opens the Configuration Login dialog box in which you enter the User Name, Password, Application, Host, and SOAP Port to connect to the Configuration Server. If there is a tenant associated with the Outbound table, which would be displayed in the upper left-hand corner, all operations will be applied to that tenant. Otherwise, after successful connection to the Configuration Server, a dialog box containing the list of valid tenants will be displayed. You then select a tenant to which all operations will be applied.

The Outbound table contains a status column which determines the action to be performed when a Synchronize is issued. If the status column is empty then Configuration Server is up-to-date with the Outbound table. Otherwise, the status column can contain one of the following four values:

Value | Meaning
Add | Will create a script object in Configuration Server. The DBID of the script object will be propagated back to the Outbound table if no error was encountered.
Update | Will update the script object in Configuration Server with the changes made in the Outbound table.
Remove | Will delete the script object from Configuration Server and remove the entry from the Outbound table.
Deleted | The script object in Configuration Server is associated with a Process Flow that is no longer in this Project Book. To remove this entry from the Outbound Table, a Remove should be issued against that entry followed by a Synchronize.

Process Flow Assignment Rule Dialog Box

The following controls appear in the Process Flow Assignment Rule dialog box:

Name

Type a name in the Name box to identify this assignment rule .

Process Flow

Select a Process Flow to which this assignment rule will apply from the Process Flow dropdown list.

Insert Before / Insert After

Use these buttons to define the conditions of the assignment rule and specify the order in which the conditions will be evaluated in the expression. For example, click Insert Before to create a new condition before an existing, selected condition. Click Insert After to create a new condition after an existing, selected condition.

Clicking either of these buttons opens the Process Flow Assignment Condition dialog box.

Delete

Select an existing assignment rule condition and click Delete to remove it from the expression.

Edit

Select an existing assignment rule condition and click Edit to edit the condition definition in the Process Flow Assignment Condition dialog box.

OK

Click OK to complete the definition of this assignment rule and add it to the list of assignment rules. You will return to the Assignment Rules Tab.

Cancel

Click Cancel to cancel the assignment rule definition without saving it to the list of assignment rules. You will return to the Assignment Rules Tab.

Process Flow Assignment Condition Dialog Box

Use this dialog to compare a Genesys field against another field, or a specific value. The details of this comparison (described in bullet points below) will change according to selections that you make for certain fields.

The following controls appear in the Process Flow Assignment Condition dialog box:

Genesys Field (located in the upper left of the dialog box)

This field always appears in this dialog box. Select the appropriate Genesys Field for this condition from the Genesys Field drop-down list.

  • If you select Interaction Attached Data KVPair or Contact Custom Data, the field Key Name appears below this field. Enter the appropriate key name there; the KVPair that has this key will become the left operand in the comparison.

  • If you select a field of the type Agent Skill Level, the field Skill Name appears below. Enter a Skill Level which will become the left operand in the comparison.

Operator (upper left center)

This field always appears in this dialog box. Select the appropriate operator for this condition from the Operator dropdown list. Valid operators are:

Operator | Meaning
> | Greater than
< | Less than
= | Equal to
!= | Not equal to
>= | Greater than or equal to
<= | Less than or equal to
EXIST | The Key or Skill (or for simple fields such as email or telephone, the field itself) is present, regardless of value.
NOT EXIST | The Key or Skill (or simple field) is not present.

Value Type (upper right center)

Select Field or Static from the drop-down list.

• If you select Field, the field Genesys Field appears on the right side of the dialog. Select the appropriate Genesys field from the drop-down list there; it will become the right operand in the comparison.

• If you select Static, the field Value appears on the right side of the dialog. It will become the right operand in the comparison.

Key Name or Skill Name (middle left)

Only one of these two fields appears, depending on your selection in the field Genesys Field. See Genesys Field above for details and instructions.

Genesys Field or Value (top right)

Only one of these two fields appears, depending on your selection in the field Value Type. See Value Type above for details and instructions.

Compare as (lower left)

Use this field to specify how the comparison will be conducted. Select one of these values from the drop-down list:

Selection

Description

Default

If the field type is Integer, then both operands are transformed into an integer and then compared. If the field type is a string, then both operands are transformed into a string and then compared.

Possible operators:

> - left operand is greater than right operand

< - left operand is less than right operand

= - left operand equals right operand

!= - left operand does NOT equal right operand

>= - left operand is greater than or equal to right operand

=< - left operand is less than or equal to right operand

Exist - can be applied only to fields of type KVPair, Contact Custom Data, or Skill Level and when used, the right operand is ignored. This operator checks for existence of the corresponding Key or Skill Name in the left operand field. Transforms are not performed.

Not Exist - works the same as Exist, except that it checks for non-existence of the corresponding Key or Skill Name in the left operand field. Transforms are not performed.

String

The value of each operand is transformed into a string, and the resulting strings are compared. This may produce an unexpected result; for example, if the left operand is 9, right operand is 10, and operator is <, the result of comparison is false (because lexicographically, the string ”9” is greater then the string”10”).

Possible operators are the same as described for Default.

Integer

The value of each operand is transformed to an integer, and the resulting integers are compared. In this case, the example of 9<10 compares numbers (not strings) thus would evaluate to TRUE unless one of the operands cannot be transformed to an integer.

Possible operators are the same as described for Default.

Wildcards expression

You can enter wildcard symbols into the right operand: * (asterisk) represents multiple characters and ? (question mark) represents a single character. For example, *@genesyslab.com or ?jones@genesyslab.com.

Possible operators:

LIKE - the left operand matches the expression in the right operand.

NOT LIKE - the left operand does NOT match the expression in the right operand.

Regular expression

You can enter a regular expression into the right operand. For example, \w*@genesyslab.com.

Possible operators are the same as described for Wildcard expression.

Note: The syntax of regular expressions is compliant with basic regular expressions (BREs) as defined in IEEE POSIX 1003.2 (Section 2.8). See http://www.opengroup.org/onlinepubs/009695399/basedefs/xbd_chap09.html.

OK

Click OK to complete the definition of this condition and add it to the list of conditions for the assignment rule. You will return to the Process Flow Assignment Rule dialog box.

Cancel

Click Cancel to cancel the condition definition without saving it to the list of conditions for the assignment rule. You will return to the Process Flow Assignment Rule dialog box.


Window

Window Menu Overview

The Window menu is used to manage the different windows within Genesys Agent Scripting. There are nine options in the Window menu:

  • Default Setup

  • Open Tools

  • Project Tree

  • Page Tree

  • Field List

  • Action List

  • Genesys Agent Scripting Page Editor

  • Process Flow

  • Stream Flow


Window

Default Setup

Windows within Genesys Agent Scripting can be moved, resized, and closed. The Default Setup menu item allows users to return the windows to their default positions and sizes relative to the main Genesys Agent Scripting window.


Window

Open Tools

The Open Tools menu option allows the user to reopen any window that has been closed. Selecting this menu option will show a list of all seven of the main Genesys Agent Scripting windows. A check next to the window name indicates that it is currently open. Selecting an unchecked window will open the window.


Window

Project Tree

The Project Tree menu option only appears if the window has not been closed. Selecting this menu option will cause the Project Tree window to become the currently active window and cause a check to appear next to it indicating that this window is currently the active window.


Window

Page Tree

The Page Tree menu option only appears if the window has not been closed. Selecting this menu option will cause the Page Tree window to become the currently active window and cause a check to appear next to it indicating that this window is currently the active window.


Window

Field List

This menu option will cause the Field List window to become the currently active window and cause a check to appear next to it indicating that this window is currently the active window.


Window

Action List

The Action List menu option only appears if the window has not been closed. Selecting this menu option will cause the Action List window to become the currently active window and cause a check to appear next to it indicating that this window is currently the active window.


Window

Genesys Agent Scripting Page Editor

The Genesys Agent Scripting Page Editor menu option only appears if the window has not been closed. Selecting this menu option will cause the Genesys Agent Scripting Page Editor window to become the currently active window and cause a check to appear next to it indicating that this window is currently the active window.


Process Flow - Window Menu

Window

Process Flow

The Process Flow menu option only appears if the window has not been closed. Selecting this menu option will cause the Process Flow window to become the currently active window and cause a check to appear next to it indicating that this window is currently the active window.

A process flow diagram shows the collection of streams that comprise that process flow, a default flow, any branches connecting the streams, and any branches connecting to other process flows.

Right-clicking on a process flow diagram brings up a menu containing a subset of the process flow menu items. From this menu, the user can

  • Layout Shapes

  • Print Diagram

  • Insert Stream

See process flow diagram icons and information on using process flow diagrams.


Stream Flow - Window Menu

Window

Stream Flow

The Stream Flow menu option only appears if the window has not been closed. Selecting this menu option will cause the Stream Flow window to become the currently active window and cause a check to appear next to it indicating that this window is currently the active window.

A stream diagram is a lower level diagram that shows the flow from page to page within a stream including all branching conditions within the stream as well as connections to other streams and process flows.

In addition, any actions that occur during page load or unload are indicated by a star as seen in the icon table below.

Right-clicking on a stream flow diagram brings up a menu containing a subset of the stream menu items. From this menu, the user can

  • Layout shapes

  • Print diagram

  • Insert Page

See stream diagram icons and information on using stream diagrams.


Supporting Information

Supporting Information Overview

The following supporting information is provided for convenience:

  • Database Connection Strings

  • Configuration Files

  • Style Sheets and Catalog Elements

  • Troubleshooting

  • Action Code Functions

  • Process Flow Diagrams

  • Stream Diagrams


Supporting Information

Database Connection Strings

This topic provides information on database connection strings for various server types: MS SQL Server, mySQL, Oracle, and IBM DB2.

MS SQL Server 2008

JDBC SQL Server 2008 Runtime Connection

jdbc:sqlserver://hostname:port;user=username;password=password;DatabaseName=database

hostname = Computer name where MS SQLServer is running

port = MS SQLServer Listener Port number (DEFAULT=1433)

database = MS SQLServer database name

username = MS SQLServer user name

password = MS SQLServer password

JDBC SQLServer 2008 Provider

MSSQL2005.jdbc.SQLServerDriver

To use the MSSQL2005.jdbc.SQLServerDriver, you must have the sqljdbc4.jar file in the server’s CLASSPATH. One such spot is in the TOMCAT_HOME/common/lib directory (for Tomcat), or any location that will be accessible to the Java Web Server running the generated Agent Scripting Web application.

MS SQLServer

Development Connection (ODBC)

data source=hostname;Database=dbname;UID=username;Password=password

hostname = Computer name where MS SQLServer is running

dbname = MS SQLServer database name

username = MS SQL server user name

password = MS SQL server password

IIS Provider

SQLOLEDB

System.Data.SqlClient

IIS Runtime Connection

Database=database;UID=username;Password=password
Note: When SQL Server is located on a remote host, use:
Server=server_name;Database=database;UID=username;Password=password;)

database = MS SQLServer database name

username = MS SQLServer user name

password = MS SQLServer password

JDBC SQLServer 2005 Provider

MSSQL2005.jdbc.SQLServerDriver

To use the MSSQL2005.jdbc.SQLServerDriver, you must have the sqljdbc.jar file in the server’s CLASSPATH. One such spot is in the TOMCAT_HOME/common/lib directory (for Tomcat), or any location that will be accessible to the Java Web Server running the generated Agent Scripting Web application.

JDBC SQLServer 2000 Provider

com.microsoft.jdbc.sqlserver.SQLServerDriver

To use the JDBC driver com.microsoft.jdbc.sqlserver.SQLServerDriver, you must have the files mssqlserver.jar, msbase.jar, and msutil.jar in the server’s CLASSPATH. One such spot is in the TOMCAT_HOME/common/lib directory (for Tomcat), or any location that will be accessible to the Java Web Server running the generated Agent Scripting Web application.

JDBC SQLServer 2005 Runtime Connection

jdbc:sqlserver://hostname:port;user=username;password=password;DatabaseName=database

hostname = Computer name where MS SQLServer is running

port = MS SQLServer Listener Port number (DEFAULT=1433)

database = MS SQLServer database name

username = MS SQLServer user name

password = MS SQLServer password

JDBC SQLServer 2000 Runtime Connection

jdbc:microsoft:sqlserver://hostname:port;user=username;password=password;DatabaseName=database

hostname = Computer name where MS SQLServer is running

port = MS SQLServer Listener Port number (DEFAULT=1433)

database = MS SQLServer database name

username = MS SQLServer user name

password = MS SQLServer password

Other Information

Make sure the services are started after installation.

mySQL

Development Connection (ODBC)

DSN=dsn;UID=username;Password=password

dsn = Data source name from ODBC Control panel

username = mySQL server user name

password = mySQL server password

JDBC Provider

com.mysql.jdbc.Driver

JDBC Runtime Connection

jdbc:mysql://hosturl:port/database?user=username&password=password

hosturl = URL of sight where mySQL database is running

port = mySQL Listener Port number (DEFAULT=3306)

database = mySQL database name

username = mySQL user name

password = mySQL password

Oracle

Development Connection (ODBC)

DSN=dsn;UID=username;Password=password

dsn = Data source name from ODBC Control panel

username = Oracle user name

password = Oracle password

IIS Provider

OraOLEDB.Oracle

System.Data.OracleClient

IIS Runtime Connection

Data Source=TNSName;User ID=username;Password=password

TNSName = Oracle database local Service Name as defined in tnsnames.ora configuration file.

username = Oracle user name

password = Oracle password

JDBC Provider

oracle.jdbc.OracleDriver

oracle.jdbc.pool.OracleConnectionCacheImpl for a pooled cached connection

JDBC Runtime Connection

Two possible connection strings:

jdbc:oracle:thin:username/password@hostname:port:sid

username = Oracle user name

password = Oracle password

hostname = Computer name where Oracle is running

port = Oracle Listener Port number (DEFAULT=1521)

sid = Oracle database SID as defined in tnsnames.ora

jdbc:oracle:oci:username/password@TNSName

username = Oracle user name

password = Oracle password

TNSName = Oracle database local Service Name as defined in tnsnames.ora  configuration file.

Other Information

For IIS you must grant read/execute permission on the Oracle home directory to IUSR_xxx where xxx is the machine name.

      1. Log on to Windows as a user with Administrator privileges.

      2. Launch Windows Explorer from the Start Menu and navigate to the ORACLE_HOME directory. This default path is C:\oracle\ora92

      3. Right-click the ORACLE_HOME folder and choose the Properties option from the drop-down list. The Properties window displays.

      4. Click the Security tab on the Properties window.

      5. Click the Authenticated Users item in the Name list (on Windows XP the Name list is called Group or user names).

      6. Clear the Read and Execute box in the Permissions list (on Windows XP the Permissions list is called Permissions for Authenticated Users). This box will be under the Allow column.

      7. Select the Read and Execute box. This is the box you just cleared.

      8. Click the Apply button.

      9. Click the OK button.

      10. Restart your computer.

For JDBC make sure that the classes12.jar file is in the common/lib folder (for Tomcat), or any location that will be accessible to the Java Web Server running the generated Agent Scripting Web application.

IBM DB2

Development Connection (ODBC)

DSN=dsn;UID=username;PWD=password

dsn = Data source name from ODBC Control panel

username = IBM DB2 server user name

password = IBM DB2 server password

IIS Provider

IBMDADB2

IBM.Data.DB2

IIS Runtime Connection for provider IBMDADB2

DSN=database;UID=username;PWD=password

database  =   IBM DB2 database (alias) name

username = IBM DB2Server user name

password = IBM DB2Server user password

IIS Runtime Connection for provider IBM.Data.DB2

Server=server:port;Database=database;UID=username;PWD=password

Server:port = Name of computer running IBM DB2Server:port number (Default port number is 50000)

database = IBM DB2Server database name

username = IBM DB2Server user name

password = IBM DB2Server user password

JDBC Provider

com.ibm.db2.jcc.DB2Driver

JDBC Runtime Connection

jdbc:db2://Server:port/Database:user=User_ID;

password=password;

Server = Computer name where IBM DB2 server is running.

port = IBM DB2 server listener port number (DEFAULT=50000)

database = IBM DB2Server database name

User_ID = IBM DB2Server user name

password = IBM DB2Server password

Other Information

  1. IBM DB2 client is at version 8.1.7 or higher for provider = IBM.Data.DB2.

  2. For JDBC, make sure that the file db2jcc.jar file is in the common/lib folder (for Tomcat), or any location that will be accessible to the Java Web Server running the generated Agent Scripting Web application.


Supporting Information

Configuration Files

The following files can be edited by the user:

  • WWGConfig.xml

  • WWGUDFunctions.asp/WWGUDFunctions.aspx/WWGUDFunctions.jsp

  • WWGXMLPost.inc

WWGConfig.xml

This is a configuration file for the Genesys Agent Scripting application. This file contains all Genesys Agent Scripting fields that have been declared configuration file fields and their values. When a Genesys Agent Scripting application is started, it accesses this file and reads in the values.

Below is an example of the format of the file:

<WWGConfig>

  <XMLServerURL>http://localhost/WWGDemo/Server/</XMLServerURL>

</WWGConfig>

XMLServerURL is a Genesys Agent Scripting configuration field and http://localhost/WWGDemo/Server/ is the value stored in that field.

The fields Server URL and DTD URL in the XML Interface Settings window are configuration fields.

WWGUDFunctions.asp/WWGUDFunctions.aspx/WWGUDFunctions.jsp

User Defined Functions are used to customize actions in Genesys Agent Scripting. The User Defined Functions are written in Visual Basic for ASP in a file called WWGUDFunctions.asp. For ASPX, the functions are written in C-Sharp in a file called WWGUDFunctions.aspx. For JSP, the functions are written in Java in a file called WWGUDFunctions.jsp.

Here is an example function written in Visual Basic.

<%

'--------------------------------------------------------------------------

' WWGUDFunctions.asp

' Written By:

' Date:

' Description: Use these functions to customize WWG Actions. Any

' Functions added here should be listed in the WWG

' UDFunctions Database table.

'--------------------------------------------------------------------------

'--------------------------------------------------------------------------

' Use Luhn calculation to verify credit card number

'--------------------------------------------------------------------------

FUNCTION verifyCreditCard(ccNum)

ccCheckSum = 0

ccDigitCnt = 0

ccDigitSum = 0

ccValid = ""

FOR idx = LEN(ccNum) TO 1 STEP -1

ccDigitCnt = ccDigitCnt + 1

ccDigit = CINT( mid(ccNum, idx, 1) )

ccDigitSum = ccDigitSum + ccDigit

IF ccDigitCnt MOD 2 = 0 THEN

ccDigit = ccDigit * 2

END IF

FOR idx2 = 1 TO LEN(ccDigit)

ccCheckSum = ccCheckSum + MID( CSTR(ccDigit), idx2, 1)

NEXT

NEXT

IF ccCheckSum MOD 10 = 0 THEN

IF LEN(ccNum) > 10 AND ccDigit > 0 THEN

verifyCreditCard = "1"

ELSE

verifyCreditCard = "0"

END IF

ELSE

verifyCreditCard = "0"

END IF

END FUNCTION

%>

WWGXMLPost.inc (XML Interface Pre/Post Processing)

Preprocessing will execute the functions and make any changes to the XML before the request is sent to the XML Server. Postprocessing takes the response sent back from the server and executes the function against that information. The following two functions are provided for the Preprocessing and Postprocessing:

XMLGlobalPreProcess

XMLGlobalPostProcess

These functions exist in the following Genesys Agent Scripting installation files for the various platforms:

Platform | Installation File
ASP | Script asp Web Folder\WWGXMLPost.inc
JSP | Script jsp Web Folder\WWGXMLPost.inc
ASPX | Script aspx Web Folder\WWGXMLPostInc.aspx

Once you compile your Project Book and deploy it to a target folder, you can modify the file from the target folder. Future compiles will not overlay any changes you made to the file in the target folder.

XMLGlobalPreProcess

The function XMLGlobalPreProcess takes as input the following parameters:

parmxml - The XML string to be sent to the XML Server

parmtargeturl - The URL string for the targeted XML Server (ASP only)

parmnodename - The top node name of the XML string (ASP only)

Note: ASP takes as input all three parameters, JSP and ASPX take as input only the first parameter.

The returned value from the function will be sent to the XML Server. The user can update this function to modify the XML string. The following is an example of this function modified for ASP:

Function XMLGlobalPreProcess(parmxml, parmtargeturl, parmnodename)

If parmtageturl = ”http://MyServer/MyWebApp/MyXMLServer.asp” Then

       parmxml = rep(parmxml, ”system”, ”matrix”)

     End If

     XMLGlobalPreProcess = parmxml

End Function

Thus, before an XML Server is called, this function will take the XML stream and replace the word "system" with "matrix" if the target XML Server is ”http://MyServer/MyWebApp/MyXMLServer.asp”. The resulting XML stream is returned and the targeted XML Server is called with the modified XML stream.

XMLGlobalPostProcess

The function XMLGlobalPostProcess takes as input the following parameters:

parmxml - The XML string that was returned from the XML Server

parmtargeturl - The URL string for the targeted XML Server (ASP only)

parmnodename - The top node name of the XML string that was sent to the XML Server (ASP only)

Note: ASP takes as input all three parameters, JSP and ASPX take as input only the first parameter.

The returned value from the function will be processed by Agent Scripting, mapping XML tags to their associated fields. The user can update this function to modify the returned XML string. The following is an example of this function modified for ASP:

Function XMLGlobalPostProcess(parmxml, parmtargeturl, parmnodename)

 If parmtageturl = ”http://MyServer/MyWebApp/MyXMLServer.asp” And

parmnodename = "MatrixTest" Then

         parmxml = rep(parmxml, ”system”, ”matrix”)

     End If

     XMLGlobalPreProcess = parmxml

End Function

Thus, before Agent Scripting maps the returned XML stream from the XML Server to associated fields, this function will take the XML stream and replace the word "system" with "matrix" if the XML Server was "http://MyServer/MyWebApp/MyXMLServer.asp” and the top XML node name that was specified on the XML stream to the XML Server was ”MatrixTest”.


Supporting Information

Style Sheets and Catalog Elements

In a style sheet, you can set the style of all elements of a certain type by using the element’s HTML TAG. For example, the user can put a TD section in the style sheet and affect all table columns on a page, or A to affect all anchors. The user can tailor this even more by giving individual elements classes. This allows you to set style using the tag, or for specific elements override the style by providing class specific style information. Some elements have sub styles that describe how the element appears in different situations. An A tag for example has Hover to cover when the mouse is over the element, and Visited to describe how it should appear after it has been visited.

In order to maximize the flexibility of the look and feel of the catalog each element in the catalog has a class name. Following is the list of elements and their class names:

HTML Tag Type | Class Name | Description
TD | WWGCatalogLinkTitle | Optional Current Links Title
TD | WWGCatalogProcessFlowTitle | Non-tree format catalog Process Flow Title
TD | WWGCatalogStreamTitle | Non-tree format catalog Stream Title
TD | WWGCatalogOtherTitle | Optional Other Links Title
A | WWGCatalogCurrentLink | Optional Current Links Anchor
A | WWGCatalogProcessFlow | Tree format Process Flow Anchor
A | WWGCatalogStream | Tree format Stream Anchor
A | WWGCatalogPage | Tree and non-tree format Page Anchor
A | WWGCatalogOtherLink | Optional Other Links Anchor

Here is an excerpt of a style sheet with some of these items set:

A.WWGCatalogOtherLink:hover

{

            color:#CC0000;

            text-decoration:none;

}

TD.WWGCatalogLinkTitle

{

            color:    red;

            font:      bold;

}

TD.WWGCatalogProcessFlowTitle

{

            color:    green;

            font:      bold;

}


Supporting Information

Troubleshooting

Permissions

Genesys Agent Scripting applications need write permissions on the target directory. The user that needs this write permission is the user-id (usually everyone) the web server is running as. If it is determined that the problems are due to permission issues, there is a command that can be run that will recursively verify that everyone has full permissions to the required directory. It is

cacls c:\inetpub\wwwroot /t /e /g Everyone:F

The above example is for a system running IIS locally. For users running other systems, replace c:\inetpub\wwwroot with the location in which the web server is running

This allows local users, not remote users, to have read/write access.

In a production environment, security issues may preclude having the permissions set in this manner; however this command is useful in troubleshooting issues that might be related to permissions and want to verify that the permissions are set up to allow full access.


Supporting Information

Action Code Functions

The following functions have been provided as cross-platform functions that can be used in action code.

Function Name | Function Returns | Parameters
Mid | A substring | String, start position, end position
inStrRev | The index of a string within a string searching from the end | start position, String1, String2
inStr | The index of a string within a string searching from the start | start position, String1, String2
LEN | The length of a string | String


Supporting Information > Process Flow Diagram

Process Flow Diagram Overview

This section introduces the process flow diagrams.

  • Icons

  • Using the Process Flow Diagrams

Right-clicking a process flow diagram brings up a menu containing a subset of the process flow menu items. From this menu, the user can

  • Layout Shapes

  • Print Diagram

  • Insert Stream

See process flow diagram icons and information on using process flow diagrams.


Supporting Information > Process Flow Diagram

Process Flow Diagram Icons

Below is a table outlining the icons that can appear in a process flow diagram and what they represent.

Icon | Description
 | This icon indicates the start of a process flow.
 | This icon indicates the default path from one stream to the next.
 | This is the stream icon. The stream name will appear in the center of the icon. There are three places on a stream in which the path can flow. The path flows in from the left side of a stream and either out the bottom of the stream, indicating that there is a branch that occurs somewhere in the stream or out the right hand side of the stream indicating that it is moving on to the next item in the flow.
 | Paths that are not part of the default flow are indicated by a blue arrow.
 | This icon indicates that there is an error in the flow such as an invalid branching condition.
 | Paths containing errors such as invalid branches are drawn in red.
 | This icon indicates that the flow branches to a stream that is not part of the current process flow.
 | This icon indicates the end of a process flow.

Within a process flow diagram, the user can drag and drop the various icons shown above. Moving an icon will not cause it the connectors to detach.

If an object that connects two other objects is deleted from the diagram, the path will reconnect itself, linking the objects on either side of the deleted object together.


Supporting Information > Process Flow Diagram

Using Process Flow Diagrams

Within a process flow diagram, the user can drag and drop the various process flow diagram icons. Moving an icon will not cause it the connectors to detach.

If an object that connects two other objects is deleted from the diagram, the path will reconnect itself, linking the objects on either side of the deleted object together.

The following diagram shows a sample process flow diagram.


Layout Shapes - Process Flow Diagram

Supporting Information > Process Flow Diagram

Layout Shapes

When selected, this option lines up the shapes in the process flow diagram.


Print Diagram - Process Flow Diagram

Supporting Information > Process Flow Diagram

Print Diagram

When selected, this option sends a copy of the process flow diagram to the printer.


Insert Stream - Process Flow Diagram

Supporting Information > Process Flow Diagram

Insert Stream

The Insert Stream option allows the user to add streams to the selected process flow. Selecting the Insert Stream option opens the Stream List dialog box. Inserting a stream from the diagram menu will provide the user with a choice in placement. The default placement is to place a stream at the end of a process flow.

If a stream, including its branches, is selected in the diagram, the user can choose to place the inserted stream before the selected one. A confirmation message appears.

  • Click Yes to place the inserted stream before the selected one.

  • Click No to place the stream at the end of the process flow.

If a default path arrow is selected in the diagram, the inserted stream will be placed between the two streams connected by the selected arrow.


Supporting Information > Stream Diagram

Stream Diagram Overview

This section introduces the stream diagrams.

  • Icons

  • Using Stream Diagrams

Right-clicking on a stream flow diagram brings up a menu containing a subset of the stream menu items. From this menu, the user can

  • Layout shapes

  • Print diagram

  • Insert Page

See stream diagram icons and information on using stream diagrams.


Supporting Information > Stream Diagram

Stream Diagram Icons

Below is a table outlining the icons that can appear in a stream diagram and what they represent.

Icon | Description
 | This icon indicates the start of a stream flow.
 | This icon indicates the default path from one page to the next.
 | This is the default page icon. The default path flow in the left side of the icon and out the right. Branches may occur during page load, if action occurs while the user is viewing the page, or during page unload. The branches would be linked to the bottom of the corresponding section of the page.
 | The yellow star in the upper left corner of this page icon indicates that an action occurs when the page is loaded.
 | The yellow star in the upper left and lower right corners of this page icon indicate that actions occur when the page is loaded and unloaded.
 | The yellow star in the lower right corner of this page icon indicates that an action occurs when the page is unloaded.
 | Paths that are not part of the default flow are indicated by a blue arrow.
 | This icon indicates a branch. The branching logic is noted inside the icon. The default path continues out of the right corner and the branching path is indicated by a blue arrow out of the bottom of the icon.
 | The icon indicates a branch with return. The default path continues out of the top right corner and the branching path is indicated by a double blue arrow out of the bottom of the icon, indicating the return to the branch. The arrow leaving the lower right corner indicates where the branch is going after the return.
 | This icon indicates that the flow branches to a page that is not part of the current stream flow.
 | This icon indicates that there is an error in the flow such as an invalid branching condition.
 | Paths containing errors such as invalid branches are drawn in red.
 | This icon indicates the end of a stream flow.
 | This icon indicates that the current flow has ended and continues in the next stream. The stream name will appear in the center of the icon.


Supporting Information > Stream Diagram

Using Stream Diagrams

Within a stream flow diagram, the user can drag and drop the various stream diagram icons. Moving an icon will not cause it the connectors to detach.

If an object that connects two other objects is deleted from the diagram, the path will reconnect itself, linking the objects on either side of the deleted object together.

The following diagram shows a portion of a sample stream diagram containing several pages and branching logic.


Layout Shapes - Stream Diagram

Supporting Information > Stream Diagram

Layout Shapes

When selected, this option lines up the shapes in the stream diagram.


Print Diagram - Stream Diagram

Supporting Information > Stream Diagram

Print Diagram

When selected, this option sends a copy of the stream diagram to the printer.


Insert Page - Stream Diagram

Supporting Information > Stream Diagram

Insert Page

The Insert Page option allows the user to add pages to the selected stream. Selecting the Insert Page option opens the Page List dialog box. Inserting a page from the diagram menu will provide the user with a choice in placement. The default placement is to place a page at the end of the stream

If a page, including its branches, is selected in the diagram, the user can choose to place the inserted page before the selected one. A confirmation message appears.

  • Click Yes to place the inserted page before the selected one.

  • Click No to place the page at the end of the stream.

If a default path arrow is selected in the diagram, the inserted page will be placed between the two pages connected by the selected arrow.


Glossary of Key Terms

Glossary of Key Terms

The following key terms are defined in this glossary:

  • Action List

  • Branch

  • Catalog

  • Context

  • Database

  • Diagrams

  • Field List

  • Field Group

  • Menus

  • Page

  • Page Editor

  • Page Layout

  • Page Tree

  • Process Flow

  • Project

  • Project Book

  • Project Tree

  • Stream

  • Template


Action List - Glossary

Glossary of Key Terms

Action List

The Action List shows all the defined actions and appears on the lower-right of the main Genesys Agent Scripting window in the default view.

Type

The Type drop-down list lets you select which types of actions to display in the Action List.

Add to Page

The Add to Page button is used to add a previously-defined action to the current page. While working on a page in the Page Editor, select an action in the Action List and click Add to Page to add the action to the page.

Edit Action

To display the properties panel for an action double-click on the action from the Action List.


Branching Overview - Glossary

Glossary of Key Terms > Branching

Branching Overview

Branches are ways to navigate from one page to the next. There are four types of branches: page level branches, stream level branches, process flow level branches, and branches with return.

A page level branch is a branch associated with any instance of a page. If the user copies the page and drops it somewhere, the branches are also copied to the new location.

A stream level branch is a branch associated with a page in the context of a stream. If the user is copying a page by itself, stream level branches will not be copied along with the page. If the user copies an entire stream, the stream level branches for a page within that stream will be copied.

A process flow level branch is a branch associated with a page and stream in the context of a specific flow. It is never copied along with pages or streams.

Upon hitting a return point, the branch will return to the page specified by the user. Page Level, Stream Level, and Flow Level branches may all be branches with return. The Branch with Return branches to the specified process flow, stream, and page location and continues processing in the context of that new location until it hits a return. At that point, the context is shifted back to the process flow, stream, page where the Branch with Return occurred. The system will then branch to the location specified in the ’on return branch to’ part of the branch specification.

The Branch menu is used to modify branching conditions. It can be accessed by right clicking a branching condition in the Page Tree. There are three options in the branch menu:

  • Insert Branch

  • Edit Branch

  • Delete Branch


Glossary of Key Terms > Branching

Edit Branch

The Edit Branch menu option is the second item in the Branch menu, obtained by right-clicking a branching condition in the Page Tree. This item allows the user to edit an existing branch. Selecting the Edit Branch option causes the Branch Condition window to appear.

Edit any of the fields or change selection status of check boxes as desired.


Glossary of Key Terms > Branching

Delete Branch

The Delete Branch menu option is the last item in the Branch menu, obtained by right-clicking a branching condition in the Page Tree. This option allows the user to delete the selected branch.


Catalog - Glossary

Glossary of Key Terms

Catalog

A Catalog is where the page navigation information is stored.

See Catalogs Overview or Catalog Properties for more information.


Context - Glossary

Glossary of Key Terms

Context

A context associates every page, stream, and process flow in use with the next higher-level entity (page to stream, stream to process flow, process flow to project).


Database - Glossary

Glossary of Key Terms

Database

The database is the file that contains the data upon which scripts act when executed. You can access multiple databases when scripts are executed. These databases are the ones referenced in Define > Databases and Define > Database Interfaces.

The term database is also used to refer to a Project Book.


Diagrams - Glossary

Glossary of Key Terms

Diagrams

Diagrams provide a way to visualize a call flow. There are two types of diagrams:

  • Process Flow Diagram

  • Stream Diagram

Note: You must have Microsoft Visio 2003 Professional installed on the same system as the Genesys Agent Scripting application in order to use diagrams.


Field List - Glossary

Glossary of Key Terms

Field List

The Field List shows all the defined fields and appears on the upper-right of the main Genesys Agent Scripting window in the default view.

Type

The Type drop-down list lets you select which types of fields to display in the Field List.

Field Group

The Field Group drop-down list lets you select a Group. When you select a group, all of the fields associated with that group display.

Add to Page

The Add to Page button is used to add a previously-defined field to the current page. While working on a page in the Page Editor, select a field in the Field List and click Add to Page to add the field to the page.

Edit Field

To display the properties panel for a field double-click on the field from the Field List.


Glossary of Key Terms

Menus

Genesys Agent Scripting menus organize all the features and functionality of the software.

The following menus are available in Genesys Agent Scripting:

  • File

  • Edit

  • Project

  • Process Flow

  • Stream

  • Page

  • (Page Layout)

  • Diagrams (if Visio 2003 is installed)

  • Format

  • Define

  • Compile

  • Window

  • Help—for product information and this Help file.

Many of the options available from menus are also available through pop-up menus. Simply right mouse click an item to display its pop-up menu.


Page - Glossary

Glossary of Key Terms

Page

A page is the actual web page that appears on the agent desktop in a web browser. It contains all of the text, fields, action buttons, and interfaces displayed, in addition to the relevant page load and page unload actions and branching conditions.


Page Editor - Glossary

Glossary of Key Terms

Page Editor

The Page Editor is the main work area in Genesys Agent Scripting where you create the pages for your application. It appears in the center of the main Genesys Agent Scripting window in the default view.

The Page Editor contains the actual script page and the Process Flow diagrams and Stream diagrams provide a visual link to following the call flows.


Page Layout - Glossary

Glossary of Key Terms

Page Layout

A Page Layout allows the user to define a look and feel for compiled pages, including dynamic information such as fields, actions, and the catalog. A default layout is used when there is no specific page layout selected for a page in the page editor.


Page Tree - Glossary

Glossary of Key Terms

Page Tree

The Page Tree shows a hierarchical list of all the defined pages and branching conditions contained within the current project book. It appears on the lower-left of the main Genesys Agent Scripting window in the default view.


Process Flow - Glossary

Glossary of Key Terms

Process Flow

A process flow is a collection of streams in a default order that represents the default path a call will follow.


Glossary of Key Terms

Project

A project is a collection of process flows.


Project Book - Glossary

Glossary of Key Terms

Project Book

A Project Book is another name for the Genesys Agent Scripting database comprised of objects such as projects, process flows, streams, pages, fields, actions, and interfaces.


Project Tree - Glossary

Glossary of Key Terms

Project Tree

The Project Tree shows a hierarchical list of all the defined projects, process flows, and streams contained within the current project book. It appears on the upper-left of the main Genesys Agent Scripting window in the default view.


Stream - Glossary

Glossary of Key Terms

Stream

A stream is a collection of pages with a logical flow. Branching conditions govern the transition from page to page.


Template - Glossary

Glossary of Key Terms

Template

Templates are useful to set a common look and feel for all script pages. A Template is an html file that is imported into Genesys Agent Scripting. The HTML file can be set up to have the basic formatting the user wants to have on each page.